#include <iomanip>
#include <iostream>

#include "MCS_Date.h"
#include "MCS_Debug.h"
#include "MCS_MATLAB_Engine.h"
#include "MCS_Vector.h"

#include "MCS_SSMIMap.h"
#include "MCS_TMIMap.h"

#include "MCS_MATLAB_Engine.h"

using namespace mcs;
using namespace sat;
using namespace std;

//typedef 	Dataset<SSMI,ssmi::Level2<ssmi::Vapor>,ssmi::v5>	DatasetType;

typedef 	Dataset<TMI,tmi::Level2<tmi::Cloud>,tmi::v2>		CloudDatasetType;
typedef 	Dataset<TMI,tmi::Level2<tmi::Rain>,tmi::v2>			RainDatasetType;
typedef 	Dataset<TMI,tmi::Level2<tmi::SST>,tmi::v2>			SSTDatasetType;
typedef 	Dataset<TMI,tmi::Level2<tmi::Vapor>,tmi::v2>		VaporDatasetType;
typedef 	Dataset<TMI,tmi::Level2<tmi::Wind_11GHz>,tmi::v2>	Wind11GHzDatasetType;
typedef 	Dataset<TMI,tmi::Level2<tmi::Wind_37GHz>,tmi::v2>	Wind37GHzDatasetType;

int main()
{
	MATLAB_Engine	engine;
	
	SatelliteID		satID("TRMM");
	
	const Date	startdate(1999,1,1),
				enddate(1999,1,31);
	
	MapIterator<CloudDatasetType>::iterator 	cit=MapIterator<CloudDatasetType>(satID).date(startdate),
												cend=MapIterator<CloudDatasetType>(satID).date(enddate);	
	MapIterator<RainDatasetType>::iterator 		rit=MapIterator<RainDatasetType>(satID).date(startdate);		
	MapIterator<SSTDatasetType>::iterator 		sit=MapIterator<SSTDatasetType>(satID).date(startdate);	
	MapIterator<Wind11GHzDatasetType>::iterator w11it=MapIterator<Wind11GHzDatasetType>(satID).date(startdate);	
	MapIterator<Wind37GHzDatasetType>::iterator w37it=MapIterator<Wind37GHzDatasetType>(satID).date(startdate);	
	MapIterator<VaporDatasetType>::iterator 	vit=MapIterator<VaporDatasetType>(satID).date(startdate);		
	
	for (;cit!=cend;++cit,++rit,++sit,++w11it,++w37it,++vit)
	{
		try
		{
			cout << cit->range() << endl;
			cout << rit->range() << endl;
			cout << sit->range() << endl;
			cout << w11it->range() << endl;
			cout << w37it->range() << endl;
			cout << vit->range() << endl;
		}
		catch (Exception& ex)
		{
			cerr << endl << ex.message() << endl; 
		}
		/*
		engine.putMatrix("cloud",*cit);
		engine.evaluate("figure(1);imagesc(flipud(cloud'));colormap(ssmi_colormap);colorbar;");	
		engine.putMatrix("rain",*rit);
		engine.evaluate("figure(2);imagesc(flipud(rain'));colormap(ssmi_colormap);colorbar;");	
		engine.putMatrix("SST",*sit);
		engine.evaluate("figure(3);imagesc(flipud(SST'));colormap(ssmi_colormap);colorbar;");	
		engine.putMatrix("wind11",*w11it);
		engine.evaluate("figure(4);imagesc(flipud(wind11'));colormap(ssmi_colormap);colorbar;");	
		engine.putMatrix("wind37",*w37it);
		engine.evaluate("figure(5);imagesc(flipud(wind37'));colormap(ssmi_colormap);colorbar;");	
		engine.putMatrix("vapor",*vit);
		engine.evaluate("figure(6);imagesc(flipud(vapor'));colormap(ssmi_colormap);colorbar;");	
		*/
	}

	return 0;
}
