#include <fstream>
#include <string>

#include "MCS_Date.h"
#include "MCS_GeographicCoordinates.h"

int main(int argc,char* argv[])
{
	using namespace mcs;			
	using namespace mcs::geography;
	
	if (argc != 3)
	{
		std::cout << "Usage: get_coords timefile posfile" << std::endl;
		return -1;
	}
	
	//std::string	directory = "\\\\Micron-p266c\\E\\MOSS5\\",
	//			timefile = "time913043_D",
	//			posfile = "position_913043_D.dat";
	
	std::string	directory = "\\\\Micron-p266c\\E\\MOSS5\\",
				timefile(argv[1]),
				posfile(argv[2]);
	
	std::ifstream	ifs_t((directory+timefile).c_str(),std::ios::in),
					ifs_p((directory+posfile).c_str(),std::ios::in);
		
	while (!ifs_t.eof())
	{
		Float64	dt93,px,py,pz;
		
		ifs_t >> dt93;
		ifs_p >> px >> py >> pz;
		
		const Inertial<Float64>	pos(px/1000,py/1000,pz/1000);
		
		const Date	ep(Date(1993,1,1).julian()+dt93/Time::secondsInDay());
		
		//std::cout << ep << "\t" << pos << "\t" << pos.toGeodetic(ep) << std::endl;
		std::cout << pos.toGeodetic(ep) << std::endl;
	}
	
	return 0;
}
