#include "MCS_FixedVector.h"
#include "MCS_FixedMatrix.h"

namespace mcs {

// logical operators		
template<class T,Uint8 N> 
inline const typename FixedMatrix<T,N>::Mask operator==(const FixedMatrix<T,N>& lmat,const T& rscal)
{
	typename FixedMatrix<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lmat(i,j) == rscal);
		
	return tmp;
}

template<class T,Uint8 N>  
inline const typename FixedMatrix<T,N>::Mask operator!=(const FixedMatrix<T,N>& lmat,const T& rscal)
{
	typename FixedMatrix<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lmat(i,j) != rscal);
		
	return tmp;
}

template<class T,Uint8 N>  
inline const typename FixedMatrix<T,N>::Mask operator<(const FixedMatrix<T,N>& lmat,const T& rscal)
{
	typename FixedMatrix<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lmat(i,j) < rscal);
		
	return tmp;
}

template<class T,Uint8 N> 
inline const typename FixedMatrix<T,N>::Mask operator<=(const FixedMatrix<T,N>& lmat,const T& rscal)
{
	typename FixedMatrix<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lmat(i,j) <= rscal);
		
	return tmp;
}

template<class T,Uint8 N>  
inline const typename FixedMatrix<T,N>::Mask operator>(const FixedMatrix<T,N>& lmat,const T& rscal)
{
	typename FixedMatrix<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lmat(i,j) > rscal);
		
	return tmp;
}

template<class T,Uint8 N>  
inline const typename FixedMatrix<T,N>::Mask operator>=(const FixedMatrix<T,N>& lmat,const T& rscal)
{
	typename FixedMatrix<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lmat(i,j) >= rscal);
		
	return tmp;
}

template<class T,Uint8 N>  
inline const typename FixedMatrix<T,N>::Mask operator==(const T& lscal,const FixedMatrix<T,N>& rmat)
{
	typename FixedMatrix<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lscal == rmat(i,j));
		
	return tmp;
}

template<class T,Uint8 N>  
inline const typename FixedMatrix<T,N>::Mask operator!=(const T& lscal,const FixedMatrix<T,N>& rmat)
{
	typename FixedMatrix<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lscal != rmat(i,j));
		
	return tmp;
}

template<class T,Uint8 N>  
inline const typename FixedMatrix<T,N>::Mask operator<(const T& lscal,const FixedMatrix<T,N>& rmat)
{
	typename FixedMatrix<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lscal < rmat(i,j));
		
	return tmp;
}

template<class T,Uint8 N>  
inline const typename FixedMatrix<T,N>::Mask operator<=(const T& lscal,const FixedMatrix<T,N>& rmat)
{
	typename FixedMatrix<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lscal <= rmat(i,j));
		
	return tmp;
}

template<class T,Uint8 N>  
inline const typename FixedMatrix<T,N>::Mask operator>(const T& lscal,const FixedMatrix<T,N>& rmat)
{
	typename FixedMatrix<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lscal > rmat(i,j));
		
	return tmp;
}

template<class T,Uint8 N>  
inline const typename FixedMatrix<T,N>::Mask operator>=(const T& lscal,const FixedMatrix<T,N>& rmat)
{
	typename FixedMatrix<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lscal >= rmat(i,j));
		
	return tmp;
}

template<class T,Uint8 N>  
inline const typename FixedMatrix<T,N>::Mask operator==(const FixedMatrix<T,N>& lmat,const FixedMatrix<T,N>& rmat)
{
	typename FixedMatrix<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lmat(i,j) == rmat(i,j));
		
	return tmp;
}

template<class T,Uint8 N>  
inline const typename FixedMatrix<T,N>::Mask operator!=(const FixedMatrix<T,N>& lmat,const FixedMatrix<T,N>& rmat)
{
	typename FixedMatrix<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lmat(i,j) != rmat(i,j));
		
	return tmp;
}

template<class T,Uint8 N>  
inline const typename FixedMatrix<T,N>::Mask operator<(const FixedMatrix<T,N>& lmat,const FixedMatrix<T,N>& rmat)
{
	typename FixedMatrix<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lmat(i,j) < rmat(i,j));
		
	return tmp;
}

template<class T,Uint8 N>  
inline const typename FixedMatrix<T,N>::Mask operator<=(const FixedMatrix<T,N>& lmat,const FixedMatrix<T,N>& rmat)
{
	typename FixedMatrix<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lmat(i,j) <= rmat(i,j));
		
	return tmp;
}

template<class T,Uint8 N>  
inline const typename FixedMatrix<T,N>::Mask operator>(const FixedMatrix<T,N>& lmat,const FixedMatrix<T,N>& rmat)
{
	typename FixedMatrix<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lmat(i,j) > rmat(i,j));
		
	return tmp;
}

template<class T,Uint8 N>  
inline const typename FixedMatrix<T,N>::Mask operator>=(const FixedMatrix<T,N>& lmat,const FixedMatrix<T,N>& rmat)
{
	typename FixedMatrix<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lmat(i,j) >= rmat(i,j));
		
	return tmp;
}

// scalar op Matrix
template<class T,Uint8 N> inline const FixedMatrix<T,N> operator+(const T& lscal,const FixedMatrix<T,N>& rmat)
{
	if (lscal == static_cast<T>(0)) return rmat;
		
	return (FixedMatrix<T,N>(lscal) += rmat);
}

template<class T,Uint8 N> inline const FixedMatrix<T,N> operator-(const T& lscal,const FixedMatrix<T,N>& rmat)
{
	if (lscal == static_cast<T>(0)) return -rmat;
		
	return (FixedMatrix<T,N>(lscal) -= rmat);
}

template<class T,Uint8 N> inline const FixedMatrix<T,N> operator*(const T& lscal,const FixedMatrix<T,N>& rmat)
{
	if (lscal == static_cast<T>(1)) return rmat;
	if (lscal == static_cast<T>(0)) return FixedMatrix<T,N>(static_cast<T>(0));
	
	return (FixedMatrix<T,N>(lscal) *= rmat);
}

template<class T,Uint8 N> inline const FixedMatrix<T,N> operator/(const T& lscal,const FixedMatrix<T,N>& rmat)
{
	if (lscal == static_cast<T>(0)) return rmat;
		
	return (FixedMatrix<T,N>(lscal) /= rmat);
}

// Matrix op scalar
template<class T,Uint8 N> inline const FixedMatrix<T,N> operator+(const FixedMatrix<T,N>& lmat,const T& rscal)
{
	if (rscal == static_cast<T>(0)) return lmat;
		
	return (FixedMatrix<T,N>(lmat) += rscal);
}

template<class T,Uint8 N> inline const FixedMatrix<T,N> operator-(const FixedMatrix<T,N>& lmat,const T& rscal)
{
	if (rscal == static_cast<T>(0)) return lmat;
		
	return (FixedMatrix<T,N>(lmat) -= rscal);
}

template<class T,Uint8 N> inline const FixedMatrix<T,N> operator*(const FixedMatrix<T,N>& lmat,const T& rscal)
{
	if (rscal == static_cast<T>(1)) return lmat;
	if (rscal == static_cast<T>(0)) return FixedMatrix<T,N>(static_cast<T>(0));	

	return (FixedMatrix<T,N>(lmat) *= rscal);
}

template<class T,Uint8 N> inline const FixedMatrix<T,N> operator/(const FixedMatrix<T,N>& lmat,const T& rscal)
{
	if (rscal == static_cast<T>(1)) return lmat;
		
	return (FixedMatrix<T,N>(lmat) /= rscal);
}

// Matrix op Matrix
template<class T,Uint8 N> inline const typename FixedMatrix<T,N>::Mask operator&&(const FixedMatrix<T,N>& lhs,const FixedMatrix<T,N>& rhs)
{
	typename FixedMatrix<T,N>::Mask tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lhs(i,j) && rhs(i,j));
		
	return tmp;
}

template<class T,Uint8 N> inline const typename FixedMatrix<T,N>::Mask operator||(const FixedMatrix<T,N>& lhs,const FixedMatrix<T,N>& rhs)
{
	typename FixedMatrix<T,N>::Mask tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = (lhs(i,j) || rhs(i,j));
		
	return tmp;
}

template<class T,Uint8 N> inline const FixedMatrix<T,N> operator+(const FixedMatrix<T,N>& lhs,const FixedMatrix<T,N>& rhs)
{
	return (FixedMatrix<T,N>(lhs) += rhs);
}

template<class T,Uint8 N> inline const FixedMatrix<T,N> operator-(const FixedMatrix<T,N>& lhs,const FixedMatrix<T,N>& rhs)
{
	return (FixedMatrix<T,N>(lhs) -= rhs);
}

template<class T,Uint8 N> inline const FixedMatrix<T,N> operator*(const FixedMatrix<T,N>& lhs,const FixedMatrix<T,N>& rhs)
{
	return (FixedMatrix<T,N>(lhs) *= rhs);
}

template<class T,Uint8 N> inline const FixedMatrix<T,N> operator/(const FixedMatrix<T,N>& lhs,const FixedMatrix<T,N>& rhs)
{
	return (FixedMatrix<T,N>(lhs) /= rhs);
}

// unary operators
template<class T,Uint8 N> inline const FixedMatrix<T,N> operator+(const FixedMatrix<T,N>& source)
{
	return source;
}

template<class T,Uint8 N> inline const FixedMatrix<T,N> operator-(const FixedMatrix<T,N>& source)
{
	return (FixedMatrix<T,N>(static_cast<T>(0)) -= source);
}

template<class T,Uint8 N> inline const FixedMatrix<T,N> operator!(const FixedMatrix<T,N>& source)
{
	FixedMatrix<T,N> tmp(source);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		for (Int32 j=tmp.first();j<=tmp.last();j++)
			tmp(i,j) = !source(i,j);
		
	return tmp;
}

// matrix-vector multiplication
template<class T,Uint8 N> inline const FixedVector<T,N> operator*(const FixedVector<T,N>& lvec,const FixedMatrix<T,N>& rmat)
{
	FixedVector<T,N>	tmp(T(0));
	
	for (Int32 i=rmat.first();i<=rmat.last();i++)
		for (Int32 j=rmat.first();j<=rmat.last();j++)
			tmp[i] += lvec[i]*rmat(i,j);
			
	return tmp;
}

template<class T,Uint8 N> inline const FixedVector<T,N> operator*(const FixedMatrix<T,N>& lmat,const FixedVector<T,N>& rvec)
{
	FixedVector<T,N>	tmp(T(0));
	
	for (Int32 i=lmat.first();i<=lmat.last();i++)
		for (Int32 j=lmat.first();j<=lmat.last();j++)
			tmp[i] += lmat(i,j)*rvec[j];
			
	return tmp;
}

} // namespace mcs
