template<class T,Uint8 N> const EnsureNumeric<T> FixedVector<T,N>::dummy_;

// constructor
template<class T,Uint8 N> inline FixedVector<T,N>::FixedVector()
{
	set();
}

template<class T,Uint8 N> inline FixedVector<T,N>::FixedVector(const T& val)
{
	set(val);
}

template<class T,Uint8 N> inline FixedVector<T,N>::FixedVector(const T* data)
{
	set(data);
}

template<class T,Uint8 N> inline FixedVector<T,N>::FixedVector(const std::string& str_init)
{	
	set(str_init);
}

template<class T,Uint8 N> inline FixedVector<T,N>::FixedVector(const FixedVector<T,N>& source)
{
	set(source);
}	
	
// destructor
template<class T,Uint8 N> inline FixedVector<T,N>::~FixedVector()
{ }

// assignment
template<class T,Uint8 N> inline FixedVector<T,N>& FixedVector<T,N>::operator=(T val)
{
	 set(val); 
	 return (*this); 
}

template<class T,Uint8 N> inline FixedVector<T,N>& FixedVector<T,N>::operator=(const std::string& str_init)
{ 
	set(str_init); 
	return (*this); 
}

template<class T,Uint8 N> inline FixedVector<T,N>& FixedVector<T,N>::operator=(const FixedVector<T,N>& source)
{
	if (this == &source) return *this;

	set(source);	
	
	return *this;
}		

// element assignors
// initialize with value
template<class T,Uint8 N> inline void FixedVector<T,N>::set()
{ 
	for (Int32 i=first();i<=last();vec_data_[i++] = T()) { };
}

template<class T,Uint8 N> inline void FixedVector<T,N>::set(const T& val)
{ 
	for (Int32 i=first();i<=last();vec_data_[i++] = val) { };
}

// initialize with array
template<class T,Uint8 N> inline void FixedVector<T,N>::set(const T* data)
{ 
	for (Int32 i=first(),j=0;i<=last();vec_data_[i++] = data[j++]) { };
}

template<class T,Uint8 N> inline void FixedVector<T,N>::set(const std::string& str_init)
{	
	std::stringstream	temp(str_init);
	
	for (Int32 i=first();i<=last();i++)
		temp >> vec_data_[i];
}

template<class T,Uint8 N> inline void FixedVector<T,N>::set(const FixedVector<T,N>& source)
{
	for (Int32 i=first();i<=last();vec_data_[i] = source.vec_data_[i],++i) { };
}

// arithmetic operators
// scalar member assign/equals operators
template<class T,Uint8 N> inline FixedVector<T,N>& FixedVector<T,N>::operator+=(T val)
{
	if (val == T(0)) return *this;
		
	for (Int32 i=first();i<=last();i++)
		vec_data_[i] += val;
	
	return *this;
}

template<class T,Uint8 N> inline FixedVector<T,N>& FixedVector<T,N>::operator-=(T val)
{
	if (val == T(0)) return *this;
		
	for (Int32 i=first();i<=last();i++)
		vec_data_[i] -= val;
	
	return *this;
}

template<class T,Uint8 N> inline FixedVector<T,N>& FixedVector<T,N>::operator*=(T val)
{
	if (val == T(1)) return *this;
		
	for (Int32 i=first();i<=last();i++)
		vec_data_[i] *= val;
	
	return *this;
}

template<class T,Uint8 N> inline FixedVector<T,N>& FixedVector<T,N>::operator/=(T val)
{
	if (val == T(1)) return *this;
		
	for (Int32 i=first();i<=last();i++)
		vec_data_[i] /= val;
	
	return *this;
}

// FixedVector member assign/equals operators
template<class T,Uint8 N> inline FixedVector<T,N>& FixedVector<T,N>::operator+=(const FixedVector<T,N>& source)
{
	for (Int32 i=first();i<=last();i++)
		vec_data_[i] += source.vec_data_[i];
		
	return *this;
}

template<class T,Uint8 N> inline FixedVector<T,N>& FixedVector<T,N>::operator-=(const FixedVector<T,N>& source)
{
	for (Int32 i=first();i<=last();i++)
		vec_data_[i] -= source.vec_data_[i];
	
	return *this;
}

template<class T,Uint8 N> inline FixedVector<T,N>& FixedVector<T,N>::operator*=(const FixedVector<T,N>& source)
{
	for (Int32 i=first();i<=last();i++)
		vec_data_[i] *= source.vec_data_[i];
	
	return *this;
}

template<class T,Uint8 N> inline FixedVector<T,N>& FixedVector<T,N>::operator/=(const FixedVector<T,N>& source)
{
	for (Int32 i=first();i<=last();i++)
		vec_data_[i] /= source.vec_data_[i];
	
	return *this;
}
