//template<class T> const EnsureNumeric<T> FixedVector<T,1>::dummy_;

//constructor
template<class T> inline FixedVector<T,1>::FixedVector()
{
	set(T());
}

template<class T> inline FixedVector<T,1>::FixedVector(const T& val)
{
	set(val);
}

template<class T> inline FixedVector<T,1>::FixedVector(const T* data)
{
	set(data);
}

template<class T> inline FixedVector<T,1>::FixedVector(const std::string& str_init)
{	
	set(str_init);
}
	
// copy constructor
template<class T> inline FixedVector<T,1>::FixedVector(const FixedVector<T,1>& source)
{
	set(source[0]);
}

// destructor
template<class T> inline FixedVector<T,1>::~FixedVector()
{ }

// assignment
template<class T> inline FixedVector<T,1>& FixedVector<T,1>::operator=(T val)
{ 
	set(val);
	return (*this);
}

template<class T> inline FixedVector<T,1>& FixedVector<T,1>::operator=(const std::string& str_init)
{ 
	set(str_init); 
	return *this; 
}

template<class T> inline FixedVector<T,1>& FixedVector<T,1>::operator=(const FixedVector<T,1>& source)
{
	if (this == &source) return *this;

	set(source[0]);	
	
	return *this;
}		

// initialize with value
template<class T> inline void FixedVector<T,1>::set(const T& v0)
{ 
	vec_data_[0] = v0;
}

// initialize with array
template<class T> inline void FixedVector<T,1>::set(const T* data)
{ 
	vec_data_[0] = data[0];
}

// initialize with string
template<class T> inline void FixedVector<T,1>::set(const std::string& str_init)
{	
	std::stringstream	temp(str_init);
	
	temp >> vec_data_[0];
}

// arithmetic operators
// scalar member assign/equals operators
template<class T> inline FixedVector<T,1>& FixedVector<T,1>::operator+=(T val)
{
	if (val == T(0)) return *this;
		
	vec_data_[0] += val;
	
	return *this;
}

template<class T> inline FixedVector<T,1>& FixedVector<T,1>::operator-=(T val)
{
	if (val == T(0)) return *this;
		
	vec_data_[0] -= val;
	
	return *this;
}

template<class T> inline FixedVector<T,1>& FixedVector<T,1>::operator*=(T val)
{
	if (val == T(1)) return *this;
		
	vec_data_[0] *= val;
	
	return *this;
}

template<class T> inline FixedVector<T,1>& FixedVector<T,1>::operator/=(T val)
{
	if (val == T(1)) return *this;
		
	vec_data_[0] /= val;
	
	return *this;
}

// FixedVector member assign/equals operators
template<class T> inline FixedVector<T,1>& FixedVector<T,1>::operator+=(const FixedVector<T,1>& source)
{
	vec_data_[0] += source[0];
		
	return *this;
}

template<class T> inline FixedVector<T,1>& FixedVector<T,1>::operator-=(const FixedVector<T,1>& source)
{
	vec_data_[0] -= source[0];
	
	return *this;
}

template<class T> inline FixedVector<T,1>& FixedVector<T,1>::operator*=(const FixedVector<T,1>& source)
{
	vec_data_[0] *= source[0];
	
	return *this;
}

template<class T> inline FixedVector<T,1>& FixedVector<T,1>::operator/=(const FixedVector<T,1>& source)
{
	vec_data_[0] /= source[0];
	
	return *this;
}

