#ifndef MCS_FIXEDVECTOR10_H
#define MCS_FIXEDVECTOR10_H

#include "MCS_FixedVector.h"

namespace mcs {

template<class T> class FixedVector<T,10> 
{
	public:	
		typedef FixedVector<Binary,10>	Mask;
		
		// ctor/dtor		
		FixedVector();
		explicit FixedVector(const T&);
		explicit FixedVector(const T&,const T&,const T&,const T&,const T&,const T&,const T&,const T&,const T&,const T&);
		explicit FixedVector(const T*);
		FixedVector(const std::string&);
		FixedVector(const FixedVector<T,10>&);
		~FixedVector();
		
		// range accessors
				bool isValid() const			{ return true; }
							
				Int32 elem() const				{ return 10; }
				 	
				Int32 first() const				{ return 0; }
				Int32 last() const				{ return 10-1; }
				Int32 dim() const				{ return 10; }	
				Int32 offset() const			{ return 0; }
				
		// assignment
				FixedVector<T,10>& operator=(T);
				FixedVector<T,10>& operator=(const std::string&);
				FixedVector<T,10>& operator=(const FixedVector<T,10>&);
				 
		// element accessors		
				T& 					operator[](const Int32& idx)		{ return vec_data_[idx]; }
		const 	T& 					operator[](const Int32& idx) const	{ return vec_data_[idx]; }
			 	
		// arithmetic operations		
			 	FixedVector<T,10>& 	operator+=(T);		
			 	FixedVector<T,10>& 	operator-=(T);
			 	FixedVector<T,10>& 	operator*=(T);
			 	FixedVector<T,10>& 	operator/=(T);

			 	FixedVector<T,10>& 	operator+=(const FixedVector<T,10>&);
			 	FixedVector<T,10>& 	operator-=(const FixedVector<T,10>&);
			 	FixedVector<T,10>& 	operator*=(const FixedVector<T,10>&);
			 	FixedVector<T,10>& 	operator/=(const FixedVector<T,10>&);
				
	private:
		static const EnsureNumeric<T>	dummy_;
		
		// element assignors			
				void			set();
				void			set(const T&);
				void			set(const T&,const T&,const T&,const T&,const T&,const T&,const T&,const T&,const T&,const T&);
				void			set(const T*);
				void			set(const std::string&);
				void			set(const FixedVector<T,10>& source);	
									
		T		vec_data_[10];
};

// implementation
#include "MCS_FixedVector10.cpp"

} // namespace mcs

#endif // MCS_FIXEDVECTOR10_H
