#ifndef MCS_FIXEDVECTOR1OPERATORS_H
#define MCS_FIXEDVECTOR1OPERATORS_H

#include "MCS_FixedVector1.h"

namespace mcs {

// scalar op Vector
// Vector op Vector
template<class T> inline const typename FixedVector<T,1>::Mask operator&&(const FixedVector<T,1>& lhs,const FixedVector<T,1>& rhs)
{
	typename FixedVector<T,1>::Mask tmp;
	
	tmp[0] = (lhs[0] && rhs[0]);
		
	return tmp;
}

template<class T> inline const typename FixedVector<T,1>::Mask operator||(const FixedVector<T,1>& lhs,const FixedVector<T,1>& rhs)
{
	typename FixedVector<T,1>::Mask tmp;
	
	tmp[0] = (lhs[0] || rhs[0]);
		
	return tmp;
}

// unary operators
template<class T> inline const FixedVector<T,1> operator!(const FixedVector<T,1>& source)
{
	typename FixedVector<T,1> tmp(source);
	
	tmp[0] = !source[0];
		
	return tmp;
}

} // namespace mcs

#endif // MCS_FIXEDVECTOR1OPERATORS_H