template<class T> const EnsureNumeric<T> FixedVector<T,2>::dummy_;

//constructor
template<class T> inline FixedVector<T,2>::FixedVector()
{
	set(T(),T());
}

template<class T> inline FixedVector<T,2>::FixedVector(const T& val)
{
	set(val,val);
}

template<class T> inline FixedVector<T,2>::FixedVector(const T& v0,const T& v1)
{
	set(v0,v1);
}

template<class T> inline FixedVector<T,2>::FixedVector(const T* data)
{
	set(data);
}

template<class T> inline FixedVector<T,2>::FixedVector(const std::string& str_init)
{	
	set(str_init);
}

// copy constructor
template<class T> inline FixedVector<T,2>::FixedVector(const FixedVector<T,2>& source)
{
	set(source[0],source[1]);
}

// destructor
template<class T> inline FixedVector<T,2>::~FixedVector()
{ }

template<class T> inline FixedVector<T,2>& FixedVector<T,2>::operator=(T val)
{ 
	set(val,val); 
	return (*this); 
}

template<class T> inline FixedVector<T,2>& FixedVector<T,2>::operator=(const std::string& str_init)
{ 
	set(str_init); 
	return *this; 
}	

// element assignors
template<class T> inline FixedVector<T,2>& FixedVector<T,2>::operator=(const FixedVector<T,2>& source)
{
	if (this == &source) return *this;

	set(source[0],source[1]);	
	
	return *this;
}		

// initialize with value
template<class T> inline void FixedVector<T,2>::set(const T& val)
{ 
	vec_data_[0] = val;
	vec_data_[1] = val;
}

template<class T> inline void FixedVector<T,2>::set(const T& v0,const T& v1)
{ 
	vec_data_[0] = v0;
	vec_data_[1] = v1;
}

// initialize with array
template<class T> inline void FixedVector<T,2>::set(const T* data)
{ 
	vec_data_[0] = data[0];
	vec_data_[1] = data[1];
}

// initialize with string
template<class T> inline void FixedVector<T,2>::set(const std::string& str_init)
{	
	std::stringstream	temp(str_init);
	
	temp >> vec_data_[0] >> vec_data_[1];
}

// arithmetic operators
// scalar member assign/equals operators
template<class T> inline FixedVector<T,2>& FixedVector<T,2>::operator+=(T val)
{
	if (val == T(0)) return *this;
		
	vec_data_[0] += val;
	vec_data_[1] += val;
	
	return *this;
}

template<class T> inline FixedVector<T,2>& FixedVector<T,2>::operator-=(T val)
{
	if (val == T(0)) return *this;
		
	vec_data_[0] -= val;
	vec_data_[1] -= val;
	
	return *this;
}

template<class T> inline FixedVector<T,2>& FixedVector<T,2>::operator*=(T val)
{
	if (val == T(1)) return *this;
		
	vec_data_[0] *= val;
	vec_data_[1] *= val;
	
	return *this;
}

template<class T> inline FixedVector<T,2>& FixedVector<T,2>::operator/=(T val)
{
	if (val == T(1)) return *this;
		
	vec_data_[0] /= val;
	vec_data_[1] /= val;
	
	return *this;
}

// FixedVector member assign/equals operators
template<class T> inline FixedVector<T,2>& FixedVector<T,2>::operator+=(const FixedVector<T,2>& source)
{
	vec_data_[0] += source[0];
	vec_data_[1] += source[1];
		
	return *this;
}

template<class T> inline FixedVector<T,2>& FixedVector<T,2>::operator-=(const FixedVector<T,2>& source)
{
	vec_data_[0] -= source[0];
	vec_data_[1] -= source[1];
	
	return *this;
}

template<class T> inline FixedVector<T,2>& FixedVector<T,2>::operator*=(const FixedVector<T,2>& source)
{
	vec_data_[0] *= source[0];
	vec_data_[1] *= source[1];
	
	return *this;
}

template<class T> inline FixedVector<T,2>& FixedVector<T,2>::operator/=(const FixedVector<T,2>& source)
{
	vec_data_[0] /= source[0];
	vec_data_[1] /= source[1];
	
	return *this;
}
