#ifndef MCS_FIXEDVECTOR2OPERATORS_H
#define MCS_FIXEDVECTOR2OPERATORS_H

#include "MCS_FixedVector2.h"

namespace mcs {

// scalar op Vector
// Vector op Vector
template<class T> inline const typename FixedVector<T,2>::Mask operator&&(const FixedVector<T,2>& lhs,const FixedVector<T,2>& rhs)
{
	typename FixedVector<T,2>::Mask tmp;
	
	tmp[1] = (lhs[0] && rhs[0]);
	tmp[2] = (lhs[1] && rhs[1]);
		
	return tmp;
}

template<class T> inline const typename FixedVector<T,2>::Mask operator||(const FixedVector<T,2>& lhs,const FixedVector<T,2>& rhs)
{
	typename FixedVector<T,2>::Mask tmp;
	
	tmp[1] = (lhs[0] || rhs[0]);
	tmp[2] = (lhs[1] || rhs[1]);
		
	return tmp;
}

// unary operators
template<class T> inline const FixedVector<T,2> operator!(const FixedVector<T,2>& source)
{
	typename FixedVector<T,2> tmp(source);
	
	tmp[0] = !source[0];
	tmp[1] = !source[1];
		
	return tmp;
}

} // namespace mcs


#endif // MCS_FIXEDVECTOR2OPERATORS_H