template<class T> const EnsureNumeric<T> FixedVector<T,3>::dummy_;

//constructor
template<class T> inline FixedVector<T,3>::FixedVector()
{
	set(T(),T(),T());
}

template<class T> inline FixedVector<T,3>::FixedVector(const T& val)
{
	set(val,val,val);
}

template<class T> inline FixedVector<T,3>::FixedVector(const T& v0,const T& v1,const T& v2)
{
	set(v0,v1,v2);
}

template<class T> inline FixedVector<T,3>::FixedVector(const T* data)
{
	set(data);
}

template<class T> inline FixedVector<T,3>::FixedVector(const std::string& str_init)
{	
	set(str_init);
}

// copy constructor	
template<class T> inline FixedVector<T,3>::FixedVector(const FixedVector<T,3>& source)
{
	set(source[0],source[1],source[2]);
}

// destructor
template<class T> inline FixedVector<T,3>::~FixedVector()
{ }

template<class T> inline FixedVector<T,3>& FixedVector<T,3>::operator=(T val)
{ 
	set(val); 
	return (*this); 
}

template<class T> inline FixedVector<T,3>& FixedVector<T,3>::operator=(const std::string& str_init)
{ 
	set(str_init); 
	return *this; 
}

// element assignors
template<class T> inline FixedVector<T,3>& FixedVector<T,3>::operator=(const FixedVector<T,3>& source)
{
	if (this == &source) return *this;

	set(source[0],source[1],source[2]);	
	
	return *this;
}		

// initialize with value
template<class T> inline void FixedVector<T,3>::set(const T& val)
{ 
	vec_data_[0] = val;
	vec_data_[1] = val;
	vec_data_[2] = val;
}

template<class T> inline void FixedVector<T,3>::set(const T& v0,const T& v1,const T& v2)
{ 
	vec_data_[0] = v0;
	vec_data_[1] = v1;
	vec_data_[2] = v2;
}

// initialize with array
template<class T> inline void FixedVector<T,3>::set(const T* data)
{ 
	vec_data_[0] = data[0];
	vec_data_[1] = data[1];
	vec_data_[2] = data[2];
}

// initialize with string
template<class T> inline void FixedVector<T,3>::set(const std::string& str_init)
{	
	std::stringstream	temp(str_init);
	
	temp >> vec_data_[0] >> vec_data_[1] >> vec_data_[2];
}

// arithmetic operators
// scalar member assign/equals operators
template<class T> inline FixedVector<T,3>& FixedVector<T,3>::operator+=(T val)
{
	if (val == T(0)) return *this;
		
	vec_data_[0] += val;
	vec_data_[1] += val;
	vec_data_[2] += val;
	
	return *this;
}

template<class T> inline FixedVector<T,3>& FixedVector<T,3>::operator-=(T val)
{
	if (val == T(0)) return *this;
		
	vec_data_[0] -= val;
	vec_data_[1] -= val;
	vec_data_[2] -= val;
	
	return *this;
}

template<class T> inline FixedVector<T,3>& FixedVector<T,3>::operator*=(T val)
{
	if (val == T(1)) return *this;
		
	vec_data_[0] *= val;
	vec_data_[1] *= val;
	vec_data_[2] *= val;
	
	return *this;
}

template<class T> inline FixedVector<T,3>& FixedVector<T,3>::operator/=(T val)
{
	if (val == T(1)) return *this;
		
	vec_data_[0] /= val;
	vec_data_[1] /= val;
	vec_data_[2] /= val;
	
	return *this;
}

// FixedVector member assign/equals operators
template<class T> inline FixedVector<T,3>& FixedVector<T,3>::operator+=(const FixedVector<T,3>& source)
{
	vec_data_[0] += source[0];
	vec_data_[1] += source[1];
	vec_data_[2] += source[2];
		
	return *this;
}

template<class T> inline FixedVector<T,3>& FixedVector<T,3>::operator-=(const FixedVector<T,3>& source)
{
	vec_data_[0] -= source[0];
	vec_data_[1] -= source[1];
	vec_data_[2] -= source[2];
	
	return *this;
}

template<class T> inline FixedVector<T,3>& FixedVector<T,3>::operator*=(const FixedVector<T,3>& source)
{
	vec_data_[0] *= source[0];
	vec_data_[1] *= source[1];
	vec_data_[2] *= source[2];
	
	return *this;
}

template<class T> inline FixedVector<T,3>& FixedVector<T,3>::operator/=(const FixedVector<T,3>& source)
{
	vec_data_[0] /= source[0];
	vec_data_[1] /= source[1];
	vec_data_[2] /= source[2];
	
	return *this;
}
