#ifndef MCS_FIXEDVECTOR3OPERATORS_H
#define MCS_FIXEDVECTOR3OPERATORS_H

#include "MCS_FixedVector3.h"

namespace mcs {

// scalar op Vector
// Vector op Vector
template<class T> inline const typename FixedVector<T,3>::Mask operator&&(const FixedVector<T,3>& lhs,const FixedVector<T,3>& rhs)
{
	typename FixedVector<T,3>::Mask tmp;
	
	tmp[0] = (lhs[0] && rhs[0]);
	tmp[1] = (lhs[1] && rhs[1]);
	tmp[2] = (lhs[2] && rhs[2]);
		
	return tmp;
}

template<class T> inline const typename FixedVector<T,3>::Mask operator||(const FixedVector<T,3>& lhs,const FixedVector<T,3>& rhs)
{
	typename FixedVector<T,3>::Mask tmp;
	
	tmp[0] = (lhs[0] || rhs[0]);
	tmp[1] = (lhs[1] || rhs[1]);
	tmp[2] = (lhs[2] || rhs[2]);
		
	return tmp;
}

// unary operators
template<class T> inline const FixedVector<T,3> operator!(const FixedVector<T,3>& source)
{
	typename FixedVector<T,3> tmp(source);
	
	tmp[0] = !source[0];
	tmp[1] = !source[1];
	tmp[2] = !source[2];
		
	return tmp;
}

} // namespace mcs


#endif // MCS_FIXEDVECTOR3OPERATORS_H