#ifndef MCS_FIXEDVECTOR4OPERATORS_H
#define MCS_FIXEDVECTOR4OPERATORS_H

#include "MCS_FixedVector4.h"

namespace mcs {

// scalar op Vector
// Vector op Vector
template<class T> inline const typename FixedVector<T,4>::Mask operator&&(const FixedVector<T,4>& lhs,const FixedVector<T,4>& rhs)
{
	typename FixedVector<T,4>::Mask tmp;
	
	tmp[0] = (lhs[0] && rhs[0]);
	tmp[1] = (lhs[1] && rhs[1]);
	tmp[2] = (lhs[2] && rhs[2]);
	tmp[3] = (lhs[3] && rhs[3]);
		
	return tmp;
}

template<class T> inline const typename FixedVector<T,4>::Mask operator||(const FixedVector<T,4>& lhs,const FixedVector<T,4>& rhs)
{
	typename FixedVector<T,4>::Mask tmp;
	
	tmp[0] = (lhs[0] || rhs[0]);
	tmp[1] = (lhs[1] || rhs[1]);
	tmp[2] = (lhs[2] || rhs[2]);
	tmp[3] = (lhs[3] || rhs[3]);
		
	return tmp;
}

// unary operators
template<class T> inline const FixedVector<T,4> operator!(const FixedVector<T,4>& source)
{
	typename FixedVector<T,4> tmp(source);
	
	tmp[0] = !source[0];
	tmp[1] = !source[1];
	tmp[2] = !source[2];
	tmp[3] = !source[3];
		
	return tmp;
}

} // namespace mcs

#endif // MCS_FIXEDVECTO4ROPERATORS_H