template<class T> const EnsureNumeric<T> FixedVector<T,9>::dummy_;

//constructor
template<class T> inline FixedVector<T,9>::FixedVector()
{
	set(T(),T(),T(),T(),T(),T(),T(),T(),T());
}

template<class T> inline FixedVector<T,9>::FixedVector(const T& val)
{
	set(val,val,val,val,val,val,val,val,val);
}

template<class T> inline FixedVector<T,9>::FixedVector(const T& v0,const T& v1,const T& v2,const T& v3,const T& v4,const T& v5,const T& v6,const T& v7,const T& v8)
{
	set(v0,v1,v2,v3,v4,v5,v6,v7,v8);
}

template<class T> inline FixedVector<T,9>::FixedVector(const T* data)
{
	set(data);
}

template<class T> inline FixedVector<T,9>::FixedVector(const std::string& str_init)
{	
	set(str_init);
}

// copy constructor	
template<class T> inline FixedVector<T,9>::FixedVector(const FixedVector<T,9>& source)
{
	set(source[0],source[1],source[2],source[3],source[4],
		source[5],source[6],source[7],source[8]);	
}

// destructor
template<class T> inline FixedVector<T,9>::~FixedVector()
{ }

template<class T> inline FixedVector<T,9>& FixedVector<T,9>::operator=(T val)
{ 
	set(val); 
	return (*this); 
}

template<class T> inline FixedVector<T,9>& FixedVector<T,9>::operator=(const std::string& str_init)
{ 
	set(str_init); 
	return *this; 
}

// element assignors
template<class T> inline FixedVector<T,9>& FixedVector<T,9>::operator=(const FixedVector<T,9>& source)
{
	if (this == &source) return *this;

	set(source[0],source[1],source[2],source[3],source[4],
		source[5],source[6],source[7],source[8]);	
	
	return *this;
}		

// initialize with value
template<class T> inline void FixedVector<T,9>::set(const T& val)
{ 
	vec_data_[0] = val;
	vec_data_[1] = val;
	vec_data_[2] = val;
	vec_data_[3] = val;
	vec_data_[4] = val;
	vec_data_[5] = val;
	vec_data_[6] = val;
	vec_data_[7] = val;
	vec_data_[8] = val;
}

template<class T> inline void FixedVector<T,9>::set(const T& v0,const T& v1,const T& v2,const T& v3,const T& v4,const T& v5,const T& v6,const T& v7,const T& v8)
{ 
	vec_data_[0] = v0;
	vec_data_[1] = v1;
	vec_data_[2] = v2;
	vec_data_[3] = v3;
	vec_data_[4] = v4;
	vec_data_[5] = v5;
	vec_data_[6] = v6;
	vec_data_[7] = v7;
	vec_data_[8] = v8;
}

// initialize with array
template<class T> inline void FixedVector<T,9>::set(const T* data)
{ 
	vec_data_[0] = data[0];
	vec_data_[1] = data[1];
	vec_data_[2] = data[2];
	vec_data_[3] = data[3];
	vec_data_[4] = data[4];
	vec_data_[5] = data[5];
	vec_data_[6] = data[6];
	vec_data_[7] = data[7];
	vec_data_[8] = data[8];
}

// initialize with string
template<class T> inline void FixedVector<T,9>::set(const std::string& str_init)
{	
	std::stringstream	temp(str_init);
	
	temp >> vec_data_[0] >> vec_data_[1] >> vec_data_[2] >> vec_data_[3] >> vec_data_[4]
		 >> vec_data_[5] >> vec_data_[6] >> vec_data_[7] >> vec_data_[8];
}

// arithmetic operators
// scalar member assign/equals operators
template<class T> inline FixedVector<T,9>& FixedVector<T,9>::operator+=(T val)
{
	if (val == T(0)) return *this;
		
	vec_data_[0] += val;
	vec_data_[1] += val;
	vec_data_[2] += val;
	vec_data_[3] += val;
	vec_data_[4] += val;
	vec_data_[5] += val;
	vec_data_[6] += val;
	vec_data_[7] += val;
	vec_data_[8] += val;
	
	return *this;
}

template<class T> inline FixedVector<T,9>& FixedVector<T,9>::operator-=(T val)
{
	if (val == T(0)) return *this;
		
	vec_data_[0] -= val;
	vec_data_[1] -= val;
	vec_data_[2] -= val;
	vec_data_[3] -= val;
	vec_data_[4] -= val;
	vec_data_[5] -= val;
	vec_data_[6] -= val;
	vec_data_[7] -= val;
	vec_data_[8] -= val;
	
	return *this;
}

template<class T> inline FixedVector<T,9>& FixedVector<T,9>::operator*=(T val)
{
	if (val == T(1)) return *this;
		
	vec_data_[0] *= val;
	vec_data_[1] *= val;
	vec_data_[2] *= val;
	vec_data_[3] *= val;
	vec_data_[4] *= val;
	vec_data_[5] *= val;
	vec_data_[6] *= val;
	vec_data_[7] *= val;
	vec_data_[8] *= val;
	
	return *this;
}

template<class T> inline FixedVector<T,9>& FixedVector<T,9>::operator/=(T val)
{
	if (val == T(1)) return *this;
		
	vec_data_[0] /= val;
	vec_data_[1] /= val;
	vec_data_[2] /= val;
	vec_data_[3] /= val;
	vec_data_[4] /= val;
	vec_data_[5] /= val;
	vec_data_[6] /= val;
	vec_data_[7] /= val;
	vec_data_[8] /= val;
	
	return *this;
}

// FixedVector member assign/equals operators
template<class T> inline FixedVector<T,9>& FixedVector<T,9>::operator+=(const FixedVector<T,9>& source)
{
	vec_data_[0] += source[0];
	vec_data_[1] += source[1];
	vec_data_[2] += source[2];
	vec_data_[3] += source[3];
	vec_data_[4] += source[4];
	vec_data_[5] += source[5];
	vec_data_[6] += source[6];
	vec_data_[7] += source[7];
	vec_data_[8] += source[8];
		
	return *this;
}

template<class T> inline FixedVector<T,9>& FixedVector<T,9>::operator-=(const FixedVector<T,9>& source)
{
	vec_data_[0] -= source[0];
	vec_data_[1] -= source[1];
	vec_data_[2] -= source[2];
	vec_data_[3] -= source[3];
	vec_data_[4] -= source[4];
	vec_data_[5] -= source[5];
	vec_data_[6] -= source[6];
	vec_data_[7] -= source[7];
	vec_data_[8] -= source[8];
	
	return *this;
}

template<class T> inline FixedVector<T,9>& FixedVector<T,9>::operator*=(const FixedVector<T,9>& source)
{
	vec_data_[0] *= source[0];
	vec_data_[1] *= source[1];
	vec_data_[2] *= source[2];
	vec_data_[3] *= source[3];
	vec_data_[4] *= source[4];
	vec_data_[5] *= source[5];
	vec_data_[6] *= source[6];
	vec_data_[7] *= source[7];
	vec_data_[8] *= source[8];
	
	return *this;
}

template<class T> inline FixedVector<T,9>& FixedVector<T,9>::operator/=(const FixedVector<T,9>& source)
{
	vec_data_[0] /= source[0];
	vec_data_[1] /= source[1];
	vec_data_[2] /= source[2];
	vec_data_[3] /= source[3];
	vec_data_[4] /= source[4];
	vec_data_[5] /= source[5];
	vec_data_[6] /= source[6];
	vec_data_[7] /= source[7];
	vec_data_[8] /= source[8];
	
	return *this;
}

