#include "MCS_FixedVectorOperators.h"

namespace mcs {

// logical operations
// Vector op scalar
template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator==(const FixedVector<T,N>& lvec,const T& rscal)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lvec[i] == rscal);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator!=(const FixedVector<T,N>& lvec,const T& rscal)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lvec[i] != rscal);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator<(const FixedVector<T,N>& lvec,const T& rscal)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lvec[i] < rscal);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator<=(const FixedVector<T,N>& lvec,const T& rscal)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lvec[i] <= rscal);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator>(const FixedVector<T,N>& lvec,const T& rscal)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lvec[i] > rscal);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator>=(const FixedVector<T,N>& lvec,const T& rscal)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lvec[i] >= rscal);

	return tmp;	
}

// scalar op Vector
template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator==(const T& lscal,const FixedVector<T,N>& rvec)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lscal == rvec[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator!=(const T& lscal,const FixedVector<T,N>& rvec)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lscal != rvec[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator<(const T& lscal,const FixedVector<T,N>& rvec)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lscal < rvec[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator<=(const T& lscal,const FixedVector<T,N>& rvec)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lscal <= rvec[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator>(const T& lscal,const FixedVector<T,N>& rvec)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lscal > rvec[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator>=(const T& lscal,const FixedVector<T,N>& rvec)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lscal >= rvec[i]);

	return tmp;	
}

// Vector op Vector
template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator==(const FixedVector<T,N>& lvec,const FixedVector<T,N>& rvec)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lvec[i] == rvec[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator!=(const FixedVector<T,N>& lvec,const FixedVector<T,N>& rvec)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lvec[i] != rvec[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator<(const FixedVector<T,N>& lvec,const FixedVector<T,N>& rvec)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lvec[i] < rvec[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator<=(const FixedVector<T,N>& lvec,const FixedVector<T,N>& rvec)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lvec[i] <= rvec[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator>(const FixedVector<T,N>& lvec,const FixedVector<T,N>& rvec)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lvec[i] > rvec[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator>=(const FixedVector<T,N>& lvec,const FixedVector<T,N>& rvec)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lvec[i] >= rvec[i]);

	return tmp;	
}

// arithmetic operators
// scalar op Vector
template<class T,Uint8 N> inline const FixedVector<T,N> operator+(T lscal,const FixedVector<T,N>& rvec)
{
	if (lscal == static_cast<T>(0)) return rvec;
		
	return (FixedVector<T,N>(lscal) += rvec);
}

template<class T,Uint8 N> inline const FixedVector<T,N> operator-(T lscal,const FixedVector<T,N>& rvec)
{
	if (lscal == static_cast<T>(0)) return -rvec;
		
	return (FixedVector<T,N>(lscal) -= rvec);
}

template<class T,Uint8 N> inline const FixedVector<T,N> operator*(T lscal,const FixedVector<T,N>& rvec)
{
	if (lscal == static_cast<T>(1)) return rvec;
	if (lscal == static_cast<T>(0)) return FixedVector<T,N>(static_cast<T>(0));
	
	return (FixedVector<T,N>(lscal) *= rvec);
}

template<class T,Uint8 N> inline const FixedVector<T,N> operator/(T lscal,const FixedVector<T,N>& rvec)
{
	if (lscal == static_cast<T>(0)) return rvec;
		
	return (FixedVector<T,N>(lscal) /= rvec);
}

// Vector op scalar
template<class T,Uint8 N> inline const FixedVector<T,N> operator+(const FixedVector<T,N>& lvec,T rscal)
{
	if (rscal == static_cast<T>(0)) return lvec;
		
	return (FixedVector<T,N>(lvec) += rscal);
}

template<class T,Uint8 N> inline const FixedVector<T,N> operator-(const FixedVector<T,N>& lvec,T rscal)
{
	if (rscal == static_cast<T>(0)) return lvec;
		
	return (FixedVector<T,N>(lvec) -= rscal);
}

template<class T,Uint8 N> inline const FixedVector<T,N> operator*(const FixedVector<T,N>& lvec,T rscal)
{
	if (rscal == static_cast<T>(1)) return lvec;
	if (rscal == static_cast<T>(0)) return FixedVector<T,N>(static_cast<T>(0));	

	return (FixedVector<T,N>(lvec) *= rscal);
}

template<class T,Uint8 N> inline const FixedVector<T,N> operator/(const FixedVector<T,N>& lvec,T rscal)
{
	if (rscal == static_cast<T>(1)) return lvec;
		
	return (FixedVector<T,N>(lvec) /= rscal);
}

// Vector op Vector
template<class T,Uint8 N> inline const typename FixedVector<T,N>::Mask operator&&(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	typename FixedVector<T,N>::Mask tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs[i] && rhs[i]);
		
	return tmp;
}

template<class T,Uint8 N> inline const typename FixedVector<T,N>::Mask operator||(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	typename FixedVector<T,N>::Mask tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs[i] || rhs[i]);
		
	return tmp;
}

template<class T,Uint8 N> inline const FixedVector<T,N> operator+(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) += rhs);
}

template<class T,Uint8 N> inline const FixedVector<T,N> operator-(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) -= rhs);
}

template<class T,Uint8 N> inline const FixedVector<T,N> operator*(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) *= rhs);
}

template<class T,Uint8 N> inline const FixedVector<T,N> operator/(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) /= rhs);
}

// unary operators
template<class T,Uint8 N> inline const FixedVector<T,N> operator+(const FixedVector<T,N>& source)
{
	return source;
}

template<class T,Uint8 N> inline const FixedVector<T,N> operator-(const FixedVector<T,N>& source)
{
	return (FixedVector<T,N>(static_cast<T>(0)) -= source);
}

template<class T,Uint8 N> inline const FixedVector<T,N> operator!(const FixedVector<T,N>& source)
{
	FixedVector<T,N> tmp(source);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = !source[i];
		
	return tmp;
}

} // namespace mcs
