#ifndef MCS_FIXEDVECTOROPERATORS_H
#define MCS_FIXEDVECTOROPERATORS_H

#include "MCS_FixedVector.h"

namespace mcs {

// logical operations		
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator==(const FixedVector<T,N>& lvec,const T& rscal);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator!=(const FixedVector<T,N>& lvec,const T& rscal);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator<(const FixedVector<T,N>& lvec,const T& rscal);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator<=(const FixedVector<T,N>& lvec,const T& rscal);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator>(const FixedVector<T,N>& lvec,const T& rscal);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator>=(const FixedVector<T,N>& lvec,const T& rscal);

template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator==(const T& lscal,const FixedVector<T,N>& rvec);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator!=(const T& lscal,const FixedVector<T,N>& rvec);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator<(const T& lscal,const FixedVector<T,N>& rvec);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator<=(const T& lscal,const FixedVector<T,N>& rvec);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator>(const T& lscal,const FixedVector<T,N>& rvec);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator>=(const T& lscal,const FixedVector<T,N>& rvec);

template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator==(const FixedVector<T,N>& lvec,const FixedVector<T,N>& rvec);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator!=(const FixedVector<T,N>& lvec,const FixedVector<T,N>& rvec);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator<(const FixedVector<T,N>& lvec,const FixedVector<T,N>& rvec);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator<=(const FixedVector<T,N>& lvec,const FixedVector<T,N>& rvec);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator>(const FixedVector<T,N>& lvec,const FixedVector<T,N>& rvec);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator>=(const FixedVector<T,N>& lvec,const FixedVector<T,N>& rvec);

// vector non-member operators
template<class T,Uint8 N> const FixedVector<T,N> operator+(T lscal,const FixedVector<T,N>& rvec);
template<class T,Uint8 N> const FixedVector<T,N> operator-(T lscal,const FixedVector<T,N>& rvec);
template<class T,Uint8 N> const FixedVector<T,N> operator*(T lscal,const FixedVector<T,N>& rvec);
template<class T,Uint8 N> const FixedVector<T,N> operator/(T lscal,const FixedVector<T,N>& rvec);

template<class T,Uint8 N> const FixedVector<T,N> operator+(const FixedVector<T,N>& lvec,T rscal);
template<class T,Uint8 N> const FixedVector<T,N> operator-(const FixedVector<T,N>& lvec,T rscal);
template<class T,Uint8 N> const FixedVector<T,N> operator*(const FixedVector<T,N>& lvec,T rscal);
template<class T,Uint8 N> const FixedVector<T,N> operator/(const FixedVector<T,N>& lvec,T rscal);

template<class T,Uint8 N> const FixedVector<T,N> operator+(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator-(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator*(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator/(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);

template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator&&(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator||(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);

template<class T,Uint8 N> const FixedVector<T,N> operator+(const FixedVector<T,N>& source);
template<class T,Uint8 N> const FixedVector<T,N> operator-(const FixedVector<T,N>& source);

template<class T,Uint8 N> const FixedVector<T,N> operator!(const FixedVector<T,N>& source);

} // namespace mcs

// implementation
#include "MCS_FixedVectorOperators.cpp"

#include "MCS_FixedVector1Operators.h"
#include "MCS_FixedVector2Operators.h"
#include "MCS_FixedVector3Operators.h"
#include "MCS_FixedVector4Operators.h"

#endif // MCS_FIXEDVECTOROPERATORS_H