#ifndef MCS_FIXEDVECTOROPERATORS_H
#define MCS_FIXEDVECTOROPERATORS_H

#include <cmath>
#include <complex>

#include "MCS_FixedVector.h"
#include "MCS_MathExtensions.h"
#include "MCS_Promote.h"

namespace mcs {
/*
// unary operators		
template<class T,Uint8 N> const FixedVector<T,N> operator+(const FixedVector<T,N>& val);
template<class T,Uint8 N> const FixedVector<T,N> operator-(const FixedVector<T,N>& val);
template<class T,Uint8 N> const FixedVector<T,N> operator~(const FixedVector<T,N>& val);
template<class T,Uint8 N> const FixedVector<T,N> operator!(const FixedVector<T,N>& val);

template<class T,Uint8 N> FixedVector<T,N> abs(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> ceil(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> exp(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> fabs(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> floor(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> log(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> log10(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> round(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> sqr(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> sqrt(const FixedVector<T,N>& val);

// trigonometric functions
template<class T,Uint8 N> FixedVector<T,N> acos(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> asin(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> atan(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> cos(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> sin(const FixedVector<T,N>& val); 
template<class T,Uint8 N> FixedVector<T,N> tan(const FixedVector<T,N>& val);

// hyperbolic functions
template<class T,Uint8 N> FixedVector<T,N> acosh(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> asinh(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> atanh(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> cosh(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> sinh(const FixedVector<T,N>& val); 
template<class T,Uint8 N> FixedVector<T,N> tanh(const FixedVector<T,N>& val);
 
// complex vectors
template<class T,Uint8 N> FixedVector<T,N> conj(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<typename DemoteComplex<T>::demote_t,N> imag(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<typename DemoteComplex<T>::demote_t,N> real(const FixedVector<T,N>& val);

// in place
template<class T,Uint8 N> FixedVector<T,N>& Abs(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Ceil(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Exp(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Fabs(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Floor(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Log(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Log10(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Round(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Sqr(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Sqrt(FixedVector<T,N>& val);

// trigonometric functions
template<class T,Uint8 N> FixedVector<T,N>& Acos(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Asin(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Atan(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Cos(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Sin(FixedVector<T,N>& val); 
template<class T,Uint8 N> FixedVector<T,N>& Tan(FixedVector<T,N>& val);

// hyperbolic functions
template<class T,Uint8 N> FixedVector<T,N>& Acosh(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Asinh(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Atanh(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Cosh(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Sinh(FixedVector<T,N>& val); 
template<class T,Uint8 N> FixedVector<T,N>& Tanh(FixedVector<T,N>& val);

// complex
template<class T,Uint8 N> FixedVector<T,N>& Conj(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Imag(FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N>& Real(FixedVector<T,N>& val);

// MCS unary functions
template<class T,Uint8 N> FixedVector<T,N> acosd(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> asind(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> atand(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> cosd(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> sind(const FixedVector<T,N>& val); 
template<class T,Uint8 N> FixedVector<T,N> tand(const FixedVector<T,N>& val);

template<class T,Uint8 N> FixedVector<T,N> acosr(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> asinr(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> atanr(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> cosr(const FixedVector<T,N>& val);
template<class T,Uint8 N> FixedVector<T,N> sinr(const FixedVector<T,N>& val); 
template<class T,Uint8 N> FixedVector<T,N> tanr(const FixedVector<T,N>& val);

template<class T,Uint8 N> T mag(const FixedVector<T,N>& val);
template<class T,Uint8 N> T norm(const FixedVector<T,N>& val);
template<class T,Uint8 N> T product(const FixedVector<T,N>& val);
template<class T,Uint8 N> T sum(const FixedVector<T,N>& val);

template<class T,Uint8 N> const FixedVector<T,N> sign(const FixedVector<T,N>& val);
template<class T,Uint8 N> const FixedVector<T,N> unit(const FixedVector<T,N>& val);

template<class T,Uint8 N> bool all(const FixedVector<T,N>& val);
template<class T,Uint8 N> bool any(const FixedVector<T,N>& val);

template<class T,Uint8 N> const typename FixedVector<T,N>::Mask even(const FixedVector<T,N>& val);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask is_finite(const FixedVector<T,N>& val);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask odd(const FixedVector<T,N>& val);
*/
// unary operators
template<class T,Uint8 N> 
inline const FixedVector<T,N> operator+(const FixedVector<T,N>& val)
{
	return val;
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator-(const FixedVector<T,N>& val)
{
	return FixedVector<T,N>(val) *= -1;
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator~(const FixedVector<T,N>& val)
{
	FixedVector<T,N> tmp(val);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = ~val[i];
		
	return tmp;
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator!(const FixedVector<T,N>& val)
{
	FixedVector<T,N> tmp(val);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = !val[i];
		
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> abs(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Abs(tmp);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> ceil(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Ceil(tmp);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> exp(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Exp(tmp);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> fabs(const FixedVector<T,N>& val)
{
	return abs(val);
}

template<class T,Uint8 N> 
inline FixedVector<T,N> floor(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Floor(tmp);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> log(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Log(tmp);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> log10(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Log10(tmp);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> round(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Round(tmp);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> sqr(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Sqr(tmp);

	return tmp;
}


template<class T,Uint8 N> 
inline FixedVector<T,N> sqrt(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Sqrt(tmp);

	return tmp;
}

// trigonometric functions
template<class T,Uint8 N> 
inline FixedVector<T,N> acos(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Acos(tmp);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> asin(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Asin(tmp);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> atan(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Atan(tmp);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> cos(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Cos(tmp);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> sin(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Sin(tmp);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> tan(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Tan(tmp);

	return tmp;
}

// hyperbolic functions
template<class T,Uint8 N> 
inline FixedVector<T,N> acosh(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Acosh(tmp);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> asinh(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Asinh(tmp);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> atanh(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Atanh(tmp);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> cosh(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Cosh(tmp);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> sinh(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Sinh(tmp);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> tanh(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Tanh(tmp);

	return tmp;
}

// complex 
template<class T,Uint8 N> 
inline FixedVector<T,N> conj(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp(val);

	Conj(tmp);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<typename mcs::DemoteComplex<T>::demote_t,N> imag(const FixedVector<T,N>& val)
{
	FixedVector<typename mcs::DemoteComplex<T>::demote_t,N>	tmp;

	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = imag(val[i]);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<typename mcs::DemoteComplex<T>::demote_t,N> real(const FixedVector<T,N>& val)
{
	FixedVector<typename mcs::DemoteComplex<T>::demote_t,N>	tmp;

	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = real(val[i]);

	return tmp;
}

// in-place unary operators
template<class T,Uint8 N> 
inline FixedVector<T,N>& Abs(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::abs(val[i]);
	
	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Ceil(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::ceil(val[i]);
	
	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Exp(FixedVector<T,N>& val)
{
	static const EnsureFloat<T>	dummy_;
	
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::exp(val[i]);
	
	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Fabs(FixedVector<T,N>& val)
{
	return Abs(val);
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Floor(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::floor(val[i]);
	
	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Log(FixedVector<T,N>& val)
{
	static const EnsureFloat<T>	dummy_;
	
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::log(val[i]);
	
	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Log10(FixedVector<T,N>& val)
{
	static const EnsureFloat<T>	dummy_;
	
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::log10(val[i]);
	
	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Round(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::round(val[i]);
	
	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Sqr(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::sqr(val[i]);
	
	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Sqrt(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::sqrt(val[i]);
	
	return val;
}

// trigonometric functions
template<class T,Uint8 N> 
inline FixedVector<T,N>& Acos(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::acos(val[i]);
	
	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Asin(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::asin(val[i]);
	
	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Atan(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::atan(val[i]);
	
	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Cos(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::cos(val[i]);
	
	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Sin(FixedVector<T,N>& val)
{	
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::sin(val[i]);

	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Tan(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::tan(val[i]);
	
	return val;
}

// hyperbolic functions
template<class T,Uint8 N> 
inline FixedVector<T,N>& Acosh(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::acosh(val[i]);
	
	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Asinh(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::asinh(val[i]);
	
	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Atanh(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::atanh(val[i]);

	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Cosh(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::cosh(val[i]);
	
	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Sinh(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::sinh(val[i]);
	
	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Tanh(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::tanh(val[i]);
	
	return val;
}

// complex
template<class T,Uint8 N> 
inline FixedVector<T,N>& Conj(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::conj(val[i]);
		
	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Imag(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::imag(val[i]);
		
	return val;
}

template<class T,Uint8 N> 
inline FixedVector<T,N>& Real(FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		val[i] = std::real(val[i]);
		
	return val;
}

// MCS unary operators
template<class T,Uint8 N> 
inline FixedVector<T,N> acosd(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp;

	for (Int32 i=val.first();i<=val.last();i++)
		tmp[i] = std::acosd(val[i]);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> asind(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp;

	for (Int32 i=val.first();i<=val.last();i++)
		tmp[i] = std::asind(val[i]);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> atand(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp;

	for (Int32 i=val.first();i<=val.last();i++)
		tmp[i] = std::atand(val[i]);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> cosd(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp;

	for (Int32 i=val.first();i<=val.last();i++)
		tmp[i] = std::cosd(val[i]);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> sind(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp;

	for (Int32 i=val.first();i<=val.last();i++)
		tmp[i] = std::sind(val[i]);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> tand(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp;

	for (Int32 i=val.first();i<=val.last();i++)
		tmp[i] = std::tand(val[i]);

	return tmp;
}


template<class T,Uint8 N> 
inline FixedVector<T,N> acosr(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp;

	for (Int32 i=val.first();i<=val.last();i++)
		tmp[i] = std::acosr(val[i]);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> asinr(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp;

	for (Int32 i=val.first();i<=val.last();i++)
		tmp[i] = std::asinr(val[i]);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> atanr(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp;

	for (Int32 i=val.first();i<=val.last();i++)
		tmp[i] = std::atanr(val[i]);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> cosr(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp;

	for (Int32 i=val.first();i<=val.last();i++)
		tmp[i] = std::cosr(val[i]);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> sinr(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp;

	for (Int32 i=val.first();i<=val.last();i++)
		tmp[i] = std::sinr(val[i]);

	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> tanr(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp;

	for (Int32 i=val.first();i<=val.last();i++)
		tmp[i] = std::tanr(val[i]);

	return tmp;
}

template<class T,Uint8 N> 
inline T mag(const FixedVector<T,N>& val)
{
	return std::sqrt(norm(val));
}

template<class T,Uint8 N> 
inline T norm(const FixedVector<T,N>& val)
{
	return sum(sqr(val));
}

template<class T,Uint8 N> 
inline T product(const FixedVector<T,N>& val)
{
	T	pd(val[0]);
	
	for (Int32 i=val.first()+1;i<=val.last();i++)
		pd *= val[i];
		
	return pd;
}

template<class T,Uint8 N> 
inline T sum(const FixedVector<T,N>& val)
{
	T	sm(val[0]);
	
	for (Int32 i=val.first()+1;i<=val.last();i++)
		sm += val[i];
		
	return sm;
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> sign(const FixedVector<T,N>& val)
{
	FixedVector<T,N>	tmp;

	for (Int32 i=val.first();i<=val.last();i++)
		tmp[i] = std::sign(val[i]);
		
	return tmp;
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> unit(const FixedVector<T,N>& val)
{
	return val/std::mag(val);
}

template<class T,Uint8 N> 
inline bool all(const FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		if (val[i] == false) 
			return false;
		
	return true;
}

template<class T,Uint8 N> 
inline bool any(const FixedVector<T,N>& val)
{
	for (Int32 i=val.first();i<=val.last();i++)
		if (val[i] == true) 
			return true;
		
	return false;
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask even(const FixedVector<T,N>& val)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=val.first();i<=val.last();i++)
		tmp[i] = std::even(val[i]);
		
	return tmp;
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask is_finite(const FixedVector<T,N>& val)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=val.first();i<=val.last();i++)
		tmp[i] = std::is_finite(val[i]);
		
	return tmp;
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask odd(const FixedVector<T,N>& val)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=val.first();i<=val.last();i++)
		tmp[i] = std::odd(val[i]);
		
	return tmp;
}
/*
// binary operators
template<class T,Uint8 N> const FixedVector<T,N> operator+(T lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator-(T lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator*(T lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator/(T lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator%(T lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator&(T lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator|(T lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator^(T lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator<<(T lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator>>(T lhs,const FixedVector<T,N>& rhs);

template<class T,Uint8 N> const FixedVector<T,N> operator+(const FixedVector<T,N>& lhs,T rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator-(const FixedVector<T,N>& lhs,T rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator*(const FixedVector<T,N>& lhs,T rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator/(const FixedVector<T,N>& lhs,T rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator%(const FixedVector<T,N>& lhs,T rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator&(const FixedVector<T,N>& lhs,T rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator|(const FixedVector<T,N>& lhs,T rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator^(const FixedVector<T,N>& lhs,T rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator<<(const FixedVector<T,N>& lhs,T rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator>>(const FixedVector<T,N>& lhs,T rhs);

template<class T,Uint8 N> const FixedVector<T,N> operator+(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator-(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator*(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator/(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator%(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator&(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator|(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator^(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator<<(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const FixedVector<T,N> operator>>(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);

template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator==(const FixedVector<T,N>& lhs,const T& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator!=(const FixedVector<T,N>& lhs,const T& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator<(const FixedVector<T,N>& lhs,const T& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator<=(const FixedVector<T,N>& lhs,const T& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator>(const FixedVector<T,N>& lhs,const T& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator>=(const FixedVector<T,N>& lhs,const T& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator&&(const FixedVector<T,N>& lhs,const T& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator||(const FixedVector<T,N>& lhs,const T& rhs);

template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator==(const T& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator!=(const T& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator<(const T& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator<=(const T& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator>(const T& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator>=(const T& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator&&(const T& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator||(const T& lhs,const FixedVector<T,N>& rhs);

template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator==(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator!=(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator<(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator<=(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator>(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator>=(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator&&(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> const typename FixedVector<T,N>::Mask operator||(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);

template<class T,Uint8 N> FixedVector<T,N> atan2(T lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> FixedVector<T,N> fmod(T lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> FixedVector<T,N> ldexp(T lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> FixedVector<T,N> pow(T lhs,const FixedVector<T,N>& rhs);

template<class T,Uint8 N> FixedVector<T,N> atan2(const FixedVector<T,N>& lhs,T rhs);
template<class T,Uint8 N> FixedVector<T,N> fmod(const FixedVector<T,N>& lhs,T rhs);
template<class T,Uint8 N> FixedVector<T,N> ldexp(const FixedVector<T,N>& lhs,T rhs);
template<class T,Uint8 N> FixedVector<T,N> pow(const FixedVector<T,N>& lhs,T rhs);

template<class T,Uint8 N> FixedVector<T,N> atan2(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> FixedVector<T,N> fmod(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> FixedVector<T,N> ldexp(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> FixedVector<T,N> pow(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);

// MCS binary operators
template<class T,Uint8 N> FixedVector<T,N> mod(T lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> FixedVector<T,N> quotient(T lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> FixedVector<T,N> sign(T lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> FixedVector<T,N> step(T lhs,const FixedVector<T,N>& rhs);

template<class T,Uint8 N> FixedVector<T,N> mod(const FixedVector<T,N>& lhs,T rhs);
template<class T,Uint8 N> FixedVector<T,N> quotient(const FixedVector<T,N>& lhs,T rhs);
template<class T,Uint8 N> FixedVector<T,N> sign(const FixedVector<T,N>& lhs,T rhs);
template<class T,Uint8 N> FixedVector<T,N> step(const FixedVector<T,N>& lhs,T rhs);

template<class T,Uint8 N> FixedVector<T,N> cross(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> FixedVector<T,N> mod(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> FixedVector<T,N> quotient(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> FixedVector<T,N> sign(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
template<class T,Uint8 N> FixedVector<T,N> step(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);

template<class T,Uint8 N> T dot(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs);
*/
// arithmetic operators
template<class T,Uint8 N> 
inline const FixedVector<T,N> operator+(T lhs,const FixedVector<T,N>& rhs)
{
	if (lhs == T(0)) return rhs;
		
	return (FixedVector<T,N>(lhs) += rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator-(T lhs,const FixedVector<T,N>& rhs)
{
	if (lhs == T(0)) return -rhs;
		
	return (FixedVector<T,N>(lhs) -= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator*(T lhs,const FixedVector<T,N>& rhs)
{
	if (lhs == T(1)) return rhs;
	if (lhs == T(0)) return FixedVector<T,N>(T(0));
	
	return (FixedVector<T,N>(lhs) *= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator/(T lhs,const FixedVector<T,N>& rhs)
{
	if (lhs == T(0)) return FixedVector<T,N>(T(0));
		
	return (FixedVector<T,N>(lhs) /= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator%(T lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) %= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator&(T lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) &= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator|(T lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) |= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator^(T lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) ^= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator<<(T lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) <<= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator>>(T lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) >>= rhs);
}


template<class T,Uint8 N> 
inline const FixedVector<T,N> operator+(const FixedVector<T,N>& lhs,T rhs)
{
	if (rhs == T(0)) return lhs;
		
	return (FixedVector<T,N>(lhs) += rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator-(const FixedVector<T,N>& lhs,T rhs)
{
	if (rhs == T(0)) return lhs;
		
	return (FixedVector<T,N>(lhs) -= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator*(const FixedVector<T,N>& lhs,T rhs)
{
	if (rhs == T(1)) return lhs;
	if (rhs == T(0)) return FixedVector<T,N>(T(0));	

	return (FixedVector<T,N>(lhs) *= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator/(const FixedVector<T,N>& lhs,T rhs)
{
	if (rhs == T(1)) return lhs;
		
	return (FixedVector<T,N>(lhs) /= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator%(const FixedVector<T,N>& lhs,T rhs)
{
	return (FixedVector<T,N>(lhs) %= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator&(const FixedVector<T,N>& lhs,T rhs)
{
	return (FixedVector<T,N>(lhs) &= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator|(const FixedVector<T,N>& lhs,T rhs)
{
	return (FixedVector<T,N>(lhs) |= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator^(const FixedVector<T,N>& lhs,T rhs)
{
	return (FixedVector<T,N>(lhs) ^= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator<<(const FixedVector<T,N>& lhs,T rhs)
{
	return (FixedVector<T,N>(lhs) <<= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator>>(const FixedVector<T,N>& lhs,T rhs)
{
	return (FixedVector<T,N>(lhs) >>= rhs);
}


template<class T,Uint8 N> 
inline const FixedVector<T,N> operator+(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) += rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator-(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) -= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator*(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) *= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator/(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) /= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator%(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) %= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator&(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) &= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator|(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) |= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator^(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) ^= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator<<(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) <<= rhs);
}

template<class T,Uint8 N> 
inline const FixedVector<T,N> operator>>(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	return (FixedVector<T,N>(lhs) >>= rhs);
}

// logical operators
template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator==(const T& lhs,const FixedVector<T,N>& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs == rhs[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator!=(const T& lhs,const FixedVector<T,N>& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs != rhs[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator<(const T& lhs,const FixedVector<T,N>& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs < rhs[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator<=(const T& lhs,const FixedVector<T,N>& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs <= rhs[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator>(const T& lhs,const FixedVector<T,N>& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs > rhs[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator>=(const T& lhs,const FixedVector<T,N>& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs >= rhs[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator&&(const T& lhs,const FixedVector<T,N>& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs && rhs[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator||(const T& lhs,const FixedVector<T,N>& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs || rhs[i]);

	return tmp;	
}


template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator==(const FixedVector<T,N>& lhs,const T& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs[i] == rhs);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator!=(const FixedVector<T,N>& lhs,const T& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs[i] != rhs);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator<(const FixedVector<T,N>& lhs,const T& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs[i] < rhs);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator<=(const FixedVector<T,N>& lhs,const T& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs[i] <= rhs);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator>(const FixedVector<T,N>& lhs,const T& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs[i] > rhs);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator>=(const FixedVector<T,N>& lhs,const T& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs[i] >= rhs);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator&&(const FixedVector<T,N>& lhs,const T& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs[i] && rhs);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator||(const FixedVector<T,N>& lhs,const T& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs[i] || rhs);

	return tmp;	
}


template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator==(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs[i] == rhs[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator!=(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs[i] != rhs[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator<(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs[i] < rhs[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator<=(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs[i] <= rhs[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator>(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs[i] > rhs[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator>=(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	typename FixedVector<T,N>::Mask	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs[i] >= rhs[i]);

	return tmp;	
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator&&(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	typename FixedVector<T,N>::Mask tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs[i] && rhs[i]);
		
	return tmp;
}

template<class T,Uint8 N> 
inline const typename FixedVector<T,N>::Mask operator||(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	typename FixedVector<T,N>::Mask tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = (lhs[i] || rhs[i]);
		
	return tmp;
}


template<class T,Uint8 N> 
inline FixedVector<T,N> atan2(T lhs,const FixedVector<T,N>& rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::atan2(lhs,rhs[i]);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> fmod(T lhs,const FixedVector<T,N>& rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::fmod(lhs,rhs[i]);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> ldexp(T lhs,const FixedVector<T,N>& rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::ldexp(lhs,rhs[i]);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> pow(T lhs,const FixedVector<T,N>& rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::pow(lhs,rhs[i]);
	
	return tmp;
}


template<class T,Uint8 N> 
inline FixedVector<T,N> atan2(const FixedVector<T,N>& lhs,T rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::atan2(lhs[i],rhs);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> fmod(const FixedVector<T,N>& lhs,T rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::fmod(lhs[i],rhs);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> ldexp(const FixedVector<T,N>& lhs,T rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::ldexp(lhs[i],rhs);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> pow(const FixedVector<T,N>& lhs,T rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::pow(lhs[i],rhs);
	
	return tmp;
}


template<class T,Uint8 N> 
inline FixedVector<T,N> atan2(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	FixedVector<T,N>	tmp;
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::atan2(lhs[i],rhs[i]);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> fmod(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::fmod(lhs[i],rhs[i]);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> ldexp(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::ldexp(lhs[i],rhs[i]);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> pow(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::pow(lhs[i],rhs[i]);
	
	return tmp;
}

// MCS binary operators
template<class T,Uint8 N> 
inline FixedVector<T,N> mod(T lhs,const FixedVector<T,N>& rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::mod(lhs,rhs[i]);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> quotient(T lhs,const FixedVector<T,N>& rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::quotient(lhs,rhs[i]);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> sign(T lhs,const FixedVector<T,N>& rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::sign(lhs,rhs[i]);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> step(T lhs,const FixedVector<T,N>& rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::step(lhs,rhs[i]);
	
	return tmp;
}


template<class T,Uint8 N> 
inline FixedVector<T,N> mod(const FixedVector<T,N>& lhs,T rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::mod(lhs[i],rhs);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> quotient(const FixedVector<T,N>& lhs,T rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::quotient(lhs[i],rhs);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> sign(const FixedVector<T,N>& lhs,T rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::sign(lhs[i],rhs);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> step(const FixedVector<T,N>& lhs,T rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::step(lhs[i],rhs);
	
	return tmp;
}


template<class T> 
inline FixedVector<T,3> cross(const FixedVector<T,3>& lhs,const FixedVector<T,3>& rhs)
{
	FixedVector<T,3>	tmp;
	
	tmp[0] = lhs[1]*rhs[2]-rhs[1]*lhs[2];
	tmp[1] = lhs[2]*rhs[0]-rhs[2]*lhs[0];
	tmp[2] = lhs[0]*rhs[1]-rhs[1]*lhs[0];
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> mod(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::mod(lhs[i],rhs[i]);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> quotient(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::quotient(lhs[i],rhs[i]);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> sign(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::sign(lhs[i],rhs[i]);
	
	return tmp;
}

template<class T,Uint8 N> 
inline FixedVector<T,N> step(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	FixedVector<T,N>	tmp(lhs);
	
	for (Int32 i=tmp.first();i<=tmp.last();i++)
		tmp[i] = std::step(lhs[i],rhs[i]);
	
	return tmp;
}

template<class T,Uint8 N> 
inline T dot(const FixedVector<T,N>& lhs,const FixedVector<T,N>& rhs)
{
	return sum(lhs*rhs);
}

} // namespace mcs

#endif // MCS_FIXEDVECTOROPERATORS_H