#ifndef MCS_FIXEDVECTORTYPECASTS_H
#define MCS_FIXEDVECTORTYPECASTS_H

#include "MCS_FixedVector.h"
#include "MCS_Typecasts.h"

namespace mcs {

template<class T,Uint8 D> class construct< FixedVector<T,D> >
{
	public:
		template<class U> static FixedVector<T,D> from(const FixedVector<U,D>& vec)
		{ 
			FixedVector<T,D>	tmp;
			
			for (Int32 i=vec.first();i<=vec.last();i++) 
				tmp[i] = static_cast<T>(vec[i]);
				
			return tmp;
		}
};

template<class T> class construct< FixedVector<T,1> >
{
	public:
		template<class U> static FixedVector<T,1> from(const FixedVector<U,1>& vec)
		{ return FixedVector<T,1>(static_cast<T>(vec[0])); }
};

template<class T> class construct< FixedVector<T,2> >
{
	public:
		template<class U> static FixedVector<T,2> from(const FixedVector<U,2>& vec)
		{ return FixedVector<T,2>(static_cast<T>(vec[0]),static_cast<T>(vec[1])); }
};

template<class T> class construct< FixedVector<T,3> >
{
	public:
		template<class U> static FixedVector<T,3> from(const FixedVector<U,3>& vec)
		{ return FixedVector<T,3>(static_cast<T>(vec[0]),static_cast<T>(vec[1]),static_cast<T>(vec[2])); }
};

template<class T> class construct< FixedVector<T,4> >
{
	public:
		template<class U> static FixedVector<T,4> from(const FixedVector<U,4>& vec)
		{ return FixedVector<T,4>(static_cast<T>(vec[0]),static_cast<T>(vec[1]),static_cast<T>(vec[2]),static_cast<T>(vec[3])); }
};

} // namespace mcs

#endif // MCS_FIXEDVECTORTYPECASTS_H