#include "MCS_FileLocations.h"

namespace mcs {

const FileLocationDirectory& FileLocations = Singleton<FileLocationDirectory>::instance();

FileLocationDirectory::FileLocationDirectory()
{
	add("geoid","Q:\\Geoid\\");
	add("land cover","Q:\\LandCover\\");
	add("land fraction","Q:\\LandFraction\\");
	add("topography","Q:\\Topography\\");
	
	add("GOES diurnal","\\\\DELL-P1700D\\F\\MSU_Diurnal\\");
	
	add("CCM3 MSU diurnal cycle","\\\\DELL-P1700D\\F\\MSU_Diurnal\\CCM3_Diurnal_Climatology\\");
	add("MSU climatology","\\\\DELL-P1700D\\F\\MSU_Climatology\\");
	add("MSU S&C gridded","\\\\DELL-P1700D\\F\\MSU_SC_Gridded\\");
	add("MSU Level 0","\\\\DELL-P1700D\\G\\MSU_Level_0\\");
	add("MSU Level 1A","\\\\DELL-P1700D\\F\\MSU_Level_1A\\");
	add("MSU Level 1B","\\\\DELL-P1700D\\F\\MSU_Level_1B\\");
	add("NCEP MSU TB","\\\\DELL-P1700D\\F\\NCEP_Modelled_Tbs\\");

	add("NCAR RAOB","\\\\DELL-P1700D\\RAOB_Data\\NCAR_RAOB\\Level_1\\");
	
	add("NCEP profile climatology","\\\\DELL-P1700D\\Q\\NCEP\\MonthlyClimatology\\");
	add("NCEP profile reanalysis","\\\\MICRON-P400A\\F\\NCEP\\");
	add("NCEP surface climatology","\\\\DELL-P1700D\\Q\\NCEP\\MonthlyClimatology\\");
	add("NCEP surface reanalysis","\\\\MICRON-P400A\\F\\NCEP\\");

	add("Reynolds SST climatology","\\\\DELL-P1700D\\Data\\SST\\Reynolds\\Climatology\\");
	add("Reynolds OISST","Q:\\SST\\Reynolds\\OISST\\data\\oiweek_v2\\");

	add("SSMI bytemaps","\\\\SSMI\\");
	add("SSMI Level 1A","\\\\DELL-P1000B\\");
	add("SSMI Level 2","\\\\SSMI\\");
	add("SSMI output","\\\\DELL-P1700D\\SSMI_Data\\");

	add("TLE","\\\\DELL-P1700D\\Q\\TLE\\");

	add("TMI Level 1A","");
	add("TMI Level 2","\\\\SSMI\\");
};

} // namespace mcs
