template<Uint8 D> 
inline Index<D>& Index<D>::operator=(Int32 source)
{
	FixedVector<Int32,D>::operator=(source);
		
	return *this;
}

template<Uint8 D> 
inline Index<D>& Index<D>::operator=(const std::string& str)
{
	FixedVector<Int32,D>::operator=(str);
		
	return *this;
}

template<Uint8 D> 
inline Index<D>& Index<D>::operator=(const FixedVector<Int32,D>& source)
{
	FixedVector<Int32,D>::operator=(source);
		
	return *this;
}

template<Uint8 D> 
inline Index<D>& Index<D>::operator=(const Index<D>& source)
{
	if (this == &source) return *this;
	
	FixedVector<Int32,D>::operator=(source);
		
	return *this;
}

// specializations
// vector index -> behaves like Int32
template<> 
inline Index<1>& Index<1>::operator=(const Int32& source)
{
	FixedVector<Int32,1>::operator=(source);
		
	return *this;
}

template<> 
inline Index<1>& Index<1>::operator=(const std::string& str)
{
	FixedVector<Int32,1>::operator=(str);
		
	return *this;
}

template<> 
inline Index<1>& Index<1>::operator=(const FixedVector<Int32,1>& source)
{
	FixedVector<Int32,1>::operator=(source);
		
	return *this;
}

template<> 
inline Index<1>& Index<1>::operator=(const Index<1>& source)
{
	if (this == &source) return *this;
	
	FixedVector<Int32,1>::operator=(source);
		
	return *this;
}

// matrix index 
template<> 
inline Index<2>& Index<2>::operator=(Int32 source)
{
	FixedVector<Int32,2>::operator=(source);
		
	return *this;
}

template<> 
inline Index<2>& Index<2>::operator=(const std::string& str)
{
	FixedVector<Int32,2>::operator=(str);
		
	return *this;
}

template<> 
inline Index<2>& Index<2>::operator=(const FixedVector<Int32,2>& source)
{
	FixedVector<Int32,2>::operator=(source);
		
	return *this;
}

template<> 
inline Index<2>& Index<2>::operator=(const Index<2>& source)
{
	if (this == &source) return *this;
	
	FixedVector<Int32,2>::operator=(source);
		
	return *this;
}

// rank 3 tensor index 
template<> 
inline Index<3>& Index<3>::operator=(Int32 source)
{
	FixedVector<Int32,3>::operator=(source);
		
	return *this;
}

template<> 
inline Index<3>& Index<3>::operator=(const std::string& str)
{
	FixedVector<Int32,3>::operator=(str);
		
	return *this;
}

template<> 
inline Index<3>& Index<3>::operator=(const FixedVector<Int32,3>& source)
{
	FixedVector<Int32,3>::operator=(source);
		
	return *this;
}

template<> 
inline Index<3>& Index<3>::operator=(const Index<3>& source)
{
	if (this == &source) return *this;
	
	FixedVector<Int32,3>::operator=(source);
		
	return *this;
}

// rank 4 tensor index 
template<> 
inline Index<4>& Index<4>::operator=(Int32 source)
{
	FixedVector<Int32,4>::operator=(source);
		
	return *this;
}

template<> 
inline Index<4>& Index<4>::operator=(const std::string& str)
{
	FixedVector<Int32,4>::operator=(str);
		
	return *this;
}

template<> 
inline Index<4>& Index<4>::operator=(const FixedVector<Int32,4>& source)
{
	FixedVector<Int32,4>::operator=(source);
		
	return *this;
}

template<> 
inline Index<4>& Index<4>::operator=(const Index<4>& source)
{
	if (this == &source) return *this;
	
	FixedVector<Int32,4>::operator=(source);
		
	return *this;
}

// rank 5 tensor index 
template<> 
inline Index<5>& Index<5>::operator=(Int32 source)
{
	FixedVector<Int32,5>::operator=(source);
		
	return *this;
}

template<> 
inline Index<5>& Index<5>::operator=(const std::string& str)
{
	FixedVector<Int32,5>::operator=(str);
		
	return *this;
}

template<> 
inline Index<5>& Index<5>::operator=(const FixedVector<Int32,5>& source)
{
	FixedVector<Int32,5>::operator=(source);
		
	return *this;
}

template<> 
inline Index<5>& Index<5>::operator=(const Index<5>& source)
{
	if (this == &source) return *this;
	
	FixedVector<Int32,5>::operator=(source);
		
	return *this;
}

// rank 6 tensor index 
template<> 
inline Index<6>& Index<6>::operator=(Int32 source)
{
	FixedVector<Int32,6>::operator=(source);
		
	return *this;
}

template<> 
inline Index<6>& Index<6>::operator=(const std::string& str)
{
	FixedVector<Int32,6>::operator=(str);
		
	return *this;
}

template<> 
inline Index<6>& Index<6>::operator=(const FixedVector<Int32,6>& source)
{
	FixedVector<Int32,6>::operator=(source);
		
	return *this;
}

template<> 
inline Index<6>& Index<6>::operator=(const Index<6>& source)
{
	if (this == &source) return *this;
	
	FixedVector<Int32,6>::operator=(source);
		
	return *this;
}

// rank 7 tensor index 
template<> 
inline Index<7>& Index<7>::operator=(Int32 source)
{
	FixedVector<Int32,7>::operator=(source);
		
	return *this;
}

template<> 
inline Index<7>& Index<7>::operator=(const std::string& str)
{
	FixedVector<Int32,7>::operator=(str);
		
	return *this;
}

template<> 
inline Index<7>& Index<7>::operator=(const FixedVector<Int32,7>& source)
{
	FixedVector<Int32,7>::operator=(source);
		
	return *this;
}

template<> 
inline Index<7>& Index<7>::operator=(const Index<7>& source)
{
	if (this == &source) return *this;
	
	FixedVector<Int32,7>::operator=(source);
		
	return *this;
}

// rank 8 tensor index 
template<> 
inline Index<8>& Index<8>::operator=(Int32 source)
{
	FixedVector<Int32,8>::operator=(source);
		
	return *this;
}

template<> 
inline Index<8>& Index<8>::operator=(const std::string& str)
{
	FixedVector<Int32,8>::operator=(str);
		
	return *this;
}

template<> 
inline Index<8>& Index<8>::operator=(const FixedVector<Int32,8>& source)
{
	FixedVector<Int32,8>::operator=(source);
		
	return *this;
}

template<> 
inline Index<8>& Index<8>::operator=(const Index<8>& source)
{
	if (this == &source) return *this;
	
	FixedVector<Int32,8>::operator=(source);
		
	return *this;
}

// rank 9 tensor index 
template<> 
inline Index<9>& Index<9>::operator=(Int32 source)
{
	FixedVector<Int32,9>::operator=(source);
		
	return *this;
}

template<> 
inline Index<9>& Index<9>::operator=(const std::string& str)
{
	FixedVector<Int32,9>::operator=(str);
		
	return *this;
}

template<> 
inline Index<9>& Index<9>::operator=(const FixedVector<Int32,9>& source)
{
	FixedVector<Int32,9>::operator=(source);
		
	return *this;
}

template<> 
inline Index<9>& Index<9>::operator=(const Index<9>& source)
{
	if (this == &source) return *this;
	
	FixedVector<Int32,9>::operator=(source);
		
	return *this;
}

// rank 10 tensor index 
template<> 
inline Index<10>& Index<10>::operator=(Int32 source)
{
	FixedVector<Int32,10>::operator=(source);
		
	return *this;
}

template<> 
inline Index<10>& Index<10>::operator=(const std::string& str)
{
	FixedVector<Int32,10>::operator=(str);
		
	return *this;
}

template<> 
inline Index<10>& Index<10>::operator=(const FixedVector<Int32,10>& source)
{
	FixedVector<Int32,10>::operator=(source);
		
	return *this;
}

template<> 
inline Index<10>& Index<10>::operator=(const Index<10>& source)
{
	if (this == &source) return *this;
	
	FixedVector<Int32,10>::operator=(source);
		
	return *this;
}
