#ifndef MCS_INTELNSP_H
#define MCS_INTELNSP_H

/*
	Some #defines, includes, and conversion utility operators for use of the Intel 
		Signal Processing Libraries for performance tuning on Intel processors.
*/

#define nsp_UsesVector
#define nsp_UsesTransform
#define nsp_UsesConvolution
#define nsp_UsesWin

// include Intel Signal Processing Library
#include "nsp.h"

#include "MCS_Typedefs.h"

namespace mcs {

// type conversions from standard complex to Intel SPL complex and back
inline SCplx scplx(const s_complex& val) 	{ return nspcSet(val.real(),val.imag()); }
inline DCplx dcplx(const d_complex& val) 	{ return nspzSet(val.real(),val.imag()); }
inline Complex32 scplx(const SCplx& val) 	{ return Complex32(val.re,val.im); }
inline Complex64 dcplx(const DCplx& val) 	{ return Complex64(val.re,val.im); }

} // namespace mcs

#endif // MCS_INTELNSP_H