#ifndef MCS_METADATA_H
#define MCS_METADATA_H

#include <string>

#include "MCS_Exceptions.h"
#include "MCS_OneWayDirectory.h"

namespace mcs {

class Metadata : 
	public OneWayDirectory<std::string,std::string>
{
	public:
		Metadata(const std::string& = "");
		~Metadata() { }

		bool operator==(const Metadata& meta) const;
		bool operator!=(const Metadata& meta) const;
		
		//class Err : public Exception { };
		__DECLARE_EXCEPTION_CLASS__(Err,Exception)
	
	private:
		std::string	str_;
};

inline Metadata::Metadata(const std::string& str) :
	str_(str)
{
	if (str != "")
	{
		std::stringstream	sstr;
		
		sstr << str;
		
		std::string	tmp1,
					tmp2;
					
		while (sstr >> tmp1 >> tmp2)
			add(tmp1,tmp2);
	}
}

inline bool Metadata::operator==(const Metadata& meta) const
{
	return str_ == meta.str_;
}

inline bool Metadata::operator!=(const Metadata& meta) const
{
	return str_ != meta.str_;
}

} // namespace mcs

#endif // MCS_METADATA_H