#ifndef MCS_PROMOTE_H
#define MCS_PROMOTE_H

#include "MCS_Typedefs.h"

namespace mcs {

// promote to appropriate float type
template<class T> class PromoteFloat;

template<> class PromoteFloat<Binary>						{ public: typedef Float32 promote_t; };
template<> class PromoteFloat<Int8>							{ public: typedef Float32 promote_t; };
template<> class PromoteFloat<Uint8>						{ public: typedef Float32 promote_t; };
template<> class PromoteFloat<Int16>						{ public: typedef Float32 promote_t; };
template<> class PromoteFloat<Uint16>						{ public: typedef Float32 promote_t; };
template<> class PromoteFloat<Int32>						{ public: typedef Float32 promote_t; };
template<> class PromoteFloat<Uint32>						{ public: typedef Float32 promote_t; };
template<> class PromoteFloat<Float32>						{ public: typedef Float32 promote_t; };
template<> class PromoteFloat<Float64>						{ public: typedef Float64 promote_t; };

// promote to appropriate complex type
template<class T> class PromoteComplex						{ public: typedef std::complex<T> promote_t; };

template<class T> class PromoteComplex< std::complex<T> >	{ public: typedef std::complex<T> promote_t; };

// for functions such as real where we want behavior like this:
//
//		Float32 real(Float32)
//		Float32 real(complex<Float32>)
//
template<class T> class DemoteComplex						{ public: typedef T demote_t; };

template<class T> class DemoteComplex< std::complex<T> >	{ public: typedef T demote_t; };

} // namespace mcs

#endif // MCS_PROMOTE_H