#ifndef MCS_PUSHBUTTON_H
#define MCS_PUSHBUTTON_H

#include <bitset>

#include "MCS_Constants.h"

namespace mcs {

template<int N> 
class PushButton
{
	public:
		PushButton(int idx = 0) 						{ bs_.set(idx); }
		~PushButton()									{ }
		
		bool operator==(const PushButton<N>& pb) const	{ return bs_ == pb.bs_; }
		bool operator!=(const PushButton<N>& pb) const	{ return bs_ != pb.bs_; }
		
		void set(int idx,bool val = true)				{ bs_.clear(); bs_.set(idx,val); }
		bool test(int idx) const						{ return bs_.test(idx); }
		
	private:
		std::bitset<N>	bs_;
};

} // namespace mcs

#endif // MCS_PUSHBUTTON_H