#ifndef MCS_REFERENCE_H
#define MCS_REFERENCE_H

namespace mcs {

/*
#include <iostream>

#include "MCS_Reference.h"

using namespace mcs;

int main( void )
{
	int	x = 12,
		y = 15;
	
	Reference<int>	ref1(x),
					ref2;
			
	int	z = ref1;
	
	ref1 = y;
	ref1 = 16;
	
	try
	{
		int	zz = ref2;
	}
	catch (Reference<int>::Err&)
	{ }
	
	ConstReference<int>	cref1(y),
						cref2;
						
	int	cz = cref1;
	
	cref1 = y;
	cref1 = 16;
					
	return 0;
}
*/

template<class T> class Reference
{
	public:
		Reference() : ptr_(NULL) { }
		explicit Reference(T& ref) : ptr_(&ref) { }
		Reference(const Reference<T>& source) : ptr_(source.ptr_) { }
		~Reference() { }
		
		Reference<T>& operator=(T&);
		Reference<T>& operator=(const Reference<T>&);
		
		operator T&();
		
		class Err { };
	
	private:
		T*	ptr_;
};

template<class T>
inline Reference<T>& Reference<T>::operator=(T& source)
{
	ptr_ = &source;
	return *this;
}

template<class T>
inline Reference<T>& Reference<T>::operator=(const Reference<T>& source)
{
	if (this == &source) return *this;
	
	ptr_ = source.ptr_;
	return *this;
}

template<class T>
inline Reference<T>::operator T&()
{
	if (ptr_ == NULL) throw Err();
	
	return *ptr_;
}

template<class T> class ConstReference
{
	public:
		ConstReference() : ptr_(NULL) { }
		explicit ConstReference(const T& ref) : ptr_(&ref) { }
		ConstReference(const ConstReference<T>& source) : ptr_(source.ptr_) { }
		~ConstReference() { }
		
		const ConstReference<T>& operator=(const T&);
		ConstReference<T>& operator=(const ConstReference<T>&);
		
		operator const T&();
		
		class Err { };
	
	private:
		const T*	ptr_;
};

template<class T>
inline const ConstReference<T>& ConstReference<T>::operator=(const T& source)
{
	ptr_ = &source;
	return *this;
}

template<class T>
inline ConstReference<T>& ConstReference<T>::operator=(const ConstReference<T>& source)
{
	if (this == &source) return *this;
	
	ptr_ = source.ptr_;
	return *this;
}

template<class T>
inline ConstReference<T>::operator const T&()
{
	if (ptr_ == NULL) throw Err();
	
	return *ptr_;
}

} // namespace mcs

#endif // MCS_REFERENCE_H