#ifndef MCS_STRINGEXTENSIONS_H
#define MCS_STRINGEXTENSIONS_H

#include <sstream>
#include <string>

namespace mcs {

template<class T> void fromString(const std::string&,T& val);
template<class T> std::string toString(const T& val);

std::string toLower(const std::string& str);
std::string toUpper(const std::string& str);
std::string removeSpaces(const std::string& str);

template<class T> 
inline void fromString(const std::string& str,T& val)
{
	std::stringstream	sstr;
	
	sstr << str;
	
	sstr >> val;
}

template<class T> 
inline std::string toString(const T& val)
{
	std::stringstream	sstr;
	
	sstr << val;

	return sstr.str();
}

inline std::string toLower(const std::string& str)
{
	std::string	outstr(str);
	
	for (int i=0;i<outstr.length();i++)
		outstr[i] = std::tolower(outstr[i]);
		
	return outstr;
}

inline std::string toUpper(const std::string& str)
{
	std::string	outstr(str);
	
	for (int i=0;i<outstr.length();i++)
		outstr[i] = std::toupper(outstr[i]);
		
	return outstr;
}

inline std::string removeSpaces(const std::string& str)
{
	int	numchar = 0;
	
	for (int i=0;i<str.length();i++)
		if (str[i] != ' ')
			numchar++;
			
	std::string	outstr(str.substr(0,numchar));
	
	for (int i=0,j=0;i<str.length();i++)
		if (str[i] != ' ')
			outstr[j++] = str[i];
			
	return outstr;
}

} // namespace mcs

#endif // MCS_STRINGEXTENSIONS_H