#ifndef MCS_TRIPLE_H
#define MCS_TRIPLE_H

#include <iostream>
#include <utility>

namespace mcs {

// complement to std::pair
template<class A,class B = A,class C = A> class triple
{
	public:
		triple(A a = A(),B b = B(),C c = C()) : first(a),second(b),third(c) { }
	
		A	first;
		B	second;
		C	third;
};

template<class A,class B> inline std::ostream& operator<<(std::ostream& os,const std::pair<A,B>& source)
{ 
	os << "(" << source.first << "," << source.second << ")"; 
	return os; 
}

template<class A,class B,class C> inline std::ostream& operator<<(std::ostream& os,const triple<A,B,C>& source)
{ 
	os << "(" << source.first << "," << source.second << "," << source.third << ")"; 
	return os; 
}

} // namespace mcs

#endif // MCS_TRIPLE_H