#ifndef MCS_TYPEFLAGS_H
#define MCS_TYPEFLAGS_H

#include <bitset>
#include <string>

#include "MCS_Typedefs.h"

namespace mcs {

// used to identify the type of data being output
template<class T> 
class TypeFlags
{
	public:
		static const std::bitset<8> flags();
								
	private:
		TypeFlags();
};

template<> inline const std::bitset<8> TypeFlags<Int8>::flags() 		{ return std::bitset<8>(std::string("00000001")); }
template<> inline const std::bitset<8> TypeFlags<Uint8>::flags() 		{ return std::bitset<8>(std::string("10000001")); }
template<> inline const std::bitset<8> TypeFlags<Int16>::flags() 		{ return std::bitset<8>(std::string("00000010")); }
template<> inline const std::bitset<8> TypeFlags<Uint16>::flags() 		{ return std::bitset<8>(std::string("10000010")); }
template<> inline const std::bitset<8> TypeFlags<Int32>::flags()		{ return std::bitset<8>(std::string("00000100")); }
template<> inline const std::bitset<8> TypeFlags<Uint32>::flags()		{ return std::bitset<8>(std::string("10000100")); }
template<> inline const std::bitset<8> TypeFlags<Float32>::flags()		{ return std::bitset<8>(std::string("00001000")); }
template<> inline const std::bitset<8> TypeFlags<Float64>::flags()		{ return std::bitset<8>(std::string("00010000")); }
template<> inline const std::bitset<8> TypeFlags<Complex32>::flags()	{ return std::bitset<8>(std::string("00100000")); }
template<> inline const std::bitset<8> TypeFlags<Complex64>::flags()	{ return std::bitset<8>(std::string("01000000")); }

// unspecified type
template<class T> inline const std::bitset<8> TypeFlags<T>::flags()		{ return std::bitset<8>(std::string("00000000")); }

} // namespace mcs

#endif // MCS_TYPEFLAGS_H