#ifndef MCS_GEOID_H
#define MCS_GEOID_H

#include "MCS_EarthMap.h"
#include "MCS_Exceptions.h"
#include "MCS_Geography.h"

namespace mcs {

namespace geo {

class Geoid
{
	public:
		Geoid(const Float32& res = 0.25);
		~Geoid() { }
		
		void resolution(const Float32& res)				{ setResolution(res); }
		const Float32& resolution() const				{ return res_; }
		
		Float32					operator()(const GeographicCoordinate<Float32>& coord) const;
		CenteredSurfaceMapF32	operator()(const CenteredSurfaceMapF32::GridType& grid) const;
		CenteredSurfaceMapF32&	operator()(CenteredSurfaceMapF32& map) const;
	
		Float32 			ellipsoid(const GeographicCoordinate<Float32>& coord) const;

		//class Err : public Exception { };
		__DECLARE_EXCEPTION_CLASS__(Err,GeographicErr)
		
	private:
		void setResolution(const Float32& res);
		
		Float32					res_;
		CenteredSurfaceMapF32*	data_ptr_;
};

} // namespace geo

} // namespace mcs

#endif // MCS_GEOID_H
