#ifndef MCS_LANDCOVERTYPE_H
#define MCS_LANDCOVERTYPE_H

#include "MCS_EarthMap.h"
#include "MCS_Exceptions.h"
#include "MCS_Geography.h"

namespace mcs {

namespace geo {

class LandCoverType
{
	public:
		LandCoverType(const Float32& res = 0.25);
		~LandCoverType() { }
		
		void resolution(const Float32& res)				{ setResolution(res); }
		const Float32& resolution() const				{ return res_; }
		
		Float32					operator()(const GeographicCoordinate<Float32>& coord) const;
		CenteredSurfaceMapI8	operator()(const CenteredSurfaceMapI8::GridType& grid) const;
		CenteredSurfaceMapI8&	operator()(CenteredSurfaceMapI8& map) const;
		
		//class Err : public Exception { };
		__DECLARE_EXCEPTION_CLASS__(Err,GeographicErr)
		
	private:
		void setResolution(const Float32& res);
		
		Float32					res_;
		CenteredSurfaceMapI8*	data_ptr_;
};

} // namespace geo

} // namespace mcs

#endif // MCS_LANDCOVERTYPE_H
