#include "MCS_SeaIceMask.h"

namespace mcs {

namespace geo {

SeaIceMask::SeaIceMask(const Float32& res)
{
	setResolution(res);
}

void SeaIceMask::setResolution(const Float32& res)
{ 
	res_ = res;
	
	if (resolution() < (180.0/720))
		throw Err();
	else if (resolution() < (180.0/180))
		data_ptr_ = &getMedResIceMaskData();
	else
		data_ptr_ = &getLoResIceMaskData();
}

bool SeaIceMask::operator()(const GeographicCoordinate<Float32>& coord,const Date&) const
{
	return data_ptr_->z(coord);
}

CenteredSurfaceMapF32& SeaIceMask::operator()(CenteredSurfaceMapF32& map,const Date& ep) const
{
	for (Index<2> idx(map.first());idx[0]<=map.last(0);++idx[0])
		for (idx[1]=map.first(1);idx[1]<=map.last(1);++idx[1])
			if ((*this)(map.coordinate(idx),ep))
				map(idx) = _NaN_;
						
	return map;
}

} // namespace geo

} // namespace mcs