#ifndef MCS_SEAICEMASK_H
#define MCS_SEAICEMASK_H

#include "MCS_EarthMap.h"
#include "MCS_Exceptions.h"
#include "MCS_Geography.h"

namespace mcs {

namespace geo {

class SeaIceMask
{
	public:
		SeaIceMask(const Float32& res = 0.25);
		~SeaIceMask() { }
		
		void resolution(const Float32& res)				{ setResolution(res); }
		const Float32& resolution() const				{ return res_; }
				
		bool					operator()(const GeographicCoordinate<Float32>& coord,const Date& ep) const;
		CenteredSurfaceMapF32&	operator()(CenteredSurfaceMapF32& map,const Date& ep) const;
	
		//class Err : public Exception { };
		__DECLARE_EXCEPTION_CLASS__(Err,GeographicErr)
		
	private:
		void setResolution(const Float32& res);
		void setThreshold(const Float32& thresh);
		
		Float32					res_;
		CenteredSurfaceMask*	data_ptr_;
};

} // namespace geo

} // namespace mcs

#endif // MCS_SEAICEMASK_H
