#include "MCS_FileLocations.h"
#include "MCS_Geography.h"

namespace mcs {

namespace geo {

// MCS 99/08/19 - return USGS Land Use/Land Cover System
Int8 getLandCover(const GeographicCoordinate<Float32>& coord)
{	
	const CenteredSurfaceMapI8&	data = getHiResLandCoverData();
		
	return data.z(coord);
}

CenteredSurfaceMapI8 getLandCover(const CenteredSurfaceMapI8::GridType& grid)
{
	CenteredSurfaceMapI8		map(grid);
	
	getLandCover(map);
			
	return map;
}

CenteredSurfaceMapI8& getLandCover(CenteredSurfaceMapI8& map)
{	
	CenteredSurfaceMapI8*	dataptr;
	const Float32			res = statistics::normal::min(map.resolution());
	
	dataptr = &getHi4ResLandCoverData();
	/*
	if (res <= (180.0/21600))
		dataptr = &getHi4ResLandCoverData();
	else if (res <= (180.0/10800))
		dataptr = &getHi3ResLandCoverData();
	else if (res <= (180.0/5400))
		dataptr = &getHi2ResLandCoverData();
	else if (res <= (180.0/2700))
		dataptr = &getHiResLandCoverData();
	else if (res <= (180.0/675))
		dataptr = &getMedResLandCoverData();
	else
		dataptr = &getLoResLandCoverData();
	*/
	for (Index<2> idx(map.first());idx[0]<=map.last(0);++idx[0])
		for (idx[1]=map.first(1);idx[1]<=map.last(1);++idx[1])
			map(idx) = dataptr->z(map.coordinate(idx));
			//map(idx) = dataptr->z(map.grid().nearest(map.coordinate(idx)));

	return map;
}

} // namespace geo

} // namespace mcs