#ifndef MCS_GZIPINPUTSTREAM_H
#define MCS_GZIPINPUTSTREAM_H

#include <string>

#include "MCS_IO.h"
#include "MCS_Vector.h"

namespace mcs {

class GZIPInputStream
{
	public:
		GZIPInputStream();
		
		Int32 uncompressedSize(const std::string& fname) const;
		
		void read(const std::string&);
		
		Vector<Uint8>& uncompressedData() 				{ return rawdata_; }
		const Vector<Uint8>& uncompressedData() const	{ return rawdata_; }
	
	private:
		std::string		last_filename_;
		Vector<Uint8>	rawdata_;
};

} // namespace mcs

#endif // MCS_GZIPINPUTSTREAM_H
