#ifndef MCS_MATRIXMASK_H
#define MCS_MATRIXMASK_H

#include "MCS_Matrix.h"
#include "MCS_Typedefs.h"

namespace mcs {

//namespace matrix {

// matrix mask class
class MatrixMask : public Matrix<Binary>
{
	public:
		MatrixMask(const IndexRange<2>&);
		MatrixMask(const MatrixMask&);
		MatrixMask(const IndexRange<2>&,const Binary&);
		MatrixMask(const IndexRange<2>&,const VectorMask&);
		MatrixMask(const IndexRange<2>&,const std::string&);
		~MatrixMask();
		
		MatrixMask& operator=(const MatrixMask&);
};

inline MatrixMask::MatrixMask(const IndexRange<2>& rng) : 
	Matrix<Binary>(rng)
{ }

inline MatrixMask::MatrixMask(const IndexRange<2>& rng,const Binary& val) :
	Matrix<Binary>(rng,val)
{ }

inline MatrixMask::MatrixMask(const IndexRange<2>& rng,const VectorMask& msk) :
	Matrix<Binary>(rng,msk)
{ }

inline MatrixMask::MatrixMask(const IndexRange<2>& rng,const std::string& str) :
	Matrix<Binary>(rng,str)
{ }

inline MatrixMask::MatrixMask(const MatrixMask& source) :
	Matrix<Binary>(source)
{ }

inline MatrixMask::~MatrixMask()
{ }

inline MatrixMask& MatrixMask::operator=(const MatrixMask& source)
{
	if (this == &source) return *this;

	Matrix<Binary>::operator=(source);
		
	return *this;
}

//} // namespace matrix

} // namespace mcs

#endif // MCS_MATRIXMASK_H