#ifndef MCS_NRGLOBALS_H
#define MCS_NRGLOBALS_H

#include "MCS_NumericalRecipes.h"

namespace NR {

namespace SP { 

long idum;
int kmax,kount,ncom,ndatat,nn,nn2,nvar;
fcomplex aax,bb,cc,dz,z0;
float aa,abdevt,dxsav,offs,tt,x1,x2,xf,xsav,ysav;
float *fvec,*pcom,*xicom,*xx,*yy,
		*sx,*sy,*ww,*xt,*yt,*ys,**yss,*xp,
		**yp,**d,**y,*x;
wavefilt wfilt;

void difeq(int,int,int,int,int,int,int*,int,float**,float**);
void load(float,float*,float*);
void load1(float,float*,float*);
void load2(float,float*,float*);
float nrfunc(float*);
float nrfunc(float,float,float);
void nrdfun(float*,float*);
void nrfuncv(int,float*,float*);
void score(float,float*,float*);
void usrfun(float*,int,float*,float**);
float yy1(float);
float yy2(float);
float z1(float,float);
float z2(float,float);

} // namespace SP

namespace DP {

long idum;
int kmax,kount,ncom,ndatat,nn,nn2,nvar;
dcomplex aax,bb,cc,dz,z0;
double aa,abdevt,dxsav,offs,tt,x1,x2,xf,xsav,ysav;
double *fvec,*pcom,*xicom,*xx,*yy,
		*sx,*sy,*ww,*xt,*yt,*ys,**yss,*xp,
		**yp,**d,**y,*x;
dwavefilt wfilt;

void difeq(int,int,int,int,int,int,int*,int,double**,double**);
void load(double,double*,double*);
void load1(double,double*,double*);
void load2(double,double*,double*);
double nrfunc(double*);
double nrfunc(double,double,double);
void nrdfun(double*,double*);
void nrfuncv(int,double*,double*);
void score(double,double*,double*);
void usrfun(double*,int,double*,double**);
double yy1(double);
double yy2(double);
double z1(double,double);
double z2(double,double);

} // namespace DP

} // namespace NR

#endif // MCS_NRGLOBALS_H