#include "MCS_NRWrappers.h"
#include "MCS_NumericalRecipes.h"

namespace NR {
/*
// single-precision specialization
template<> const typename FN<float>::_gaussj FN<float>::gaussj = &NR::SP::gaussj;
template<> const typename FN<float>::_ludcmp FN<float>::ludcmp = &NR::SP::ludcmp;
template<> const typename FN<float>::_lubksb FN<float>::lubksb = &NR::SP::lubksb;
template<> const typename FN<float>::_tridag FN<float>::tridag = &NR::SP::tridag;
template<> const typename FN<float>::_banmul FN<float>::banmul = &NR::SP::banmul;
template<> const typename FN<float>::_bandec FN<float>::bandec = &NR::SP::bandec;
template<> const typename FN<float>::_banbks FN<float>::banbks = &NR::SP::banbks;
template<> const typename FN<float>::_mprove FN<float>::mprove = &NR::SP::mprove;
template<> const typename FN<float>::_svbksb FN<float>::svbksb = &NR::SP::svbksb;
template<> const typename FN<float>::_svdcmp FN<float>::svdcmp = &NR::SP::svdcmp;
template<> const typename FN<float>::_pythag FN<float>::pythag = &NR::SP::pythag;
template<> const typename FN<float>::_cyclic FN<float>::cyclic = &NR::SP::cyclic;
template<> const typename FN<float>::_sprsin FN<float>::sprsin = &NR::SP::sprsin;
template<> const typename FN<float>::_sprsax FN<float>::sprsax = &NR::SP::sprsax;
template<> const typename FN<float>::_sprstx FN<float>::sprstx = &NR::SP::sprstx;
template<> const typename FN<float>::_sprstp FN<float>::sprstp = &NR::SP::sprstp;
template<> const typename FN<float>::_sprspm FN<float>::sprspm = &NR::SP::sprspm;
template<> const typename FN<float>::_sprstm FN<float>::sprstm = &NR::SP::sprstm;
//template<> const typename FN<float>::_linbcg FN<float>::linbcg = &NR::SP::linbcg;
template<> const typename FN<float>::_snrm FN<float>::snrm = &NR::SP::snrm;
template<> const typename FN<float>::_vander FN<float>::vander = &NR::SP::vander;
template<> const typename FN<float>::_toeplz FN<float>::toeplz = &NR::SP::toeplz;
template<> const typename FN<float>::_choldc FN<float>::choldc = &NR::SP::choldc;
template<> const typename FN<float>::_cholsl FN<float>::cholsl = &NR::SP::cholsl;
template<> const typename FN<float>::_qrdcmp FN<float>::qrdcmp = &NR::SP::qrdcmp;
template<> const typename FN<float>::_qrsolv FN<float>::qrsolv = &NR::SP::qrsolv;
template<> const typename FN<float>::_rsolv FN<float>::rsolv = &NR::SP::rsolv;
template<> const typename FN<float>::_qrupdt FN<float>::qrupdt = &NR::SP::qrupdt;
template<> const typename FN<float>::_rotate FN<float>::rotate = &NR::SP::rotate;
		
template<> const typename FN<float>::_polint FN<float>::polint = &NR::SP::polint;
template<> const typename FN<float>::_ratint FN<float>::ratint = &NR::SP::ratint;
template<> const typename FN<float>::_spline FN<float>::spline = &NR::SP::spline;
template<> const typename FN<float>::_splint FN<float>::splint = &NR::SP::splint;
template<> const typename FN<float>::_locate FN<float>::locate = &NR::SP::locate;
template<> const typename FN<float>::_hunt FN<float>::hunt = &NR::SP::hunt;
template<> const typename FN<float>::_polcoe FN<float>::polcoe = &NR::SP::polcoe;
template<> const typename FN<float>::_polcof FN<float>::polcof = &NR::SP::polcof;
template<> const typename FN<float>::_blnint FN<float>::blnint = &NR::SP::blnint;
template<> const typename FN<float>::_polin2 FN<float>::polin2 = &NR::SP::polin2;
template<> const typename FN<float>::_bcucof FN<float>::bcucof = &NR::SP::bcucof;
template<> const typename FN<float>::_bcuint FN<float>::bcuint = &NR::SP::bcuint;
template<> const typename FN<float>::_splie2 FN<float>::splie2 = &NR::SP::splie2;
template<> const typename FN<float>::_splin2 FN<float>::splin2 = &NR::SP::splin2;

template<> const typename FN<float>::_trapzd FN<float>::trapzd = &NR::SP::trapzd;
template<> const typename FN<float>::_qtrap FN<float>::qtrap = &NR::SP::qtrap;

// double precision specialization
template<> const typename FN<double>::_gaussj FN<double>::gaussj = &NR::DP::gaussj;
template<> const typename FN<double>::_ludcmp FN<double>::ludcmp = &NR::DP::ludcmp;
template<> const typename FN<double>::_lubksb FN<double>::lubksb = &NR::DP::lubksb;
template<> const typename FN<double>::_tridag FN<double>::tridag = &NR::DP::tridag;
template<> const typename FN<double>::_banmul FN<double>::banmul = &NR::DP::banmul;
template<> const typename FN<double>::_bandec FN<double>::bandec = &NR::DP::bandec;
template<> const typename FN<double>::_banbks FN<double>::banbks = &NR::DP::banbks;
template<> const typename FN<double>::_mprove FN<double>::mprove = &NR::DP::mprove;
template<> const typename FN<double>::_svbksb FN<double>::svbksb = &NR::DP::svbksb;
template<> const typename FN<double>::_svdcmp FN<double>::svdcmp = &NR::DP::svdcmp;
template<> const typename FN<double>::_pythag FN<double>::pythag = &NR::DP::pythag;
template<> const typename FN<double>::_cyclic FN<double>::cyclic = &NR::DP::cyclic;
template<> const typename FN<double>::_sprsin FN<double>::sprsin = &NR::DP::sprsin;
template<> const typename FN<double>::_sprsax FN<double>::sprsax = &NR::DP::sprsax;
template<> const typename FN<double>::_sprstx FN<double>::sprstx = &NR::DP::sprstx;
template<> const typename FN<double>::_sprstp FN<double>::sprstp = &NR::DP::sprstp;
template<> const typename FN<double>::_sprspm FN<double>::sprspm = &NR::DP::sprspm;
template<> const typename FN<double>::_sprstm FN<double>::sprstm = &NR::DP::sprstm;
//template<> const typename FN<double>::_linbcg FN<double>::linbcg = &NR::DP::linbcg;
template<> const typename FN<double>::_snrm FN<double>::snrm = &NR::DP::snrm;
template<> const typename FN<double>::_vander FN<double>::vander = &NR::DP::vander;
template<> const typename FN<double>::_toeplz FN<double>::toeplz = &NR::DP::toeplz;
template<> const typename FN<double>::_choldc FN<double>::choldc = &NR::DP::choldc;
template<> const typename FN<double>::_cholsl FN<double>::cholsl = &NR::DP::cholsl;
template<> const typename FN<double>::_qrdcmp FN<double>::qrdcmp = &NR::DP::qrdcmp;
template<> const typename FN<double>::_qrsolv FN<double>::qrsolv = &NR::DP::qrsolv;
template<> const typename FN<double>::_rsolv FN<double>::rsolv = &NR::DP::rsolv;
template<> const typename FN<double>::_qrupdt FN<double>::qrupdt = &NR::DP::qrupdt;
template<> const typename FN<double>::_rotate FN<double>::rotate = &NR::DP::rotate;
		
template<> const typename FN<double>::_polint FN<double>::polint = &NR::DP::polint;
template<> const typename FN<double>::_ratint FN<double>::ratint = &NR::DP::ratint;
template<> const typename FN<double>::_spline FN<double>::spline = &NR::DP::spline;
template<> const typename FN<double>::_splint FN<double>::splint = &NR::DP::splint;
template<> const typename FN<double>::_locate FN<double>::locate = &NR::DP::locate;
template<> const typename FN<double>::_hunt FN<double>::hunt = &NR::DP::hunt;
template<> const typename FN<double>::_polcoe FN<double>::polcoe = &NR::DP::polcoe;
template<> const typename FN<double>::_polcof FN<double>::polcof = &NR::DP::polcof;
template<> const typename FN<double>::_blnint FN<double>::blnint = &NR::DP::blnint;
template<> const typename FN<double>::_polin2 FN<double>::polin2 = &NR::DP::polin2;
template<> const typename FN<double>::_bcucof FN<double>::bcucof = &NR::DP::bcucof;
template<> const typename FN<double>::_bcuint FN<double>::bcuint = &NR::DP::bcuint;
template<> const typename FN<double>::_splie2 FN<double>::splie2 = &NR::DP::splie2;
template<> const typename FN<double>::_splin2 FN<double>::splin2 = &NR::DP::splin2;

template<> const typename FN<double>::_trapzd FN<double>::trapzd = &NR::DP::trapzd;
template<> const typename FN<double>::_qtrap FN<double>::qtrap = &NR::DP::qtrap;
*/
} // namespace NR
