#include "MCS_NRGlobals.h"
#include "MCS_NRWrappersDouble.h"
#include "MCS_NumericalRecipes.h"

namespace NR {

// NR Ch 2 Solution of linear algebraic equations
template<> const typename FN<double>::_gaussj FN<double>::gaussj = &NR::DP::gaussj;
template<> const typename FN<double>::_ludcmp FN<double>::ludcmp = &NR::DP::ludcmp;
template<> const typename FN<double>::_lubksb FN<double>::lubksb = &NR::DP::lubksb;
template<> const typename FN<double>::_tridag FN<double>::tridag = &NR::DP::tridag;
template<> const typename FN<double>::_banmul FN<double>::banmul = &NR::DP::banmul;
template<> const typename FN<double>::_bandec FN<double>::bandec = &NR::DP::bandec;
template<> const typename FN<double>::_banbks FN<double>::banbks = &NR::DP::banbks;
template<> const typename FN<double>::_mprove FN<double>::mprove = &NR::DP::mprove;
template<> const typename FN<double>::_svbksb FN<double>::svbksb = &NR::DP::svbksb;
template<> const typename FN<double>::_svdcmp FN<double>::svdcmp = &NR::DP::svdcmp;
template<> const typename FN<double>::_pythag FN<double>::pythag = &NR::DP::pythag;
template<> const typename FN<double>::_cyclic FN<double>::cyclic = &NR::DP::cyclic;
template<> const typename FN<double>::_sprsin FN<double>::sprsin = &NR::DP::sprsin;
template<> const typename FN<double>::_sprsax FN<double>::sprsax = &NR::DP::sprsax;
template<> const typename FN<double>::_sprstx FN<double>::sprstx = &NR::DP::sprstx;
template<> const typename FN<double>::_sprstp FN<double>::sprstp = &NR::DP::sprstp;
template<> const typename FN<double>::_sprspm FN<double>::sprspm = &NR::DP::sprspm;
template<> const typename FN<double>::_sprstm FN<double>::sprstm = &NR::DP::sprstm;
//static const _linbcg linbcg;
template<> const typename FN<double>::_snrm FN<double>::snrm = &NR::DP::snrm;
template<> const typename FN<double>::_vander FN<double>::vander = &NR::DP::vander;
template<> const typename FN<double>::_toeplz FN<double>::toeplz = &NR::DP::toeplz;
template<> const typename FN<double>::_choldc FN<double>::choldc = &NR::DP::choldc;
template<> const typename FN<double>::_cholsl FN<double>::cholsl = &NR::DP::cholsl;
template<> const typename FN<double>::_qrdcmp FN<double>::qrdcmp = &NR::DP::qrdcmp;
template<> const typename FN<double>::_qrsolv FN<double>::qrsolv = &NR::DP::qrsolv;
template<> const typename FN<double>::_rsolv FN<double>::rsolv = &NR::DP::rsolv;
template<> const typename FN<double>::_qrupdt FN<double>::qrupdt = &NR::DP::qrupdt;
template<> const typename FN<double>::_rotate FN<double>::rotate = &NR::DP::rotate;
		
// NR Ch 3 Interpolation and extrapolation
template<> const typename FN<double>::_polint FN<double>::polint = &NR::DP::polint;
template<> const typename FN<double>::_ratint FN<double>::ratint = &NR::DP::ratint;
template<> const typename FN<double>::_spline FN<double>::spline = &NR::DP::spline;
template<> const typename FN<double>::_splint FN<double>::splint = &NR::DP::splint;
template<> const typename FN<double>::_locate FN<double>::locate = &NR::DP::locate;
template<> const typename FN<double>::_hunt FN<double>::hunt = &NR::DP::hunt;
template<> const typename FN<double>::_polcoe FN<double>::polcoe = &NR::DP::polcoe;
template<> const typename FN<double>::_polcof FN<double>::polcof = &NR::DP::polcof;
template<> const typename FN<double>::_blnint FN<double>::blnint = &NR::DP::blnint;
template<> const typename FN<double>::_polin2 FN<double>::polin2 = &NR::DP::polin2;
template<> const typename FN<double>::_bcucof FN<double>::bcucof = &NR::DP::bcucof;
template<> const typename FN<double>::_bcuint FN<double>::bcuint = &NR::DP::bcuint;
template<> const typename FN<double>::_splie2 FN<double>::splie2 = &NR::DP::splie2;
template<> const typename FN<double>::_splin2 FN<double>::splin2 = &NR::DP::splin2;

// NR Ch 4 Integration of functions
template<> const typename FN<double>::_trapzd FN<double>::trapzd = &NR::DP::trapzd;
template<> const typename FN<double>::_qtrap FN<double>::qtrap = &NR::DP::qtrap;
template<> const typename FN<double>::_qtrapr FN<double>::qtrapr = &NR::DP::qtrapr;
template<> const typename FN<double>::_qsimp FN<double>::qsimp = &NR::DP::qsimp;
template<> const typename FN<double>::_qsimpr FN<double>::qsimpr = &NR::DP::qsimpr;
template<> const typename FN<double>::_qromb FN<double>::qromb = &NR::DP::qromb;
template<> const typename FN<double>::_qrombr FN<double>::qrombr = &NR::DP::qrombr;
template<> const typename FN<double>::_midpnt FN<double>::midpnt = &NR::DP::midpnt;
template<> const typename FN<double>::_qromo FN<double>::qromo = &NR::DP::qromo;
template<> const typename FN<double>::_midinf FN<double>::midinf = &NR::DP::midinf;
template<> const typename FN<double>::_midsql FN<double>::midsql = &NR::DP::midsql;
template<> const typename FN<double>::_midsqu FN<double>::midsqu = &NR::DP::midsqu;
template<> const typename FN<double>::_midexp FN<double>::midexp = &NR::DP::midexp;
template<> const typename FN<double>::_qgaus FN<double>::qgaus = &NR::DP::qgaus;
template<> const typename FN<double>::_gauleg FN<double>::gauleg = &NR::DP::gauleg;
template<> const typename FN<double>::_gaulag FN<double>::gaulag = &NR::DP::gaulag;
template<> const typename FN<double>::_gauher FN<double>::gauher = &NR::DP::gauher;
template<> const typename FN<double>::_gaujac FN<double>::gaujac = &NR::DP::gaujac;
template<> const typename FN<double>::_gaucof FN<double>::gaucof = &NR::DP::gaucof;
template<> const typename FN<double>::_orthog FN<double>::orthog = &NR::DP::orthog;
//template<> const typename FN<double>::_quad3d FN<double>::quad3d = &NR::DP::quad3d;
//template<> const typename FN<double>::_f1 FN<double>::f1 = &NR::DP::f1;
//template<> const typename FN<double>::_f2 FN<double>::f2 = &NR::DP::f2;
//template<> const typename FN<double>::_f3 FN<double>::f3 = &NR::DP::f3;
		
// NR Ch 5 Evaluation of functions
template<> const typename FN<double>::_eulsum FN<double>::eulsum = &NR::DP::eulsum;
template<> const typename FN<double>::_ddpoly FN<double>::ddpoly = &NR::DP::ddpoly;
template<> const typename FN<double>::_poldiv FN<double>::poldiv = &NR::DP::poldiv;
template<> const typename FN<double>::_ratval FN<double>::ratval = &NR::DP::ratval;
template<> const typename FN<double>::_dfridr FN<double>::dfridr = &NR::DP::dfridr;
template<> const typename FN<double>::_chebft FN<double>::chebft = &NR::DP::chebft;
template<> const typename FN<double>::_chebev FN<double>::chebev = &NR::DP::chebev;
template<> const typename FN<double>::_chder FN<double>::chder = &NR::DP::chder;
template<> const typename FN<double>::_chint FN<double>::chint = &NR::DP::chint;
template<> const typename FN<double>::_chebpc FN<double>::chebpc = &NR::DP::chebpc;
template<> const typename FN<double>::_pcshft FN<double>::pcshft = &NR::DP::pcshft;
template<> const typename FN<double>::_pccheb FN<double>::pccheb = &NR::DP::pccheb;
template<> const typename FN<double>::_pade FN<double>::pade = &NR::DP::pade;
template<> const typename FN<double>::_ratlsq FN<double>::ratlsq = &NR::DP::ratlsq;

// NR Ch 6 Special functions
template<> const typename FN<double>::_gammln FN<double>::gammln = &NR::DP::gammln;
template<> const typename FN<double>::_factrl FN<double>::factrl = &NR::DP::factrl;
template<> const typename FN<double>::_bico FN<double>::bico = &NR::DP::bico;
template<> const typename FN<double>::_factln FN<double>::factln = &NR::DP::factln;
template<> const typename FN<double>::_beta FN<double>::beta = &NR::DP::beta;
template<> const typename FN<double>::_gammp FN<double>::gammp = &NR::DP::gammp;
template<> const typename FN<double>::_gammq FN<double>::gammq = &NR::DP::gammq;
template<> const typename FN<double>::_gser FN<double>::gser = &NR::DP::gser;
template<> const typename FN<double>::_gcf FN<double>::gcf = &NR::DP::gcf;
template<> const typename FN<double>::_erff FN<double>::erff = &NR::DP::erff;
template<> const typename FN<double>::_erffc FN<double>::erffc = &NR::DP::erffc;
template<> const typename FN<double>::_erfcc FN<double>::erfcc = &NR::DP::erfcc;
template<> const typename FN<double>::_expint FN<double>::expint = &NR::DP::expint;
template<> const typename FN<double>::_ei FN<double>::ei = &NR::DP::ei;
template<> const typename FN<double>::_betai FN<double>::betai = &NR::DP::betai;
template<> const typename FN<double>::_betacf FN<double>::betacf = &NR::DP::betacf;
template<> const typename FN<double>::_bessj0 FN<double>::bessj0 = &NR::DP::bessj0;
template<> const typename FN<double>::_bessy0 FN<double>::bessy0 = &NR::DP::bessy0;
template<> const typename FN<double>::_bessj1 FN<double>::bessj1 = &NR::DP::bessj1;
template<> const typename FN<double>::_bessy1 FN<double>::bessy1 = &NR::DP::bessy1;
template<> const typename FN<double>::_bessy FN<double>::bessy = &NR::DP::bessy;
template<> const typename FN<double>::_bessj FN<double>::bessj = &NR::DP::bessj;
template<> const typename FN<double>::_bessi0 FN<double>::bessi0 = &NR::DP::bessi0;
template<> const typename FN<double>::_bessk0 FN<double>::bessk0 = &NR::DP::bessk0;
template<> const typename FN<double>::_bessi1 FN<double>::bessi1 = &NR::DP::bessi1;
template<> const typename FN<double>::_bessk1 FN<double>::bessk1 = &NR::DP::bessk1;
template<> const typename FN<double>::_bessk FN<double>::bessk = &NR::DP::bessk;
template<> const typename FN<double>::_bessi FN<double>::bessi = &NR::DP::bessi;
template<> const typename FN<double>::_bessjy FN<double>::bessjy = &NR::DP::bessjy;
template<> const typename FN<double>::_beschb FN<double>::beschb = &NR::DP::beschb;
template<> const typename FN<double>::_bessik FN<double>::bessik = &NR::DP::bessik;
template<> const typename FN<double>::_airy FN<double>::airy = &NR::DP::airy;
template<> const typename FN<double>::_sphbes FN<double>::sphbes = &NR::DP::sphbes;
template<> const typename FN<double>::_plgndr FN<double>::plgndr = &NR::DP::plgndr;
template<> const typename FN<double>::_frenel FN<double>::frenel = &NR::DP::frenel;
template<> const typename FN<double>::_cisi FN<double>::cisi = &NR::DP::cisi;
template<> const typename FN<double>::_dawson FN<double>::dawson = &NR::DP::dawson;
template<> const typename FN<double>::_rf FN<double>::rf = &NR::DP::rf;
template<> const typename FN<double>::_rd FN<double>::rd = &NR::DP::rd;
template<> const typename FN<double>::_rj FN<double>::rj = &NR::DP::rj;
template<> const typename FN<double>::_rc FN<double>::rc = &NR::DP::rc;
template<> const typename FN<double>::_ellf FN<double>::ellf = &NR::DP::ellf;
template<> const typename FN<double>::_elle FN<double>::elle = &NR::DP::elle;
template<> const typename FN<double>::_ellpi FN<double>::ellpi = &NR::DP::ellpi;
template<> const typename FN<double>::_sncndn FN<double>::sncndn = &NR::DP::sncndn;
template<> const typename FN<double>::_hypgeo FN<double>::hypgeo = &NR::DP::hypgeo;
template<> const typename FN<double>::_hypser FN<double>::hypser = &NR::DP::hypser;
template<> const typename FN<double>::_hypdrv FN<double>::hypdrv = &NR::DP::hypdrv;

// NR Ch 7 Random numbers
template<> const typename FN<double>::_ran0 FN<double>::ran0 = &NR::DP::ran0;
template<> const typename FN<double>::_ran1 FN<double>::ran1 = &NR::DP::ran1;
template<> const typename FN<double>::_ran2 FN<double>::ran2 = &NR::DP::ran2;
template<> const typename FN<double>::_ran3 FN<double>::ran3 = &NR::DP::ran3;
template<> const typename FN<double>::_expdev FN<double>::expdev = &NR::DP::expdev;
template<> const typename FN<double>::_gasdev FN<double>::gasdev = &NR::DP::gasdev;
template<> const typename FN<double>::_gamdev FN<double>::gamdev = &NR::DP::gamdev;
template<> const typename FN<double>::_poidev FN<double>::poidev = &NR::DP::poidev;
template<> const typename FN<double>::_bnldev FN<double>::bnldev = &NR::DP::bnldev;
template<> const typename FN<double>::_irbit1 FN<double>::irbit1 = &NR::DP::irbit1;
template<> const typename FN<double>::_irbit2 FN<double>::irbit2 = &NR::DP::irbit2;
template<> const typename FN<double>::_psdes FN<double>::psdes = &NR::DP::psdes;
template<> const typename FN<double>::_ran4 FN<double>::ran4 = &NR::DP::ran4;
template<> const typename FN<double>::_sobseq FN<double>::sobseq = &NR::DP::sobseq;
template<> const typename FN<double>::_vegas FN<double>::vegas = &NR::DP::vegas;
template<> const typename FN<double>::_rebin FN<double>::rebin = &NR::DP::rebin;
template<> const typename FN<double>::_miser FN<double>::miser = &NR::DP::miser;
template<> const typename FN<double>::_ranpt FN<double>::ranpt = &NR::DP::ranpt;

// NR Ch 8 Sorting
template<> const typename FN<double>::_piksrt FN<double>::piksrt = &NR::DP::piksrt;
template<> const typename FN<double>::_piksr2 FN<double>::piksr2 = &NR::DP::piksr2;
template<> const typename FN<double>::_shell FN<double>::shell = &NR::DP::shell;
template<> const typename FN<double>::_sort FN<double>::sort = &NR::DP::sort;
template<> const typename FN<double>::_sort2 FN<double>::sort2 = &NR::DP::sort2;
template<> const typename FN<double>::_hpsort FN<double>::hpsort = &NR::DP::hpsort;
template<> const typename FN<double>::_indexx FN<double>::indexx = &NR::DP::indexx;
template<> const typename FN<double>::_iindexx FN<double>::iindexx = &NR::DP::iindexx;
template<> const typename FN<double>::_sort3 FN<double>::sort3 = &NR::DP::sort3;
template<> const typename FN<double>::_rank FN<double>::rank = &NR::DP::rank;
template<> const typename FN<double>::_select FN<double>::select = &NR::DP::select;
template<> const typename FN<double>::_selip FN<double>::selip = &NR::DP::selip;
template<> const typename FN<double>::_hpsel FN<double>::hpsel = &NR::DP::hpsel;
template<> const typename FN<double>::_eclass FN<double>::eclass = &NR::DP::eclass;
template<> const typename FN<double>::_eclazz FN<double>::eclazz = &NR::DP::eclazz;

// NR Ch 9 Root finding and nonlinear sets of equations
template<> const typename FN<double>::_zbrac FN<double>::zbrac = &NR::DP::zbrac;
template<> const typename FN<double>::_zbrak FN<double>::zbrak = &NR::DP::zbrak;
template<> const typename FN<double>::_rtbis FN<double>::rtbis = &NR::DP::rtbis;
template<> const typename FN<double>::_rtflsp FN<double>::rtflsp = &NR::DP::rtflsp;
template<> const typename FN<double>::_rtsec FN<double>::rtsec = &NR::DP::rtsec;
template<> const typename FN<double>::_zriddr FN<double>::zriddr = &NR::DP::zriddr;
template<> const typename FN<double>::_zbrent FN<double>::zbrent = &NR::DP::zbrent;
template<> const typename FN<double>::_rtnewt FN<double>::rtnewt = &NR::DP::rtnewt;
template<> const typename FN<double>::_rtsafe FN<double>::rtsafe = &NR::DP::rtsafe;
template<> const typename FN<double>::_laguer FN<double>::laguer = &NR::DP::laguer;
template<> const typename FN<double>::_zroots FN<double>::zroots = &NR::DP::zroots;
template<> const typename FN<double>::_zrhqr FN<double>::zrhqr = &NR::DP::zrhqr;
template<> const typename FN<double>::_qroot FN<double>::qroot = &NR::DP::qroot;
//template<> const typename FN<double>::_mnewt FN<double>::mnewt = &NR::DP::mnewt;
template<> const typename FN<double>::_lnsrch FN<double>::lnsrch = &NR::DP::lnsrch;
//template<> const typename FN<double>::_newt FN<double>::newt = &NR::DP::newt;
template<> const typename FN<double>::_fdjac FN<double>::fdjac = &NR::DP::fdjac;
//template<> const typename FN<double>::_fmin FN<double>::fmin = &NR::DP::fmin;
//template<> const typename FN<double>::_broydn FN<double>::broydn = &NR::DP::broydn;

// NR Ch 10 Minimization and maximization of functions
template<> const typename FN<double>::_mnbrak FN<double>::mnbrak = &NR::DP::mnbrak;
template<> const typename FN<double>::_golden FN<double>::golden = &NR::DP::golden;
template<> const typename FN<double>::_brent FN<double>::brent = &NR::DP::brent;
template<> const typename FN<double>::_dbrent FN<double>::dbrent = &NR::DP::dbrent;
template<> const typename FN<double>::_amoeba FN<double>::amoeba = &NR::DP::amoeba;
template<> const typename FN<double>::_amotry FN<double>::amotry = &NR::DP::amotry;
//template<> const typename FN<double>::_powell FN<double>::powell = &NR::DP::powell;
//template<> const typename FN<double>::_linmin FN<double>::linmin = &NR::DP::linmin;
//template<> const typename FN<double>::_f1dim FN<double>::f1dim = &NR::DP::f1dim;
//template<> const typename FN<double>::_frprmn FN<double>::frprmn = &NR::DP::frprmn;
//template<> const typename FN<double>::_dlinmin FN<double>::dlinmin = &NR::DP::dlinmin;
//template<> const typename FN<double>::_df1dim FN<double>::df1dim = &NR::DP::df1dim;
template<> const typename FN<double>::_dfpmin FN<double>::dfpmin = &NR::DP::dfpmin;
template<> const typename FN<double>::_simplx FN<double>::simplx = &NR::DP::simplx;
template<> const typename FN<double>::_simp1 FN<double>::simp1 = &NR::DP::simp1;
template<> const typename FN<double>::_simp2 FN<double>::simp2 = &NR::DP::simp2;
template<> const typename FN<double>::_simp3 FN<double>::simp3 = &NR::DP::simp3;
template<> const typename FN<double>::_anneal FN<double>::anneal = &NR::DP::anneal;
template<> const typename FN<double>::_revcst FN<double>::revcst = &NR::DP::revcst;
template<> const typename FN<double>::_reverse FN<double>::reverse = &NR::DP::reverse;
template<> const typename FN<double>::_trncst FN<double>::trncst = &NR::DP::trncst;
template<> const typename FN<double>::_trnspt FN<double>::trnspt = &NR::DP::trnspt;
template<> const typename FN<double>::_metrop FN<double>::metrop = &NR::DP::metrop;
template<> const typename FN<double>::_amebsa FN<double>::amebsa = &NR::DP::amebsa;
template<> const typename FN<double>::_amotsa FN<double>::amotsa = &NR::DP::amotsa;

// NR Ch 11 Eigensystems
template<> const typename FN<double>::_jacobi FN<double>::jacobi = &NR::DP::jacobi;
template<> const typename FN<double>::_eigsrt FN<double>::eigsrt = &NR::DP::eigsrt;
template<> const typename FN<double>::_tred2 FN<double>::tred2 = &NR::DP::tred2;
template<> const typename FN<double>::_tqli FN<double>::tqli = &NR::DP::tqli;
template<> const typename FN<double>::_balanc FN<double>::balanc = &NR::DP::balanc;
template<> const typename FN<double>::_elmhes FN<double>::elmhes = &NR::DP::elmhes;
template<> const typename FN<double>::_hqr FN<double>::hqr = &NR::DP::hqr;

// NR Ch 12 Fast Fourier transform
template<> const typename FN<double>::_four1 FN<double>::four1 = &NR::DP::four1;
template<> const typename FN<double>::_twofft FN<double>::twofft = &NR::DP::twofft;
template<> const typename FN<double>::_realft FN<double>::realft = &NR::DP::realft;
template<> const typename FN<double>::_sinft FN<double>::sinft = &NR::DP::sinft;
template<> const typename FN<double>::_cosft1 FN<double>::cosft1 = &NR::DP::cosft1;
template<> const typename FN<double>::_cosft2 FN<double>::cosft2 = &NR::DP::cosft2;
template<> const typename FN<double>::_fourn FN<double>::fourn = &NR::DP::fourn;
template<> const typename FN<double>::_rlft3 FN<double>::rlft3 = &NR::DP::rlft3;
template<> const typename FN<double>::_fourfs FN<double>::fourfs = &NR::DP::fourfs;
template<> const typename FN<double>::_fourew FN<double>::fourew = &NR::DP::fourew;

// NR Ch 13 Fourier and spectral applications
template<> const typename FN<double>::_convlv FN<double>::convlv = &NR::DP::convlv;
template<> const typename FN<double>::_correl FN<double>::correl = &NR::DP::correl;
template<> const typename FN<double>::_spctrm FN<double>::spctrm = &NR::DP::spctrm;
template<> const typename FN<double>::_memcof FN<double>::memcof = &NR::DP::memcof;
template<> const typename FN<double>::_fixrts FN<double>::fixrts = &NR::DP::fixrts;
template<> const typename FN<double>::_predic FN<double>::predic = &NR::DP::predic;
template<> const typename FN<double>::_evlmem FN<double>::evlmem = &NR::DP::evlmem;
template<> const typename FN<double>::_period FN<double>::period = &NR::DP::period;
template<> const typename FN<double>::_fasper FN<double>::fasper = &NR::DP::fasper;
template<> const typename FN<double>::_spread FN<double>::spread = &NR::DP::spread;
template<> const typename FN<double>::_dftcor FN<double>::dftcor = &NR::DP::dftcor;
template<> const typename FN<double>::_dftint FN<double>::dftint = &NR::DP::dftint;
template<> const typename FN<double>::_wt1 FN<double>::wt1 = &NR::DP::wt1;
template<> const typename FN<double>::_daub4 FN<double>::daub4 = &NR::DP::daub4;
template<> const typename FN<double>::_pwtset FN<double>::pwtset = &NR::DP::pwtset;
template<> const typename FN<double>::_pwt FN<double>::pwt = &NR::DP::pwt;
template<> const typename FN<double>::_wtn FN<double>::wtn = &NR::DP::wtn;

// NR 14 Statistical description of data
template<> const typename FN<double>::_moment FN<double>::moment = &NR::DP::moment;
template<> const typename FN<double>::_ttest FN<double>::ttest = &NR::DP::ttest;
template<> const typename FN<double>::_avevar FN<double>::avevar = &NR::DP::avevar;
template<> const typename FN<double>::_tutest FN<double>::tutest = &NR::DP::tutest;
template<> const typename FN<double>::_tptest FN<double>::tptest = &NR::DP::tptest;
template<> const typename FN<double>::_ftest FN<double>::ftest = &NR::DP::ftest;
template<> const typename FN<double>::_chsone FN<double>::chsone = &NR::DP::chsone;
template<> const typename FN<double>::_chstwo FN<double>::chstwo = &NR::DP::chstwo;
template<> const typename FN<double>::_ksone FN<double>::ksone = &NR::DP::ksone;
template<> const typename FN<double>::_kstwo FN<double>::kstwo = &NR::DP::kstwo;
template<> const typename FN<double>::_probks FN<double>::probks = &NR::DP::probks;
template<> const typename FN<double>::_cntab1 FN<double>::cntab1 = &NR::DP::cntab1;
template<> const typename FN<double>::_cntab2 FN<double>::cntab2 = &NR::DP::cntab2;
template<> const typename FN<double>::_pearsn FN<double>::pearsn = &NR::DP::pearsn;
template<> const typename FN<double>::_spear FN<double>::spear = &NR::DP::spear;
template<> const typename FN<double>::_crank FN<double>::crank = &NR::DP::crank;
template<> const typename FN<double>::_kendl1 FN<double>::kendl1 = &NR::DP::kendl1;
template<> const typename FN<double>::_kendl2 FN<double>::kendl2 = &NR::DP::kendl2;
template<> const typename FN<double>::_ks2d1s FN<double>::ks2d1s = &NR::DP::ks2d1s;
template<> const typename FN<double>::_quadct FN<double>::quadct = &NR::DP::quadct;
template<> const typename FN<double>::_quadvl FN<double>::quadvl = &NR::DP::quadvl;
template<> const typename FN<double>::_ks2d2s FN<double>::ks2d2s = &NR::DP::ks2d2s;
template<> const typename FN<double>::_savgol FN<double>::savgol = &NR::DP::savgol;

// NR Ch 15 Modeling of data
template<> const typename FN<double>::_fit FN<double>::fit = &NR::DP::fit;
template<> const typename FN<double>::_fitexy FN<double>::fitexy = &NR::DP::fitexy;
template<> const typename FN<double>::_chixy FN<double>::chixy = &NR::DP::chixy;
template<> const typename FN<double>::_lfit FN<double>::lfit = &NR::DP::lfit;
template<> const typename FN<double>::_covsrt FN<double>::covsrt = &NR::DP::covsrt;
template<> const typename FN<double>::_svdfit FN<double>::svdfit = &NR::DP::svdfit;
template<> const typename FN<double>::_svdfitm FN<double>::svdfitm = &NR::DP::svdfitm;
template<> const typename FN<double>::_svdvar FN<double>::svdvar = &NR::DP::svdvar;
template<> const typename FN<double>::_fpoly FN<double>::fpoly = &NR::DP::fpoly;
template<> const typename FN<double>::_fleg FN<double>::fleg = &NR::DP::fleg;
template<> const typename FN<double>::_mrqmin FN<double>::mrqmin = &NR::DP::mrqmin;
template<> const typename FN<double>::_mrqcof FN<double>::mrqcof = &NR::DP::mrqcof;
template<> const typename FN<double>::_fgauss FN<double>::fgauss = &NR::DP::fgauss;
template<> const typename FN<double>::_medfit FN<double>::medfit = &NR::DP::medfit;
template<> const typename FN<double>::_rofunc FN<double>::rofunc = &NR::DP::rofunc;

// NR Ch 16 Integration of ordinary differential equations
template<> const typename FN<double>::_rk4 FN<double>::rk4 = &NR::DP::rk4;
template<> const typename FN<double>::_rkdumb FN<double>::rkdumb = &NR::DP::rkdumb;
template<> const typename FN<double>::_rkqs FN<double>::rkqs = &NR::DP::rkqs;
template<> const typename FN<double>::_rkck FN<double>::rkck = &NR::DP::rkck;
template<> const typename FN<double>::_odeint FN<double>::odeint = &NR::DP::odeint;
template<> const typename FN<double>::_mmid FN<double>::mmid = &NR::DP::mmid;
template<> const typename FN<double>::_bsstep FN<double>::bsstep = &NR::DP::bsstep;
template<> const typename FN<double>::_pzextr FN<double>::pzextr = &NR::DP::pzextr;
template<> const typename FN<double>::_rzextr FN<double>::rzextr = &NR::DP::rzextr;
template<> const typename FN<double>::_stoerm FN<double>::stoerm = &NR::DP::stoerm;
template<> const typename FN<double>::_stiff FN<double>::stiff = &NR::DP::stiff;
template<> const typename FN<double>::_jacobn FN<double>::jacobn = &NR::DP::jacobn;
template<> const typename FN<double>::_derivs FN<double>::derivs = &NR::DP::derivs;
template<> const typename FN<double>::_simpr FN<double>::simpr = &NR::DP::simpr;
template<> const typename FN<double>::_stifbs FN<double>::stifbs = &NR::DP::stifbs;

// NR Ch 17 Two point boundary value problems
//template<> const typename FN<double>::_shoot FN<double>::shoot = &NR::DP::shoot;
//template<> const typename FN<double>::_shootf FN<double>::shootf = &NR::DP::shootf;
//template<> const typename FN<double>::_solvde FN<double>::solvde = &NR::DP::solvde;
template<> const typename FN<double>::_bksub FN<double>::bksub = &NR::DP::bksub;
template<> const typename FN<double>::_pinvs FN<double>::pinvs = &NR::DP::pinvs;
template<> const typename FN<double>::_red FN<double>::red = &NR::DP::red;

// NR Ch 18 Integral equations and inverse theory
template<> const typename FN<double>::_fred2 FN<double>::fred2 = &NR::DP::fred2;
template<> const typename FN<double>::_fredin FN<double>::fredin = &NR::DP::fredin;
template<> const typename FN<double>::_voltra FN<double>::voltra = &NR::DP::voltra;

// NR Ch 19 Partial differential equations
template<> const typename FN<double>::_sor FN<double>::sor = &NR::DP::sor;
template<> const typename FN<double>::_mglin FN<double>::mglin = &NR::DP::mglin;
template<> const typename FN<double>::_rstrct FN<double>::rstrct = &NR::DP::rstrct;
template<> const typename FN<double>::_interp FN<double>::interp = &NR::DP::interp;
template<> const typename FN<double>::_addint FN<double>::addint = &NR::DP::addint;
template<> const typename FN<double>::_slvsml FN<double>::slvsml = &NR::DP::slvsml;
template<> const typename FN<double>::_relax FN<double>::relax = &NR::DP::relax;
template<> const typename FN<double>::_resid FN<double>::resid = &NR::DP::resid;
template<> const typename FN<double>::_copy FN<double>::copy = &NR::DP::copy;
template<> const typename FN<double>::_fill0 FN<double>::fill0 = &NR::DP::fill0;
template<> const typename FN<double>::_mgfas FN<double>::mgfas = &NR::DP::mgfas;
template<> const typename FN<double>::_relax2 FN<double>::relax2 = &NR::DP::relax2;
template<> const typename FN<double>::_slvsm2 FN<double>::slvsm2 = &NR::DP::slvsm2;
template<> const typename FN<double>::_lop FN<double>::lop = &NR::DP::lop;
template<> const typename FN<double>::_matadd FN<double>::matadd = &NR::DP::matadd;
template<> const typename FN<double>::_matsub FN<double>::matsub = &NR::DP::matsub;
template<> const typename FN<double>::_anorm2 FN<double>::anorm2 = &NR::DP::anorm2;

// NR Ch 20 Less numerical algorithms
template<> const typename FN<double>::_machar FN<double>::machar = &NR::DP::machar;
template<> const typename FN<double>::_igray FN<double>::igray = &NR::DP::igray;
template<> const typename FN<double>::_icrc1 FN<double>::icrc1 = &NR::DP::icrc1;
template<> const typename FN<double>::_icrc FN<double>::icrc = &NR::DP::icrc;
template<> const typename FN<double>::_decchk FN<double>::decchk = &NR::DP::decchk;
template<> const typename FN<double>::_hufmak FN<double>::hufmak = &NR::DP::hufmak;
template<> const typename FN<double>::_hufapp FN<double>::hufapp = &NR::DP::hufapp;
template<> const typename FN<double>::_hufenc FN<double>::hufenc = &NR::DP::hufenc;
template<> const typename FN<double>::_hufdec FN<double>::hufdec = &NR::DP::hufdec;
template<> const typename FN<double>::_arcmak FN<double>::arcmak = &NR::DP::arcmak;
template<> const typename FN<double>::_arcode FN<double>::arcode = &NR::DP::arcode;
template<> const typename FN<double>::_arcsum FN<double>::arcsum = &NR::DP::arcsum;
template<> const typename FN<double>::_mpadd FN<double>::mpadd = &NR::DP::mpadd;
template<> const typename FN<double>::_mpsub FN<double>::mpsub = &NR::DP::mpsub;
template<> const typename FN<double>::_mpsad FN<double>::mpsad = &NR::DP::mpsad;
template<> const typename FN<double>::_mpsmu FN<double>::mpsmu = &NR::DP::mpsmu;
template<> const typename FN<double>::_mpsdv FN<double>::mpsdv = &NR::DP::mpsdv;
template<> const typename FN<double>::_mpneg FN<double>::mpneg = &NR::DP::mpneg;
template<> const typename FN<double>::_mpmov FN<double>::mpmov = &NR::DP::mpmov;
template<> const typename FN<double>::_mplsh FN<double>::mplsh = &NR::DP::mplsh;
template<> const typename FN<double>::_mpmul FN<double>::mpmul = &NR::DP::mpmul;
template<> const typename FN<double>::_mpinv FN<double>::mpinv = &NR::DP::mpinv;
template<> const typename FN<double>::_mpdiv FN<double>::mpdiv = &NR::DP::mpdiv;
template<> const typename FN<double>::_mpsqrt FN<double>::mpsqrt = &NR::DP::mpsqrt;
template<> const typename FN<double>::_mp2dfr FN<double>::mp2dfr = &NR::DP::mp2dfr;
template<> const typename FN<double>::_mppi FN<double>::mppi = &NR::DP::mppi;

} // namespace NR
