#include "MCS_NRGlobals.h"
#include "MCS_NRWrappersFloat.h"
#include "MCS_NumericalRecipes.h"

namespace NR {

// NR Ch 2 Solution of linear algebraic equations
template<> const typename FN<float>::_gaussj FN<float>::gaussj = &NR::SP::gaussj;
template<> const typename FN<float>::_ludcmp FN<float>::ludcmp = &NR::SP::ludcmp;
template<> const typename FN<float>::_lubksb FN<float>::lubksb = &NR::SP::lubksb;
template<> const typename FN<float>::_tridag FN<float>::tridag = &NR::SP::tridag;
template<> const typename FN<float>::_banmul FN<float>::banmul = &NR::SP::banmul;
template<> const typename FN<float>::_bandec FN<float>::bandec = &NR::SP::bandec;
template<> const typename FN<float>::_banbks FN<float>::banbks = &NR::SP::banbks;
template<> const typename FN<float>::_mprove FN<float>::mprove = &NR::SP::mprove;
template<> const typename FN<float>::_svbksb FN<float>::svbksb = &NR::SP::svbksb;
template<> const typename FN<float>::_svdcmp FN<float>::svdcmp = &NR::SP::svdcmp;
template<> const typename FN<float>::_pythag FN<float>::pythag = &NR::SP::pythag;
template<> const typename FN<float>::_cyclic FN<float>::cyclic = &NR::SP::cyclic;
template<> const typename FN<float>::_sprsin FN<float>::sprsin = &NR::SP::sprsin;
template<> const typename FN<float>::_sprsax FN<float>::sprsax = &NR::SP::sprsax;
template<> const typename FN<float>::_sprstx FN<float>::sprstx = &NR::SP::sprstx;
template<> const typename FN<float>::_sprstp FN<float>::sprstp = &NR::SP::sprstp;
template<> const typename FN<float>::_sprspm FN<float>::sprspm = &NR::SP::sprspm;
template<> const typename FN<float>::_sprstm FN<float>::sprstm = &NR::SP::sprstm;
//static const _linbcg linbcg;
template<> const typename FN<float>::_snrm FN<float>::snrm = &NR::SP::snrm;
template<> const typename FN<float>::_vander FN<float>::vander = &NR::SP::vander;
template<> const typename FN<float>::_toeplz FN<float>::toeplz = &NR::SP::toeplz;
template<> const typename FN<float>::_choldc FN<float>::choldc = &NR::SP::choldc;
template<> const typename FN<float>::_cholsl FN<float>::cholsl = &NR::SP::cholsl;
template<> const typename FN<float>::_qrdcmp FN<float>::qrdcmp = &NR::SP::qrdcmp;
template<> const typename FN<float>::_qrsolv FN<float>::qrsolv = &NR::SP::qrsolv;
template<> const typename FN<float>::_rsolv FN<float>::rsolv = &NR::SP::rsolv;
template<> const typename FN<float>::_qrupdt FN<float>::qrupdt = &NR::SP::qrupdt;
template<> const typename FN<float>::_rotate FN<float>::rotate = &NR::SP::rotate;
		
// NR Ch 3 Interpolation and extrapolation
template<> const typename FN<float>::_polint FN<float>::polint = &NR::SP::polint;
template<> const typename FN<float>::_ratint FN<float>::ratint = &NR::SP::ratint;
template<> const typename FN<float>::_spline FN<float>::spline = &NR::SP::spline;
template<> const typename FN<float>::_splint FN<float>::splint = &NR::SP::splint;
template<> const typename FN<float>::_locate FN<float>::locate = &NR::SP::locate;
template<> const typename FN<float>::_hunt FN<float>::hunt = &NR::SP::hunt;
template<> const typename FN<float>::_polcoe FN<float>::polcoe = &NR::SP::polcoe;
template<> const typename FN<float>::_polcof FN<float>::polcof = &NR::SP::polcof;
template<> const typename FN<float>::_blnint FN<float>::blnint = &NR::SP::blnint;
template<> const typename FN<float>::_polin2 FN<float>::polin2 = &NR::SP::polin2;
template<> const typename FN<float>::_bcucof FN<float>::bcucof = &NR::SP::bcucof;
template<> const typename FN<float>::_bcuint FN<float>::bcuint = &NR::SP::bcuint;
template<> const typename FN<float>::_splie2 FN<float>::splie2 = &NR::SP::splie2;
template<> const typename FN<float>::_splin2 FN<float>::splin2 = &NR::SP::splin2;

// NR Ch 4 Integration of functions
template<> const typename FN<float>::_trapzd FN<float>::trapzd = &NR::SP::trapzd;
template<> const typename FN<float>::_qtrap FN<float>::qtrap = &NR::SP::qtrap;
template<> const typename FN<float>::_qtrapr FN<float>::qtrapr = &NR::SP::qtrapr;
template<> const typename FN<float>::_qsimp FN<float>::qsimp = &NR::SP::qsimp;
template<> const typename FN<float>::_qsimpr FN<float>::qsimpr = &NR::SP::qsimpr;
template<> const typename FN<float>::_qromb FN<float>::qromb = &NR::SP::qromb;
template<> const typename FN<float>::_qrombr FN<float>::qrombr = &NR::SP::qrombr;
template<> const typename FN<float>::_midpnt FN<float>::midpnt = &NR::SP::midpnt;
template<> const typename FN<float>::_qromo FN<float>::qromo = &NR::SP::qromo;
template<> const typename FN<float>::_midinf FN<float>::midinf = &NR::SP::midinf;
template<> const typename FN<float>::_midsql FN<float>::midsql = &NR::SP::midsql;
template<> const typename FN<float>::_midsqu FN<float>::midsqu = &NR::SP::midsqu;
template<> const typename FN<float>::_midexp FN<float>::midexp = &NR::SP::midexp;
template<> const typename FN<float>::_qgaus FN<float>::qgaus = &NR::SP::qgaus;
template<> const typename FN<float>::_gauleg FN<float>::gauleg = &NR::SP::gauleg;
template<> const typename FN<float>::_gaulag FN<float>::gaulag = &NR::SP::gaulag;
template<> const typename FN<float>::_gauher FN<float>::gauher = &NR::SP::gauher;
template<> const typename FN<float>::_gaujac FN<float>::gaujac = &NR::SP::gaujac;
template<> const typename FN<float>::_gaucof FN<float>::gaucof = &NR::SP::gaucof;
template<> const typename FN<float>::_orthog FN<float>::orthog = &NR::SP::orthog;
//template<> const typename FN<float>::_quad3d FN<float>::quad3d = &NR::SP::quad3d;
//template<> const typename FN<float>::_f1 FN<float>::f1 = &NR::SP::f1;
//template<> const typename FN<float>::_f2 FN<float>::f2 = &NR::SP::f2;
//template<> const typename FN<float>::_f3 FN<float>::f3 = &NR::SP::f3;
		
// NR Ch 5 Evaluation of functions
template<> const typename FN<float>::_eulsum FN<float>::eulsum = &NR::SP::eulsum;
template<> const typename FN<float>::_ddpoly FN<float>::ddpoly = &NR::SP::ddpoly;
template<> const typename FN<float>::_poldiv FN<float>::poldiv = &NR::SP::poldiv;
template<> const typename FN<float>::_ratval FN<float>::ratval = &NR::SP::ratval;
template<> const typename FN<float>::_dfridr FN<float>::dfridr = &NR::SP::dfridr;
template<> const typename FN<float>::_chebft FN<float>::chebft = &NR::SP::chebft;
template<> const typename FN<float>::_chebev FN<float>::chebev = &NR::SP::chebev;
template<> const typename FN<float>::_chder FN<float>::chder = &NR::SP::chder;
template<> const typename FN<float>::_chint FN<float>::chint = &NR::SP::chint;
template<> const typename FN<float>::_chebpc FN<float>::chebpc = &NR::SP::chebpc;
template<> const typename FN<float>::_pcshft FN<float>::pcshft = &NR::SP::pcshft;
template<> const typename FN<float>::_pccheb FN<float>::pccheb = &NR::SP::pccheb;
template<> const typename FN<float>::_pade FN<float>::pade = &NR::SP::pade;
template<> const typename FN<float>::_ratlsq FN<float>::ratlsq = &NR::SP::ratlsq;

// NR Ch 6 Special functions
template<> const typename FN<float>::_gammln FN<float>::gammln = &NR::SP::gammln;
template<> const typename FN<float>::_factrl FN<float>::factrl = &NR::SP::factrl;
template<> const typename FN<float>::_bico FN<float>::bico = &NR::SP::bico;
template<> const typename FN<float>::_factln FN<float>::factln = &NR::SP::factln;
template<> const typename FN<float>::_beta FN<float>::beta = &NR::SP::beta;
template<> const typename FN<float>::_gammp FN<float>::gammp = &NR::SP::gammp;
template<> const typename FN<float>::_gammq FN<float>::gammq = &NR::SP::gammq;
template<> const typename FN<float>::_gser FN<float>::gser = &NR::SP::gser;
template<> const typename FN<float>::_gcf FN<float>::gcf = &NR::SP::gcf;
template<> const typename FN<float>::_erff FN<float>::erff = &NR::SP::erff;
template<> const typename FN<float>::_erffc FN<float>::erffc = &NR::SP::erffc;
template<> const typename FN<float>::_erfcc FN<float>::erfcc = &NR::SP::erfcc;
template<> const typename FN<float>::_expint FN<float>::expint = &NR::SP::expint;
template<> const typename FN<float>::_ei FN<float>::ei = &NR::SP::ei;
template<> const typename FN<float>::_betai FN<float>::betai = &NR::SP::betai;
template<> const typename FN<float>::_betacf FN<float>::betacf = &NR::SP::betacf;
template<> const typename FN<float>::_bessj0 FN<float>::bessj0 = &NR::SP::bessj0;
template<> const typename FN<float>::_bessy0 FN<float>::bessy0 = &NR::SP::bessy0;
template<> const typename FN<float>::_bessj1 FN<float>::bessj1 = &NR::SP::bessj1;
template<> const typename FN<float>::_bessy1 FN<float>::bessy1 = &NR::SP::bessy1;
template<> const typename FN<float>::_bessy FN<float>::bessy = &NR::SP::bessy;
template<> const typename FN<float>::_bessj FN<float>::bessj = &NR::SP::bessj;
template<> const typename FN<float>::_bessi0 FN<float>::bessi0 = &NR::SP::bessi0;
template<> const typename FN<float>::_bessk0 FN<float>::bessk0 = &NR::SP::bessk0;
template<> const typename FN<float>::_bessi1 FN<float>::bessi1 = &NR::SP::bessi1;
template<> const typename FN<float>::_bessk1 FN<float>::bessk1 = &NR::SP::bessk1;
template<> const typename FN<float>::_bessk FN<float>::bessk = &NR::SP::bessk;
template<> const typename FN<float>::_bessi FN<float>::bessi = &NR::SP::bessi;
template<> const typename FN<float>::_bessjy FN<float>::bessjy = &NR::SP::bessjy;
template<> const typename FN<float>::_beschb FN<float>::beschb = &NR::SP::beschb;
template<> const typename FN<float>::_bessik FN<float>::bessik = &NR::SP::bessik;
template<> const typename FN<float>::_airy FN<float>::airy = &NR::SP::airy;
template<> const typename FN<float>::_sphbes FN<float>::sphbes = &NR::SP::sphbes;
template<> const typename FN<float>::_plgndr FN<float>::plgndr = &NR::SP::plgndr;
template<> const typename FN<float>::_frenel FN<float>::frenel = &NR::SP::frenel;
template<> const typename FN<float>::_cisi FN<float>::cisi = &NR::SP::cisi;
template<> const typename FN<float>::_dawson FN<float>::dawson = &NR::SP::dawson;
template<> const typename FN<float>::_rf FN<float>::rf = &NR::SP::rf;
template<> const typename FN<float>::_rd FN<float>::rd = &NR::SP::rd;
template<> const typename FN<float>::_rj FN<float>::rj = &NR::SP::rj;
template<> const typename FN<float>::_rc FN<float>::rc = &NR::SP::rc;
template<> const typename FN<float>::_ellf FN<float>::ellf = &NR::SP::ellf;
template<> const typename FN<float>::_elle FN<float>::elle = &NR::SP::elle;
template<> const typename FN<float>::_ellpi FN<float>::ellpi = &NR::SP::ellpi;
template<> const typename FN<float>::_sncndn FN<float>::sncndn = &NR::SP::sncndn;
template<> const typename FN<float>::_hypgeo FN<float>::hypgeo = &NR::SP::hypgeo;
template<> const typename FN<float>::_hypser FN<float>::hypser = &NR::SP::hypser;
template<> const typename FN<float>::_hypdrv FN<float>::hypdrv = &NR::SP::hypdrv;

// NR Ch 7 Random numbers
template<> const typename FN<float>::_ran0 FN<float>::ran0 = &NR::SP::ran0;
template<> const typename FN<float>::_ran1 FN<float>::ran1 = &NR::SP::ran1;
template<> const typename FN<float>::_ran2 FN<float>::ran2 = &NR::SP::ran2;
template<> const typename FN<float>::_ran3 FN<float>::ran3 = &NR::SP::ran3;
template<> const typename FN<float>::_expdev FN<float>::expdev = &NR::SP::expdev;
template<> const typename FN<float>::_gasdev FN<float>::gasdev = &NR::SP::gasdev;
template<> const typename FN<float>::_gamdev FN<float>::gamdev = &NR::SP::gamdev;
template<> const typename FN<float>::_poidev FN<float>::poidev = &NR::SP::poidev;
template<> const typename FN<float>::_bnldev FN<float>::bnldev = &NR::SP::bnldev;
template<> const typename FN<float>::_irbit1 FN<float>::irbit1 = &NR::SP::irbit1;
template<> const typename FN<float>::_irbit2 FN<float>::irbit2 = &NR::SP::irbit2;
template<> const typename FN<float>::_psdes FN<float>::psdes = &NR::SP::psdes;
template<> const typename FN<float>::_ran4 FN<float>::ran4 = &NR::SP::ran4;
template<> const typename FN<float>::_sobseq FN<float>::sobseq = &NR::SP::sobseq;
template<> const typename FN<float>::_vegas FN<float>::vegas = &NR::SP::vegas;
template<> const typename FN<float>::_rebin FN<float>::rebin = &NR::SP::rebin;
template<> const typename FN<float>::_miser FN<float>::miser = &NR::SP::miser;
template<> const typename FN<float>::_ranpt FN<float>::ranpt = &NR::SP::ranpt;

// NR Ch 8 Sorting
template<> const typename FN<float>::_piksrt FN<float>::piksrt = &NR::SP::piksrt;
template<> const typename FN<float>::_piksr2 FN<float>::piksr2 = &NR::SP::piksr2;
template<> const typename FN<float>::_shell FN<float>::shell = &NR::SP::shell;
template<> const typename FN<float>::_sort FN<float>::sort = &NR::SP::sort;
template<> const typename FN<float>::_sort2 FN<float>::sort2 = &NR::SP::sort2;
template<> const typename FN<float>::_hpsort FN<float>::hpsort = &NR::SP::hpsort;
template<> const typename FN<float>::_indexx FN<float>::indexx = &NR::SP::indexx;
template<> const typename FN<float>::_iindexx FN<float>::iindexx = &NR::SP::iindexx;
template<> const typename FN<float>::_sort3 FN<float>::sort3 = &NR::SP::sort3;
template<> const typename FN<float>::_rank FN<float>::rank = &NR::SP::rank;
template<> const typename FN<float>::_select FN<float>::select = &NR::SP::select;
template<> const typename FN<float>::_selip FN<float>::selip = &NR::SP::selip;
template<> const typename FN<float>::_hpsel FN<float>::hpsel = &NR::SP::hpsel;
template<> const typename FN<float>::_eclass FN<float>::eclass = &NR::SP::eclass;
template<> const typename FN<float>::_eclazz FN<float>::eclazz = &NR::SP::eclazz;

// NR Ch 9 Root finding and nonlinear sets of equations
template<> const typename FN<float>::_zbrac FN<float>::zbrac = &NR::SP::zbrac;
template<> const typename FN<float>::_zbrak FN<float>::zbrak = &NR::SP::zbrak;
template<> const typename FN<float>::_rtbis FN<float>::rtbis = &NR::SP::rtbis;
template<> const typename FN<float>::_rtflsp FN<float>::rtflsp = &NR::SP::rtflsp;
template<> const typename FN<float>::_rtsec FN<float>::rtsec = &NR::SP::rtsec;
template<> const typename FN<float>::_zriddr FN<float>::zriddr = &NR::SP::zriddr;
template<> const typename FN<float>::_zbrent FN<float>::zbrent = &NR::SP::zbrent;
template<> const typename FN<float>::_rtnewt FN<float>::rtnewt = &NR::SP::rtnewt;
template<> const typename FN<float>::_rtsafe FN<float>::rtsafe = &NR::SP::rtsafe;
template<> const typename FN<float>::_laguer FN<float>::laguer = &NR::SP::laguer;
template<> const typename FN<float>::_zroots FN<float>::zroots = &NR::SP::zroots;
template<> const typename FN<float>::_zrhqr FN<float>::zrhqr = &NR::SP::zrhqr;
template<> const typename FN<float>::_qroot FN<float>::qroot = &NR::SP::qroot;
//template<> const typename FN<float>::_mnewt FN<float>::mnewt = &NR::SP::mnewt;
template<> const typename FN<float>::_lnsrch FN<float>::lnsrch = &NR::SP::lnsrch;
//template<> const typename FN<float>::_newt FN<float>::newt = &NR::SP::newt;
template<> const typename FN<float>::_fdjac FN<float>::fdjac = &NR::SP::fdjac;
//template<> const typename FN<float>::_fmin FN<float>::fmin = &NR::SP::fmin;
//template<> const typename FN<float>::_broydn FN<float>::broydn = &NR::SP::broydn;

// NR Ch 10 Minimization and maximization of functions
template<> const typename FN<float>::_mnbrak FN<float>::mnbrak = &NR::SP::mnbrak;
template<> const typename FN<float>::_golden FN<float>::golden = &NR::SP::golden;
template<> const typename FN<float>::_brent FN<float>::brent = &NR::SP::brent;
template<> const typename FN<float>::_dbrent FN<float>::dbrent = &NR::SP::dbrent;
template<> const typename FN<float>::_amoeba FN<float>::amoeba = &NR::SP::amoeba;
template<> const typename FN<float>::_amotry FN<float>::amotry = &NR::SP::amotry;
//template<> const typename FN<float>::_powell FN<float>::powell = &NR::SP::powell;
//template<> const typename FN<float>::_linmin FN<float>::linmin = &NR::SP::linmin;
//template<> const typename FN<float>::_f1dim FN<float>::f1dim = &NR::SP::f1dim;
//template<> const typename FN<float>::_frprmn FN<float>::frprmn = &NR::SP::frprmn;
//template<> const typename FN<float>::_dlinmin FN<float>::dlinmin = &NR::SP::dlinmin;
//template<> const typename FN<float>::_df1dim FN<float>::df1dim = &NR::SP::df1dim;
template<> const typename FN<float>::_dfpmin FN<float>::dfpmin = &NR::SP::dfpmin;
template<> const typename FN<float>::_simplx FN<float>::simplx = &NR::SP::simplx;
template<> const typename FN<float>::_simp1 FN<float>::simp1 = &NR::SP::simp1;
template<> const typename FN<float>::_simp2 FN<float>::simp2 = &NR::SP::simp2;
template<> const typename FN<float>::_simp3 FN<float>::simp3 = &NR::SP::simp3;
template<> const typename FN<float>::_anneal FN<float>::anneal = &NR::SP::anneal;
template<> const typename FN<float>::_revcst FN<float>::revcst = &NR::SP::revcst;
template<> const typename FN<float>::_reverse FN<float>::reverse = &NR::SP::reverse;
template<> const typename FN<float>::_trncst FN<float>::trncst = &NR::SP::trncst;
template<> const typename FN<float>::_trnspt FN<float>::trnspt = &NR::SP::trnspt;
template<> const typename FN<float>::_metrop FN<float>::metrop = &NR::SP::metrop;
template<> const typename FN<float>::_amebsa FN<float>::amebsa = &NR::SP::amebsa;
template<> const typename FN<float>::_amotsa FN<float>::amotsa = &NR::SP::amotsa;

// NR Ch 11 Eigensystems
template<> const typename FN<float>::_jacobi FN<float>::jacobi = &NR::SP::jacobi;
template<> const typename FN<float>::_eigsrt FN<float>::eigsrt = &NR::SP::eigsrt;
template<> const typename FN<float>::_tred2 FN<float>::tred2 = &NR::SP::tred2;
template<> const typename FN<float>::_tqli FN<float>::tqli = &NR::SP::tqli;
template<> const typename FN<float>::_balanc FN<float>::balanc = &NR::SP::balanc;
template<> const typename FN<float>::_elmhes FN<float>::elmhes = &NR::SP::elmhes;
template<> const typename FN<float>::_hqr FN<float>::hqr = &NR::SP::hqr;

// NR Ch 12 Fast Fourier transform
template<> const typename FN<float>::_four1 FN<float>::four1 = &NR::SP::four1;
template<> const typename FN<float>::_twofft FN<float>::twofft = &NR::SP::twofft;
template<> const typename FN<float>::_realft FN<float>::realft = &NR::SP::realft;
template<> const typename FN<float>::_sinft FN<float>::sinft = &NR::SP::sinft;
template<> const typename FN<float>::_cosft1 FN<float>::cosft1 = &NR::SP::cosft1;
template<> const typename FN<float>::_cosft2 FN<float>::cosft2 = &NR::SP::cosft2;
template<> const typename FN<float>::_fourn FN<float>::fourn = &NR::SP::fourn;
template<> const typename FN<float>::_rlft3 FN<float>::rlft3 = &NR::SP::rlft3;
template<> const typename FN<float>::_fourfs FN<float>::fourfs = &NR::SP::fourfs;
template<> const typename FN<float>::_fourew FN<float>::fourew = &NR::SP::fourew;

// NR Ch 13 Fourier and spectral applications
template<> const typename FN<float>::_convlv FN<float>::convlv = &NR::SP::convlv;
template<> const typename FN<float>::_correl FN<float>::correl = &NR::SP::correl;
template<> const typename FN<float>::_spctrm FN<float>::spctrm = &NR::SP::spctrm;
template<> const typename FN<float>::_memcof FN<float>::memcof = &NR::SP::memcof;
template<> const typename FN<float>::_fixrts FN<float>::fixrts = &NR::SP::fixrts;
template<> const typename FN<float>::_predic FN<float>::predic = &NR::SP::predic;
template<> const typename FN<float>::_evlmem FN<float>::evlmem = &NR::SP::evlmem;
template<> const typename FN<float>::_period FN<float>::period = &NR::SP::period;
template<> const typename FN<float>::_fasper FN<float>::fasper = &NR::SP::fasper;
template<> const typename FN<float>::_spread FN<float>::spread = &NR::SP::spread;
template<> const typename FN<float>::_dftcor FN<float>::dftcor = &NR::SP::dftcor;
template<> const typename FN<float>::_dftint FN<float>::dftint = &NR::SP::dftint;
template<> const typename FN<float>::_wt1 FN<float>::wt1 = &NR::SP::wt1;
template<> const typename FN<float>::_daub4 FN<float>::daub4 = &NR::SP::daub4;
template<> const typename FN<float>::_pwtset FN<float>::pwtset = &NR::SP::pwtset;
template<> const typename FN<float>::_pwt FN<float>::pwt = &NR::SP::pwt;
template<> const typename FN<float>::_wtn FN<float>::wtn = &NR::SP::wtn;

// NR 14 Statistical description of data
template<> const typename FN<float>::_moment FN<float>::moment = &NR::SP::moment;
template<> const typename FN<float>::_ttest FN<float>::ttest = &NR::SP::ttest;
template<> const typename FN<float>::_avevar FN<float>::avevar = &NR::SP::avevar;
template<> const typename FN<float>::_tutest FN<float>::tutest = &NR::SP::tutest;
template<> const typename FN<float>::_tptest FN<float>::tptest = &NR::SP::tptest;
template<> const typename FN<float>::_ftest FN<float>::ftest = &NR::SP::ftest;
template<> const typename FN<float>::_chsone FN<float>::chsone = &NR::SP::chsone;
template<> const typename FN<float>::_chstwo FN<float>::chstwo = &NR::SP::chstwo;
template<> const typename FN<float>::_ksone FN<float>::ksone = &NR::SP::ksone;
template<> const typename FN<float>::_kstwo FN<float>::kstwo = &NR::SP::kstwo;
template<> const typename FN<float>::_probks FN<float>::probks = &NR::SP::probks;
template<> const typename FN<float>::_cntab1 FN<float>::cntab1 = &NR::SP::cntab1;
template<> const typename FN<float>::_cntab2 FN<float>::cntab2 = &NR::SP::cntab2;
template<> const typename FN<float>::_pearsn FN<float>::pearsn = &NR::SP::pearsn;
template<> const typename FN<float>::_spear FN<float>::spear = &NR::SP::spear;
template<> const typename FN<float>::_crank FN<float>::crank = &NR::SP::crank;
template<> const typename FN<float>::_kendl1 FN<float>::kendl1 = &NR::SP::kendl1;
template<> const typename FN<float>::_kendl2 FN<float>::kendl2 = &NR::SP::kendl2;
template<> const typename FN<float>::_ks2d1s FN<float>::ks2d1s = &NR::SP::ks2d1s;
template<> const typename FN<float>::_quadct FN<float>::quadct = &NR::SP::quadct;
template<> const typename FN<float>::_quadvl FN<float>::quadvl = &NR::SP::quadvl;
template<> const typename FN<float>::_ks2d2s FN<float>::ks2d2s = &NR::SP::ks2d2s;
template<> const typename FN<float>::_savgol FN<float>::savgol = &NR::SP::savgol;

// NR Ch 15 Modeling of data
template<> const typename FN<float>::_fit FN<float>::fit = &NR::SP::fit;
template<> const typename FN<float>::_fitexy FN<float>::fitexy = &NR::SP::fitexy;
template<> const typename FN<float>::_chixy FN<float>::chixy = &NR::SP::chixy;
template<> const typename FN<float>::_lfit FN<float>::lfit = &NR::SP::lfit;
template<> const typename FN<float>::_covsrt FN<float>::covsrt = &NR::SP::covsrt;
template<> const typename FN<float>::_svdfit FN<float>::svdfit = &NR::SP::svdfit;
template<> const typename FN<float>::_svdfitm FN<float>::svdfitm = &NR::SP::svdfitm;
template<> const typename FN<float>::_svdvar FN<float>::svdvar = &NR::SP::svdvar;
template<> const typename FN<float>::_fpoly FN<float>::fpoly = &NR::SP::fpoly;
template<> const typename FN<float>::_fleg FN<float>::fleg = &NR::SP::fleg;
template<> const typename FN<float>::_mrqmin FN<float>::mrqmin = &NR::SP::mrqmin;
template<> const typename FN<float>::_mrqcof FN<float>::mrqcof = &NR::SP::mrqcof;
template<> const typename FN<float>::_fgauss FN<float>::fgauss = &NR::SP::fgauss;
template<> const typename FN<float>::_medfit FN<float>::medfit = &NR::SP::medfit;
template<> const typename FN<float>::_rofunc FN<float>::rofunc = &NR::SP::rofunc;

// NR Ch 16 Integration of ordinary differential equations
template<> const typename FN<float>::_rk4 FN<float>::rk4 = &NR::SP::rk4;
template<> const typename FN<float>::_rkdumb FN<float>::rkdumb = &NR::SP::rkdumb;
template<> const typename FN<float>::_rkqs FN<float>::rkqs = &NR::SP::rkqs;
template<> const typename FN<float>::_rkck FN<float>::rkck = &NR::SP::rkck;
template<> const typename FN<float>::_odeint FN<float>::odeint = &NR::SP::odeint;
template<> const typename FN<float>::_mmid FN<float>::mmid = &NR::SP::mmid;
template<> const typename FN<float>::_bsstep FN<float>::bsstep = &NR::SP::bsstep;
template<> const typename FN<float>::_pzextr FN<float>::pzextr = &NR::SP::pzextr;
template<> const typename FN<float>::_rzextr FN<float>::rzextr = &NR::SP::rzextr;
template<> const typename FN<float>::_stoerm FN<float>::stoerm = &NR::SP::stoerm;
template<> const typename FN<float>::_stiff FN<float>::stiff = &NR::SP::stiff;
template<> const typename FN<float>::_jacobn FN<float>::jacobn = &NR::SP::jacobn;
template<> const typename FN<float>::_derivs FN<float>::derivs = &NR::SP::derivs;
template<> const typename FN<float>::_simpr FN<float>::simpr = &NR::SP::simpr;
template<> const typename FN<float>::_stifbs FN<float>::stifbs = &NR::SP::stifbs;

// NR Ch 17 Two point boundary value problems
//template<> const typename FN<float>::_shoot FN<float>::shoot = &NR::SP::shoot;
//template<> const typename FN<float>::_shootf FN<float>::shootf = &NR::SP::shootf;
//template<> const typename FN<float>::_solvde FN<float>::solvde = &NR::SP::solvde;
template<> const typename FN<float>::_bksub FN<float>::bksub = &NR::SP::bksub;
template<> const typename FN<float>::_pinvs FN<float>::pinvs = &NR::SP::pinvs;
template<> const typename FN<float>::_red FN<float>::red = &NR::SP::red;

// NR Ch 18 Integral equations and inverse theory
template<> const typename FN<float>::_fred2 FN<float>::fred2 = &NR::SP::fred2;
template<> const typename FN<float>::_fredin FN<float>::fredin = &NR::SP::fredin;
template<> const typename FN<float>::_voltra FN<float>::voltra = &NR::SP::voltra;

// NR Ch 19 Partial differential equations
template<> const typename FN<float>::_sor FN<float>::sor = &NR::SP::sor;
template<> const typename FN<float>::_mglin FN<float>::mglin = &NR::SP::mglin;
template<> const typename FN<float>::_rstrct FN<float>::rstrct = &NR::SP::rstrct;
template<> const typename FN<float>::_interp FN<float>::interp = &NR::SP::interp;
template<> const typename FN<float>::_addint FN<float>::addint = &NR::SP::addint;
template<> const typename FN<float>::_slvsml FN<float>::slvsml = &NR::SP::slvsml;
template<> const typename FN<float>::_relax FN<float>::relax = &NR::SP::relax;
template<> const typename FN<float>::_resid FN<float>::resid = &NR::SP::resid;
template<> const typename FN<float>::_copy FN<float>::copy = &NR::SP::copy;
template<> const typename FN<float>::_fill0 FN<float>::fill0 = &NR::SP::fill0;
template<> const typename FN<float>::_mgfas FN<float>::mgfas = &NR::SP::mgfas;
template<> const typename FN<float>::_relax2 FN<float>::relax2 = &NR::SP::relax2;
template<> const typename FN<float>::_slvsm2 FN<float>::slvsm2 = &NR::SP::slvsm2;
template<> const typename FN<float>::_lop FN<float>::lop = &NR::SP::lop;
template<> const typename FN<float>::_matadd FN<float>::matadd = &NR::SP::matadd;
template<> const typename FN<float>::_matsub FN<float>::matsub = &NR::SP::matsub;
template<> const typename FN<float>::_anorm2 FN<float>::anorm2 = &NR::SP::anorm2;

// NR Ch 20 Less numerical algorithms
template<> const typename FN<float>::_machar FN<float>::machar = &NR::SP::machar;
template<> const typename FN<float>::_igray FN<float>::igray = &NR::SP::igray;
template<> const typename FN<float>::_icrc1 FN<float>::icrc1 = &NR::SP::icrc1;
template<> const typename FN<float>::_icrc FN<float>::icrc = &NR::SP::icrc;
template<> const typename FN<float>::_decchk FN<float>::decchk = &NR::SP::decchk;
template<> const typename FN<float>::_hufmak FN<float>::hufmak = &NR::SP::hufmak;
template<> const typename FN<float>::_hufapp FN<float>::hufapp = &NR::SP::hufapp;
template<> const typename FN<float>::_hufenc FN<float>::hufenc = &NR::SP::hufenc;
template<> const typename FN<float>::_hufdec FN<float>::hufdec = &NR::SP::hufdec;
template<> const typename FN<float>::_arcmak FN<float>::arcmak = &NR::SP::arcmak;
template<> const typename FN<float>::_arcode FN<float>::arcode = &NR::SP::arcode;
template<> const typename FN<float>::_arcsum FN<float>::arcsum = &NR::SP::arcsum;
template<> const typename FN<float>::_mpadd FN<float>::mpadd = &NR::SP::mpadd;
template<> const typename FN<float>::_mpsub FN<float>::mpsub = &NR::SP::mpsub;
template<> const typename FN<float>::_mpsad FN<float>::mpsad = &NR::SP::mpsad;
template<> const typename FN<float>::_mpsmu FN<float>::mpsmu = &NR::SP::mpsmu;
template<> const typename FN<float>::_mpsdv FN<float>::mpsdv = &NR::SP::mpsdv;
template<> const typename FN<float>::_mpneg FN<float>::mpneg = &NR::SP::mpneg;
template<> const typename FN<float>::_mpmov FN<float>::mpmov = &NR::SP::mpmov;
template<> const typename FN<float>::_mplsh FN<float>::mplsh = &NR::SP::mplsh;
template<> const typename FN<float>::_mpmul FN<float>::mpmul = &NR::SP::mpmul;
template<> const typename FN<float>::_mpinv FN<float>::mpinv = &NR::SP::mpinv;
template<> const typename FN<float>::_mpdiv FN<float>::mpdiv = &NR::SP::mpdiv;
template<> const typename FN<float>::_mpsqrt FN<float>::mpsqrt = &NR::SP::mpsqrt;
template<> const typename FN<float>::_mp2dfr FN<float>::mp2dfr = &NR::SP::mp2dfr;
template<> const typename FN<float>::_mppi FN<float>::mppi = &NR::SP::mppi;

} // namespace NR
