//#define DEBUG
#ifndef DEBUG
	#include "MCS_Headers++.h"
#else
	#include <MSLHeaders++.h>
	
	#include "MCS_Vector.h"
	#include "MCS_Matrix.h"
	
	#include "NR.h"
#endif

using namespace NR;

VF32 NR::Gaussian_Smooth(const VF32& y,Float32 sigma)
{
	try
	{
		v_idx	new_dim = 0;
		
		for (v_idx i=0;i<32;i++)
			if (SPL::powers_of_two[i] >= y.dim())
			{
				new_dim = SPL::powers_of_two[i+1];
				break;
			}
				
		if (new_dim < y.dim()) throw Err(__FILE__,__LINE__);
				
		Vector<float>	pad(v_range(new_dim-y.dim())),
						yin(y);
						
		yin.append(pad);
		
		Vector<float>	kern(yin.range());
		
		for (v_idx i=kern.first();i<=kern.last();i++)
		{
			float	t1 = exp(-0.5*sqr((i-kern.first())/sigma)),
					t2 = exp(-0.5*sqr((kern.last()-i)/sigma));
					
			kern[i] = t1+t2;
		}
		
		kern /= sum(kern);
		
		return SPL::conv(yin,kern)[y.range()];
	}
	catch (VM::Err&)
	{
		throw Err(__FILE__,__LINE__);
	}
}