template<class T> Vector<bool> Median_Filter(const Vector<T>& data,Float64 nsigma)
{ 
	if (nsigma <= 0) throw Err(__FILE__,__LINE__);
	
	VM::OperationFlags	opf;
	
	opf.ignoreNaN(true);
	
	T	med = median(data,opf),
		iqr = IQR(data,opf);
	
	return (abs(data-med) >= nsigma*iqr/2.0); 
}
