//#define DEBUG
#ifndef DEBUG
	#include "MCS_Headers++.h"
#else
	#include <MSLHeaders++.h>
	
	#include "MCS_Vector.h"
	#include "MCS_Matrix.h"
	
	#include "NR.h"
#endif

using namespace NR;

void NR::spread(Float64 y,VF64& yy,Float64 x,v_idx m)
{
	static const Vector<int> nfac(v_range(11),"0 1 1 2 6 24 120 720 5040 40320 362880");
	
	try
	{
		VF64::Offset	yy_offs(yy,1);
			
		long 		ihi,ilo,ix,j,nden;
		Float64 	fac;

		v_idx	n = yy.dim();
		
		if (m > 10) throw Err(__FILE__,__LINE__);
		
		ix=static_cast<long>(x);
		
		if (x == static_cast<Float64>(ix)) 
			yy[ix] += y;
		else 
		{
			ilo=min(max(static_cast<long>(x-0.5*m+1.0),static_cast<long>(1)),static_cast<long>(n-m+1));
			ihi=ilo+m-1;
			nden=nfac[m];
			fac=x-ilo;
			
			for (j=ilo+1;j<=ihi;j++) 
				fac *= (x-j);
				
			yy[ihi] += y*fac/(nden*(x-ihi));
			
			for (j=ihi-1;j>=ilo;j--) 
			{
				nden *= (static_cast<Float64>(j-ihi)/(j+1-ilo));
				yy[j] += y*fac/(nden*(x-j));
			}
		}
	}
	catch (VM::Err&)
	{
		throw Err(__FILE__,__LINE__);
	}
}
