#ifndef MCS_SATELLITEORBIT_H
#define MCS_SATELLITEORBIT_H

#include "MCS_SatelliteDataset.h"

namespace mcs {

namespace sat {

// comparison operators
template<class DS> bool operator==(const Orbit<DS>& lhs,const Date& rhs)		{ return lhs.startDate() <= rhs && lhs.endDate() >= rhs; }
template<class DS> bool operator!=(const Orbit<DS>& lhs,const Date& rhs)		{ return !operator==(lhs,rhs); }
template<class DS> bool operator<(const Orbit<DS>& lhs,const Date& rhs)			{ return lhs.endDate() < rhs; }
template<class DS> bool operator<=(const Orbit<DS>& lhs,const Date& rhs)		{ return lhs.startDate() <= rhs; }
template<class DS> bool operator>(const Orbit<DS>& lhs,const Date& rhs)			{ return lhs.startDate() > rhs; }
template<class DS> bool operator>=(const Orbit<DS>& lhs,const Date& rhs)		{ return lhs.endDate() >= rhs; }
			  		  
template<class DS> bool operator==(const Date& lhs,const Orbit<DS>& rhs)		{ return rhs.startDate() <= lhs && rhs.endDate() >= lhs; }
template<class DS> bool operator!=(const Date& lhs,const Orbit<DS>& rhs)		{ return !operator==(lhs,rhs); }
template<class DS> bool operator<(const Date& lhs,const Orbit<DS>& rhs)			{ return lhs < rhs.startDate(); }
template<class DS> bool operator<=(const Date& lhs,const Orbit<DS>& rhs)		{ return lhs <= rhs.endDate(); }
template<class DS> bool operator>(const Date& lhs,const Orbit<DS>& rhs)			{ return lhs > rhs.endDate(); }
template<class DS> bool operator>=(const Date& lhs,const Orbit<DS>& rhs)		{ return lhs >= rhs.startDate(); }
			  		  
template<class DS> bool operator==(const Orbit<DS>& lhs,const Orbit<DS>& rhs);
template<class DS> bool operator!=(const Orbit<DS>& lhs,const Orbit<DS>& rhs);
template<class DS> bool operator<(const Orbit<DS>& lhs,const Orbit<DS>& rhs);
template<class DS> bool operator<=(const Orbit<DS>& lhs,const Orbit<DS>& rhs);
template<class DS> bool operator>(const Orbit<DS>& lhs,const Orbit<DS>& rhs);
template<class DS> bool operator>=(const Orbit<DS>& lhs,const Orbit<DS>& rhs);

} // namespace sat

} // namespace mcs

#endif // MCS_SATELLITEORBIT_H