#include "MCS_MSUConstants.h"

namespace mcs {

namespace sat {

namespace msu {

const Int32	NUM_CHANNELS = 4,
			NUM_FOVS = 11,
			NUM_VIEW_ANGLES = 5,
			NUM_SCAN_POSITIONS = 14,
			NUM_SATELLITES = 9,
			SUBTRACK = 6,
			SPACE_COUNTS_INDEX = 12,
			BLACKBODY_COUNTS_INDEX = 13,
			SCAN_COUNTS_INDEX = 14,	
			MIN_COUNTS = 1,
			MAX_COUNTS = 4094,
			FOV_FLAG_OFFSET = 15;
			
const Float32	SCAN_TIME = 25.6;
				
const Vector<Float64>	NADIR_ANGLES(IndexRange<1>(1,NUM_FOVS),
										"  47.370  37.896  28.422  18.948   9.474   0.000  "
										"   9.474  18.948  28.422  37.896  47.370  "),
						INCIDENCE_ANGLES(IndexRange<1>(1,NUM_FOVS),
										" 56.19 43.91 32.51 21.51 10.71 0.0 "
										" 10.71 21.51 32.51 43.91 56.19 ");		
			
} // namespace msu

} // namespace sat
		
} // namespace mcs
