#ifndef MCS_MSUCONSTANTS_H
#define MCS_MSUCONSTANTS_H

#include "MCS_Vector.h"

namespace mcs {

namespace sat {

namespace msu {

enum SatelliteNumber
{
	TIROS_N = 1,
	NOAA_06,
	NOAA_07,
	NOAA_08,
	NOAA_09,
	NOAA_10,
	NOAA_11,
	NOAA_12,
	NOAA_14
};

enum ChannelNumber { CH_1 = 1,CH_2,CH_3,CH_4 };

enum FOVNumber { FOV_1 = 1,FOV_2,FOV_3,FOV_4,FOV_5,FOV_6,FOV_7,FOV_8,FOV_9,FOV_10,FOV_11 };

extern const Int32	NUM_CHANNELS,
					NUM_FOVS,
					NUM_VIEW_ANGLES,
					NUM_SCAN_POSITIONS,
					NUM_SATELLITES,
					SUBTRACK,
					SPACE_COUNTS_INDEX,
					BLACKBODY_COUNTS_INDEX,
					SCAN_COUNTS_INDEX,	
					MIN_COUNTS,
					MAX_COUNTS,
					FOV_FLAG_OFFSET;
					
extern const Float32	SCAN_TIME;
				
extern const Vector<Float64>	NADIR_ANGLES,
								INCIDENCE_ANGLES;

} // namespace msu

} // namespace sat
		
} // namespace mcs

#endif // MCS_MSUCONSTANTS_H
