#ifndef MCS_MSUGEOLOCATION_H
#define MCS_MSUGEOLOCATION_H

#include "MCS_BasicGeolocation.h"
#include "MCS_GeographicCoordinates.h"
#include "MCS_MSUDataset.h"

namespace mcs {

namespace sat {

// MSU SatelliteGeolocation specialization
template<class Lev,class Ver> 
class SatelliteGeolocation< Dataset< MSU<SwathData,Lev,Ver> > > : 
	public BasicGeolocation
{
	public:
		typedef Dataset< MSU<SwathData,Lev,Ver> >	DatasetType;
		
	protected:
		SatelliteGeolocation();
		SatelliteGeolocation(const SatelliteGeolocation<DatasetType>& source);
		~SatelliteGeolocation() { }
		
		template<class Lev2,class Ver2> SatelliteGeolocation(const SatelliteGeolocation< Dataset< MSU<SwathData,Lev2,Ver2> > >& geoloc);

	private:
		SatelliteGeolocation<DatasetType>& operator=(const SatelliteGeolocation<DatasetType>&);
};

template<class Lev,class Ver> 
inline SatelliteGeolocation< Dataset< MSU<SwathData,Lev,Ver> > >::SatelliteGeolocation() : 
	BasicGeolocation(DatasetType::numberOfFOVs())
{ }

template<class Lev,class Ver> 
inline SatelliteGeolocation< Dataset< MSU<SwathData,Lev,Ver> > >::SatelliteGeolocation(const SatelliteGeolocation<DatasetType>& source) : 
	BasicGeolocation(source)
{ }

template<class Lev,class Ver> 
template<class Lev2,class Ver2>
inline SatelliteGeolocation< Dataset< MSU<SwathData,Lev,Ver> > >::SatelliteGeolocation(const SatelliteGeolocation< Dataset< MSU<SwathData,Lev2,Ver2> > >& geoloc) : 
	BasicGeolocation(geoloc)
{ }

} // namespace sat

} // namespace mcs

#endif // MCS_MSUGEOLOCATION_H
