#ifndef MCS_VECTORINDIRECTION_H
#define MCS_VECTORINDIRECTION_H

#include "MCS_Typedefs.h"
#include "MCS_Vector.h"

namespace mcs {

// vector indirection class
class VectorIndirection : public Vector< Int32 >
{
	public:
		VectorIndirection(const IndexRange<1>& = IndexRange<1>());
		VectorIndirection(const IndexRange<1>&,const Int32&);
		VectorIndirection(const IndexRange<1>&,const std::string&);
		VectorIndirection(const VectorIndirection&);
		~VectorIndirection();
		
		VectorIndirection& operator=(const VectorIndirection&);
};

inline VectorIndirection::VectorIndirection(const IndexRange<1>& rng) :
	Vector< Int32 >(rng)
{ }

inline VectorIndirection::VectorIndirection(const IndexRange<1>& rng,const Int32& val) :
	Vector< Int32 >(rng,val)
{ }

inline VectorIndirection::VectorIndirection(const IndexRange<1>& rng,const std::string& str) :
	Vector< Int32 >(rng,str)
{ }

inline VectorIndirection::VectorIndirection(const VectorIndirection& source) :
	Vector< Int32 >(source)
{ }

inline VectorIndirection::~VectorIndirection()
{ }

inline VectorIndirection& VectorIndirection::operator=(const VectorIndirection& source)
{
	if (this == &source) return *this;

	Vector< Int32 >::operator=(source);
		
	return *this;
}

} // namespace mcs

#endif // MCS_VECTORINDIRECTION_H