#ifndef MCS_VECTORSTATISTICSINTELSPECIALIZED_H
#define MCS_VECTORSTATISTICSINTELSPECIALIZED_H

#include "MCS_Vector.h"

#include "MCS_IntelNSP.h"

#if USE_INTEL_SPL

namespace mcs {

namespace statistics {

template<> inline Float32 max(const Vector<Float32>& source)
{ 
	if (source.isValid()) 	
		return nspsMax(reinterpret_cast<Float32*>(source.dataPointer()),source.dim()); 
	else
		return NAN;
}

template<> inline Float64 max(const Vector<Float64>& source)
{ 
	if (source.isValid()) 	
		return nspdMax(reinterpret_cast<Float64*>(source.dataPointer()),source.dim());
	else
		return NAN;
}

template<> inline Float32 min(const Vector<Float32>& source)
{ 
	if (source.isValid()) 	
		return nspsMin(reinterpret_cast<Float32*>(source.dataPointer()),int(source.dim())); 
	else
		return NAN;
}

template<> inline Float64 min(const Vector<Float64>& source)
{ 
	if (source.isValid()) 	
		return nspdMin(reinterpret_cast<Float64*>(source.dataPointer()),int(source.dim())); 
	else
		return NAN;
}

template<> inline Float32 mean(const Vector<Float32>& source)
{ 
	if (source.isValid()) 	
		return nspsMean(reinterpret_cast<Float32*>(source.dataPointer()),int(source.dim())); 
	else
		return NAN;
}

template<> inline Float64 mean(const Vector<Float64>& source)
{ 
	if (source.isValid()) 	
		return nspdMean(reinterpret_cast<Float64*>(source.dataPointer()),int(source.dim())); 
	else
		return NAN;
}

} // namespace statistics

} // namespace mcs

#endif // USE_INTEL_SPL

#endif // MCS_VECTORSTATISTICSINTELSPECIALIZED_H