!@***p* MLT_RSS/MSU_L1B_ingest_driver.f90
!  NAME
!    MSU_L1B_ingest_driver

!  PURPOSE
!    Top level driver program for converting MSU L1B files from NOAA CLASS to
!    RSS MSU L1B format
!
!  DESCRIPTION
!    Top level driver program for converting MSU L1B files from NOAA CLASS to
!    RSS MSU L1B format.  Takes the location of these files as the command line 
!    parameter
!
!  INPUT
!     from command line:
!     string containing the path name for the location of the CLASS L1B files
!
!  AUTHOR
!    Carl Mears, Remote Sensing Systems
!
! COPYRIGHT
!   THIS SOFTWARE AND ITS DOCUMENTATION ARE COPYRIGHT 2012 REMOTE SENSING SYSTEMS.
!   THEY ARE PROVIDED FOR INFORMATIONAL AND ALGORITHM VERIFICATION PURPOSES ONLY
!   AND MAY NOT BE USED IN WHOLE OR IN PART FOR ANY OTHER PURPOSE WITHOUT WRITTEN
!   PERMISSION FROM REMOTE SENSING SYSTEMS.  THEY ARE FURNISHED "AS IS." THE
!   AUTHORS, THE UNITED STATES GOVERNMENT, ITS INSTRUMENTALITIES, OFFICERS, EMPLOYEES,
!   AND AGENTS MAKE NO WARRANTY, EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE
!   SOFTWARE AND DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
!   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL SUPPORT
!   TO USERS.
!
!  HISTORY
!    2/21/2012 Initial Version prepared for NCDC
!
!  USAGE
!    (on command line)
!    msu_l1b_ingest_driver  c:\MSU_L1B\NOAA-06\
!
!@*****	

program msu_l1b_ingest_driver

		use MSU_L1B_ingest
		use DFLIB

		type(msu_inventory_str)				:: msu_inventory
		logical								:: wrt
		integer(4):: error

		character(len=120)		:: buffer



		character(len=FILE_LEN)	:: MSU_INCOMING_PATH 

		wrt = .true.  ! set to true to write out results
		buffer = ''
		error = 0
		call getarg(1,buffer,error)
		MSU_INCOMING_PATH = trim(buffer)
		
		if (error .ne. 0) stop
		
		call ingest_msu_l1b(MSU_INCOMING_PATH,wrt)


	end program msu_l1b_ingest_driver