$freeform
module expand_to_bits


contains


	subroutine expand_int_2(i,iarr)
! @***h* MLT_RSS/expand_to_bits.f90
!  NAME
!    expand_int_2
!
!  PURPOSE
!    converts a 2 byte integer to its bitwize representation
!
!
!  INPUTS
!    integer(2)            :: i
!
!  OUTPUTS
!    integer(2),dimension(16) :: iarr

!
!  AUTHOR
!    Carl Mears, Remote Sensing Systems
!
! COPYRIGHT
!   THIS SOFTWARE AND ITS DOCUMENTATION ARE COPYRIGHT 2012 REMOTE SENSING SYSTEMS.
!   THEY ARE PROVIDED FOR INFORMATIONAL AND ALGORITHM VERIFICATION PURPOSES ONLY
!   AND MAY NOT BE USED IN WHOLE OR IN PART FOR ANY OTHER PURPOSE WITHOUT WRITTEN
!   PERMISSION FROM REMOTE SENSING SYSTEMS.  THEY ARE FURNISHED "AS IS." THE
!   AUTHORS, THE UNITED STATES GOVERNMENT, ITS INSTRUMENTALITIES, OFFICERS, EMPLOYEES,
!   AND AGENTS MAKE NO WARRANTY, EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE
!   SOFTWARE AND DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
!   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL SUPPORT
!   TO USERS.
!
!  HISTORY
!    9/18/2012 Initial Version prepared for NCDC
!
!  USAGE
!    call expand_int_2(i,iarr)
!
! @*****
		integer(2)					:: i
		integer(2),dimension(16)	:: iarr

		integer(2)					:: j


		iarr = 0

		do j = 0,15
			if (btest(i,j)) iarr(j+1) = 1
		enddo

	end subroutine expand_int_2

	subroutine expand_int_4(i,iarr)
! @***h* MLT_RSS/expand_to_bits.f90
!  NAME
!    expand_int_4
!
!  PURPOSE
!    converts a 4 byte integer to its bitwize representation
!
!
!  INPUTS
!    integer(4)            :: i
!
!  OUTPUTS
!    integer(2),dimension(32) :: iarr

!
!  AUTHOR
!    Carl Mears, Remote Sensing Systems
!
! COPYRIGHT
!   THIS SOFTWARE AND ITS DOCUMENTATION ARE COPYRIGHT 2012 REMOTE SENSING SYSTEMS.
!   THEY ARE PROVIDED FOR INFORMATIONAL AND ALGORITHM VERIFICATION PURPOSES ONLY
!   AND MAY NOT BE USED IN WHOLE OR IN PART FOR ANY OTHER PURPOSE WITHOUT WRITTEN
!   PERMISSION FROM REMOTE SENSING SYSTEMS.  THEY ARE FURNISHED "AS IS." THE
!   AUTHORS, THE UNITED STATES GOVERNMENT, ITS INSTRUMENTALITIES, OFFICERS, EMPLOYEES,
!   AND AGENTS MAKE NO WARRANTY, EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE
!   SOFTWARE AND DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
!   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL SUPPORT
!   TO USERS.
!
!  HISTORY
!    9/18/2012 Initial Version prepared for NCDC
!
!  USAGE
!    call expand_int_2(i,iarr)
!
! @*****
		integer(4)					:: i
		integer(4),dimension(32)	:: iarr

		integer(2)					:: j


		iarr = 0

		do j = 0,31
			if (btest(i,j)) iarr(j+1) = 1
		enddo

	end subroutine expand_int_4

end module expand_to_bits




			