$freeform
module get_file_list

	use portlib

contains

	subroutine get_files_in_path(path,max_files,num_files,file_list,error)
! @***h* MLT_RSS/get_files_list.f90
!  NAME
!    get_files_in_path
!
!  PURPOSE
!    retrieves a list of all file names in a folder
!
!  DESCRIPTION
!    retrieves a list of all file names in a folder
!
!  INPUTS
!    character(len=120)          :: path       ! name of folder to evaluate
!    integer(4)            :: max_files  ! array to be sorted
!
!  OUTPUTS
!    integer(4)                       :: num_files  !number of files in path
!    character(len=120),dimension(:)  :: file_list  !list of file names
!    integer(4)                       :: error      !error flag.  0 means everything OK

!
!  AUTHOR
!    Carl Mears, Remote Sensing Systems
!
! COPYRIGHT
!   THIS SOFTWARE AND ITS DOCUMENTATION ARE COPYRIGHT 2012 REMOTE SENSING SYSTEMS.
!   THEY ARE PROVIDED FOR INFORMATIONAL AND ALGORITHM VERIFICATION PURPOSES ONLY
!   AND MAY NOT BE USED IN WHOLE OR IN PART FOR ANY OTHER PURPOSE WITHOUT WRITTEN
!   PERMISSION FROM REMOTE SENSING SYSTEMS.  THEY ARE FURNISHED "AS IS." THE
!   AUTHORS, THE UNITED STATES GOVERNMENT, ITS INSTRUMENTALITIES, OFFICERS, EMPLOYEES,
!   AND AGENTS MAKE NO WARRANTY, EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE
!   SOFTWARE AND DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
!   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL SUPPORT
!   TO USERS.
!
!  HISTORY
!    9/18/2012 Initial Version prepared for NCDC
!
!  USAGE
!    call get_files_in_path(path,max_files,num_files,file_list,error)
!
! @*****
		character(len = 120)					:: path
		integer(4)								:: max_files
		integer(4)								:: num_files
		character(len = 120),dimension(:)		:: file_list
		integer(4)								:: error

		character(len = 120)					:: command
		integer(4)								:: result

		! create command to put directory in tmp.txt
        print *,path
		command = 'dir ' // trim(path) // ' /b > c:\dirtemp.txt'
		print *,command
		result = system(command)
		print *, result
		call sleepqq(1000)

		if (result .eq. 0) then

			open(unit = 3,file = 'c:\dirtemp.txt')

			do j = 1,MAX_FILES !max_files in in the MSU_L1B_Ingest module
				read(3,100,end=999) file_list(j)
100				format(a120)
			enddo

			close(3)

999			command = 'del c:\dirtemp.txt'
			result = system(command)

			num_files = j-1

			

			return

		endif
		
		num_files = 0
		error = -1
		
		return

	end subroutine get_files_in_path

end module get_file_list