function date_str_from_julday,jday,wo_time=wo_time
;@***h* MLT_RSS/date_str_from_julday.pro

; NAME
;   date_str_from_julday
;
; PURPOSE
;   Creates a date and time string from a date in IDL julday format
;
; DESCRIPTION
;   Creates a date and time string from a date in IDL julday format
;
; INPUTS:
;   jday   ; date in julday format
;   wo_time  ; flag -- if set, don't write out time part
;   
; RETURN VALUE:
;   string representation of date
;
; AUTHOR:
;   Carl Mears, Remote Sensing Systems
;
; COPYRIGHT:
;   THIS SOFTWARE AND ITS DOCUMENTATION ARE COPYRIGHT 2012 REMOTE SENSING SYSTEMS.  
;   THEY ARE PROVIDED FOR INFORMATIONAL AND ALGORITHM VERIFICATION PURPOSES ONLY 
;   AND MAY NOT BE USED IN WHOLE OR IN PART FOR ANY OTHER PURPOSE WITHOUT WRITTEN
;   PERMISSION FROM REMOTE SENSING SYSTEMS.  THEY ARE FURNISHED "AS IS." THE 
;   AUTHORS, THE UNITED STATES GOVERNMENT, ITS INSTRUMENTALITIES, OFFICERS, EMPLOYEES, 
;   AND AGENTS MAKE NO WARRANTY, EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE 
;   SOFTWARE AND DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
;   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL SUPPORT 
;   TO USERS.;
; HISTORY
;   10/18/2012 Initial Version prepared for NCDC
;
; USAGE
;   print,date_str_from_julday(jday)
;
;@*****
	CALDAT, jday, Month , Day , Year , Hour , Minute , Second

	if keyword_set(wo_time) then begin
		str = string(month,day,year, $
	        format='(i2.2,"/",i2.2,"/",i4.4)')
	endif else begin
		str = string(month,day,year,hour,minute,round(second), $
	        format='(i2.2,"/",i2.2,"/",i4.4," ",i2.2,":",i2.2,":",i2.2)')
	endelse
	return,str

end
