function date_str_from_rd_2000,rd_2000

;@***h* MLT_RSS/date_str_from_rd_2000.pro

; NAME
;   date_str_from_rd_2000
;
; PURPOSE
;   Creates a date and time string from a date in rd_2000 format
;
; DESCRIPTION
;   Creates a date and time string from a date in rd_2000 format
;
; INPUTS:
;   rd_2000  ; date in rd_2000 format
;   
; RETURN VALUE:
;   string representation of date
;
; AUTHOR:
;   Carl Mears, Remote Sensing Systems
;
; COPYRIGHT:
;   THIS SOFTWARE AND ITS DOCUMENTATION ARE COPYRIGHT 2012 REMOTE SENSING SYSTEMS.  
;   THEY ARE PROVIDED FOR INFORMATIONAL AND ALGORITHM VERIFICATION PURPOSES ONLY 
;   AND MAY NOT BE USED IN WHOLE OR IN PART FOR ANY OTHER PURPOSE WITHOUT WRITTEN
;   PERMISSION FROM REMOTE SENSING SYSTEMS.  THEY ARE FURNISHED "AS IS." THE 
;   AUTHORS, THE UNITED STATES GOVERNMENT, ITS INSTRUMENTALITIES, OFFICERS, EMPLOYEES, 
;   AND AGENTS MAKE NO WARRANTY, EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE 
;   SOFTWARE AND DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
;   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL SUPPORT 
;   TO USERS.;
; HISTORY
;   10/18/2012 Initial Version prepared for NCDC
;
; USAGE
;   print,date_str_from_rd_2000(rd_2000)
;
;@*****
    compile_opt idl2
		jan_1_2000 = julday(1,1,2000,0.0,0.0,0.0)
		jday = rd_2000 + jan_1_2000
		return,date_str_from_julday(jday)
end