function current_month_number
;@***h* MLT_RSS/current_month_number.pro

; NAME
;   current_month_number
;
; PURPOSE
;   Returns the month number (number of months since dec 1977) using the system time.
;
; DESCRIPTION
;   Returns the month number (number of months since dec 1977) using the system time.
;
; INPUTS:
;   none
;
; RETURN VALUE:
;   month number (number of months since dec 1977)

; AUTHOR
;   Carl Mears, Remote Sensing Systems
;
; COPYRIGHT
;   THIS SOFTWARE AND ITS DOCUMENTATION ARE COPYRIGHT 2012 REMOTE SENSING SYSTEMS.  
;   THEY ARE PROVIDED FOR INFORMATIONAL AND ALGORITHM VERIFICATION PURPOSES ONLY 
;   AND MAY NOT BE USED IN WHOLE OR IN PART FOR ANY OTHER PURPOSE WITHOUT WRITTEN
;   PERMISSION FROM REMOTE SENSING SYSTEMS.  THEY ARE FURNISHED "AS IS." THE 
;   AUTHORS, THE UNITED STATES GOVERNMENT, ITS INSTRUMENTALITIES, OFFICERS, EMPLOYEES, 
;   AND AGENTS MAKE NO WARRANTY, EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE 
;   SOFTWARE AND DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
;   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL SUPPORT 
;   TO USERS.;
; HISTORY
;   10/18/2012 Initial Version prepared for NCDC
;
; USAGE
;   month_number = current_month_number()
;
;@*****
	Julian = SYSTIME(/JULIAN)
	CALDAT, Julian, Month, Day, Year, hour, Minute, Second
  current_month_number = month-1 + 12*(year-1978)
	return,current_month_number

end




