pro read_monthly_histograms_V3_2,lu,month_num,monthly_hist,error
;@***h* MLT_RSS/read_monthly_histograms_V3_2.pro
;
; NAME
;   rread_monthly_histograms_V3_2.pro
;
; PURPOSE
;   reads a single monthly gridded histogram record
;
; DESCRIPTION
;   reads a single monthly gridded histogram record
;   
; INPUTS
;   lu          logical unit to read from
;   
; OUTPUTS
;   month_num            ; month number for the histogram read
;   monthly_hist         ; monthly hsit with averaged AMSU data
;   error                ; error flag.  0 means everything is OK, -1 Means a read error
;     
; AUTHOR
;   Carl Mears, Remote Sensing Systems
;
; COPYRIGHT
;   THIS SOFTWARE AND ITS DOCUMENTATION ARE COPYRIGHT 2012 REMOTE SENSING SYSTEMS.  
;   THEY ARE PROVIDED FOR INFORMATIONAL AND ALGORITHM VERIFICATION PURPOSES ONLY 
;   AND MAY NOT BE USED IN WHOLE OR IN PART FOR ANY OTHER PURPOSE WITHOUT WRITTEN
;   PERMISSION FROM REMOTE SENSING SYSTEMS.  THEY ARE FURNISHED "AS IS." THE 
;   AUTHORS, THE UNITED STATES GOVERNMENT, ITS INSTRUMENTALITIES, OFFICERS, EMPLOYEES, 
;   AND AGENTS MAKE NO WARRANTY, EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE 
;   SOFTWARE AND DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
;   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL SUPPORT 
;   TO USERS.
;
; HISTORY
;   9/02/2012 Initial Version prepared for NCDC
;
; USAGE
;   read_monthly_histograms_V3_2,lu,month_num,monthly_hist,error
;
;@*****
	month_num = 0L
	monthly_hist = fltarr(7,2,2,144,72)

	on_ioerror,problem
	readu,lu,month_num
	readu,lu,monthly_hist
	error = 0
	return

	problem:
	;print,'Problem reading unit lu'
	error = -1
	return

end

