pro smooth_offsets_tlt,offsets,plt_offsets=plt_offsets

;@***h* MLT_RSS/smooth_offsets_tlt.pro
; NAME
;   smooth_offsets_tlt.pro
;
; PURPOSE
;   smooths AMSU zonal intersatellite offsets in the north/south direction. 
;
; DESCRIPTION
;   smooths AMSU zonal intersatellite offsets in the north/south direction.  A simple, "boxcar" smooth
;   is used of width 5 2.5 degree bins
; INPUTS
;   offsets         (num_lats,num_sats) float32 array of offsets
; OUTPUTS
;   offsets_smooth  (num_lats,num_sats) float32 array of smoothed offsets
;
; AUTHOR
;   Carl Mears, Remote Sensing Systems
;
; COPYRIGHT
;   THIS SOFTWARE AND ITS DOCUMENTATION ARE COPYRIGHT 2012 REMOTE SENSING SYSTEMS.  
;   THEY ARE PROVIDED FOR INFORMATIONAL AND ALGORITHM VERIFICATION PURPOSES ONLY 
;   AND MAY NOT BE USED IN WHOLE OR IN PART FOR ANY OTHER PURPOSE WITHOUT WRITTEN
;   PERMISSION FROM REMOTE SENSING SYSTEMS.  THEY ARE FURNISHED "AS IS." THE 
;   AUTHORS, THE UNITED STATES GOVERNMENT, ITS INSTRUMENTALITIES, OFFICERS, EMPLOYEES, 
;   AND AGENTS MAKE NO WARRANTY, EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE 
;   SOFTWARE AND DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
;   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL SUPPORT 
;   TO USERS.
;
; HISTORY
;   2/29/2012 Initial Version prepared for NCDC
; 
; USAGE
;   smooth_offsets,offsets,offsets_smooth
;
;@*****

  offsets_raw = offsets
	for satnum = 0,8 do begin

		offset_sat = reform(offsets[*,satnum])
		offset_sat2 = offset_sat

		smooth_offset_sat = smooth(offset_sat2,5,/nan)
		offsets[*,satnum] =smooth_offset_sat
	endfor

end
