pro get_AMSU_File_Locations,	AMSU_L1A_Path = AMSU_L1A_Path,		$
								AMSU_L1B_Path = AMSU_L1B_Path,		$
								AMSU_L2A_Path = AMSU_L2A_Path,		$
								MSU_L2A_Path  = MSU_L2A_Path,		$
								AMSU_L2C_Path = AMSU_L2C_Path,		$
								AMSU_L3_Path  = AMSU_L3_Path,		$
								AMSU_web_Path = AMSU_web_Path,		$
								AMSU_Daily_Hist_Path = AMSU_Daily_Hist_Path,		$
								AMSU_GRPT_TS_Path = AMSU_GRPT_TS_Path,				$
								MSU_GRPT_TS_Path = MSU_GRPT_TS_Path,				$
								AMSU_Monthly_Map_Path = AMSU_Monthly_Map_Path,		$
								AMSU_Zonal_Monthly_Path = AMSU_Zonal_Monthly_Path, $
								MSU_STAR_L1C_Path = MSU_STAR_L1C_Path,   $
                Ancillary_Data_Path = Ancillary_Data_Path
                 
;@***h* MLT_RSS/get_AMSU_File_Locations.pro           
; NAME
;  get_AMSU_File_Locations 
;
; PURPOSE
;   returns the location of various types of files used in the MSU/AMSU merging process
;
; DESCRIPTION
;   provides a hard-coded list of file locations.  
;
; AUTHOR
;   Carl Mears, Remote Sensing Systems
;
; COPYRIGHT
;   THIS SOFTWARE AND ITS DOCUMENTATION ARE COPYRIGHT 2012 REMOTE SENSING SYSTEMS.  
;   THEY ARE PROVIDED FOR INFORMATIONAL AND ALGORITHM VERIFICATION PURPOSES ONLY 
;   AND MAY NOT BE USED IN WHOLE OR IN PART FOR ANY OTHER PURPOSE WITHOUT WRITTEN
;   PERMISSION FROM REMOTE SENSING SYSTEMS.  THEY ARE FURNISHED "AS IS." THE 
;   AUTHORS, THE UNITED STATES GOVERNMENT, ITS INSTRUMENTALITIES, OFFICERS, EMPLOYEES, 
;   AND AGENTS MAKE NO WARRANTY, EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE 
;   SOFTWARE AND DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
;   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL SUPPORT 
;   TO USERS.
;
; HISTORY
;   2/21/2012 Initial Version prepared for NCDC
;
; USAGE
;   for example, to retrieve the path to ancillary data files use:
;   get_AMSU_File_Locations(Ancillary_Data_Path = Ancillary_Data_Path)
;   
;@***** MLT_RSS/get_AMSU_File_Locations.pro

  Ancillary_Data_Path     = 'M:\MSU_AMSU_Data\Ancillary_Data\'
	AMSU_L1A_Path           = 'M:\MSU_AMSU_Data\AMSU-A_L1A\'
	AMSU_L1B_Path           = 'M:\MSU_AMSU_Data\AMSU-A_L1B\'
	AMSU_L2A_Path           = 'M:\MSU_AMSU_Data\AMSU-A_L2A\'
	AMSU_L2C_Path           = 'M:\MSU_AMSU_Data\AMSU-A_L2C\'
	AMSU_L3_Path            = 'M:\MSU_AMSU_Data\AMSU-A_L3\'
	AMSU_Daily_Hist_Path 	  = AMSU_L2C_Path+'Daily_Histograms\'
	AMSU_Monthly_Map_Path 	= AMSU_L2C_Path+'Monthly_Maps\'
	AMSU_Zonal_Monthly_Path = AMSU_L2C_Path+'zonal_months\'
  MSU_L2A_Path            = 'M:\MSU_AMSU_Data\MSU_L2A\'
end