pro read_land_fraction_144_72,land_fraction
;
;
;@***h* MLT_RSS/read_land_fraction_144_72.pro
;
; NAME
;   read_land_fraction_144_72.pro
;
; PURPOSE
;   reads a file containing the land fraction on a 144x72 grid
;
; DESCRIPTION
;   Reads a flat binary file called land_fraction_144_72.dat.  This file is
;   real(4) little endian, and written using RSS gridded data conventions.
;
; AUTHOR
;   Carl Mears, Remote Sensing Systems
;
; COPYRIGHT
;   THIS SOFTWARE AND ITS DOCUMENTATION ARE COPYRIGHT 2012 REMOTE SENSING SYSTEMS.  
;   THEY ARE PROVIDED FOR INFORMATIONAL AND ALGORITHM VERIFICATION PURPOSES ONLY 
;   AND MAY NOT BE USED IN WHOLE OR IN PART FOR ANY OTHER PURPOSE WITHOUT WRITTEN
;   PERMISSION FROM REMOTE SENSING SYSTEMS.  THEY ARE FURNISHED "AS IS." THE 
;   AUTHORS, THE UNITED STATES GOVERNMENT, ITS INSTRUMENTALITIES, OFFICERS, EMPLOYEES, 
;   AND AGENTS MAKE NO WARRANTY, EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE 
;   SOFTWARE AND DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
;   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL SUPPORT 
;   TO USERS.
;
; HISTORY
;   2/21/2012 Initial Version prepared for NCDC
;
; USAGE
;   read_land_fraction_144_72,land_fraction
;
;@*****

land_fraction = fltarr(144,72)
get_AMSU_File_Locations,Ancillary_Data_Path = Ancillary_Data_Path
land_fraction_file = Ancillary_Data_Path+'LandFraction\land_fraction_144x72.dat'

close,1
openr,1,land_fraction_file,/binary

readu,1,land_fraction
close,1

return

end
