pro read_topography_144x72,hgt
;
;
;@***h* MLT_RSS/read_topography_144_72.pro
;
; NAME
;   read_topography_144_72.pro
;
; PURPOSE
;   reads a file containing the mean altitude above sea level in each grid box in a 144 x 72 grid
;
; DESCRIPTION
;   Reads a flat binary file called hgt_144x72_map.dat.  This file is
;   float little endian, and written using RSS self-describing map data conventions.
;
; AUTHOR
;   Carl Mears, Remote Sensing Systems
;
; COPYRIGHT
;   THIS SOFTWARE AND ITS DOCUMENTATION ARE CONSIDERED TO BE IN THE PUBLIC DOMAIN AND
;   THUS ARE AVAILABLE FOR UNRESTRICTED PUBLIC USE.  THEY ARE FURNISHED "AS IS." THE 
;   AUTHORS, THE UNITED STATES GOVERNMENT, ITS INSTRUMENTALITIES, OFFICERS, EMPLOYEES, 
;   AND AGENTS MAKE NO WARRANTY, EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE 
;   SOFTWARE AND DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
;   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL SUPPORT 
;   TO USERS.
;
; HISTORY
;   2/29/2012 Initial Version prepared for NCDC
;
; USAGE
;   read_topography_144x72,hgt
;
;@*****
	openr,lun,'C:\Module_Data\topography\hgt_144x72_map.dat',/get_lun,/binary
	min_x     = 0.0
  max_x     = 0.0
  delta_x   = 0.0
  num_x     = 0L
  min_y     = 0.0
  max_y     = 0.0
  delta_y   = 0.0
  num_y     = 0L
  readu,lu, min_x,max_x,delta_x,num_x,  $
    min_y,max_y,delta_y,num_y
  hgt = fltarr(num_x,num_y)
  readu,lu,hgt
	free_lun,lun
	return
end

