function sat_name,n,fill = fill
;
;@***h* MLT_RSS/sat_name.pro
;
; NAME
;   sat_name.pro
;
; PURPOSE
;   Returns the satellite name associated with satellite number n
;
; DESCRIPTION
;   Returns the satellite name associated with satellite number n.  
;   n = 1 is TIROS-N
;   n = 2 is NOAA-06, etc.
;   if the /fill keyword is not set, n = 2 returns 'NOAA-6'
;   if it is set, n = e returns 'NOAA-06'
;
; AUTHOR
;   Carl Mears, Remote Sensing Systems
;
; COPYRIGHT
;   THIS SOFTWARE AND ITS DOCUMENTATION ARE COPYRIGHT 2012 REMOTE SENSING SYSTEMS.  
;   THEY ARE PROVIDED FOR INFORMATIONAL AND ALGORITHM VERIFICATION PURPOSES ONLY 
;   AND MAY NOT BE USED IN WHOLE OR IN PART FOR ANY OTHER PURPOSE WITHOUT WRITTEN
;   PERMISSION FROM REMOTE SENSING SYSTEMS.  THEY ARE FURNISHED "AS IS." THE 
;   AUTHORS, THE UNITED STATES GOVERNMENT, ITS INSTRUMENTALITIES, OFFICERS, EMPLOYEES, 
;   AND AGENTS MAKE NO WARRANTY, EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE 
;   SOFTWARE AND DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
;   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL SUPPORT 
;   TO USERS.
;
; HISTORY
;   2/21/2012 Initial Version prepared for NCDC
;
; USAGE
;   print,sat_name(1,/fill)
;   NOAA-06
;   
;@***** MLT_RSS/sat_name.pro

	 if keyword_set(fill) then begin
     	sat_names =['TIROS-N','NOAA-06','NOAA-07','NOAA-08','NOAA-09','NOAA-10','NOAA-11', 'NOAA-12','NOAA-14','NOAA-15','NOAA-16','NOAA-17','NOAA-18','METOP-A','AQUA','NOAA-19']
     endif else begin
     	sat_names =['TIROS-N','NOAA-6','NOAA-7','NOAA-8','NOAA-9','NOAA-10','NOAA-11', 'NOAA-12','NOAA-14','NOAA-15','NOAA-16','NOAA-17','NOAA-18','METOP-A','AQUA','NOAA-19']
	 endelse
     if ((n lt 1) or (n gt 16)) then return,' '
     return,sat_names[n-1]

 end

